# Domain: KerML Shapes
Date of creation: 

Version number: 

Revision number: 

Approved By: 

Date of approval: 

Issued by: 

Referenced Vocabularies: TODO

**NamespaceURI**: https://www.omg.org/spec/KerML/20230201/shapes#

**NamespacePrefix**: kerml_sh

**Other NamespacePrefixes**: 

* dcterms: http://purl.org/dc/terms/

* kerml_vocab: https://www.omg.org/spec/KerML/20230201/vocab#

## Table of Contents
TODO

## Scope
## Background
## Constraints
Note: In the constraints below, 'definition of vocabulary class' &  'definition of Vocabulary Property' values correspond to the rdfs:comment values in the vocabularies. 

### Metaclass

URI: https://www.omg.org/spec/KerML/20230201/shapes#Metaclass

type: Shape

target class: [kerml_vocab:Metaclass](https://www.omg.org/spec/KerML/20230201/vocab#Metaclass)

definition of vocabulary class : <p>A Metaclass is a Structure used to type MetadataFeatures. It must subclassify, directly or indirectly, the base type <em><code>Metadata</code></em> from the Kernel Library.</p><br>specializesFromLibrary("Metaobjects::Metaobject")

description: <p>A Metaclass is a Structure used to type MetadataFeatures. It must subclassify, directly or indirectly, the base type <em><code>Metadata</code></em> from the Kernel Library.</p><br>specializesFromLibrary("Metaobjects::Metaobject")

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|



### LiteralString

URI: https://www.omg.org/spec/KerML/20230201/shapes#LiteralString

type: Shape

target class: [kerml_vocab:LiteralString](https://www.omg.org/spec/KerML/20230201/vocab#LiteralString)

definition of vocabulary class : <p>A LiteralString is a LiteralExpression that provides a <code><em>String</em></code> value as a result. Its <code>result</code> parameter must have the type <code><em>String</em></code>.</p><br>

description: <p>A LiteralString is a LiteralExpression that provides a <code><em>String</em></code> value as a result. Its <code>result</code> parameter must have the type <code><em>String</em></code>.</p><br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:literalStringValue](https://www.omg.org/spec/KerML/20230201/vocab#literalStringValue)| [1]| String| <p>The String value that is the result of evaluating this Expression.</p><br><br><p>The String value that is the result of evaluating this Expression.</p>| <p>The String value that is the result of evaluating this Expression.</p><br><br><p>The String value that is the result of evaluating this Expression.</p>|



### ResultExpressionMembership

URI: https://www.omg.org/spec/KerML/20230201/shapes#ResultExpressionMembership

type: Shape

target class: [kerml_vocab:ResultExpressionMembership](https://www.omg.org/spec/KerML/20230201/vocab#ResultExpressionMembership)

definition of vocabulary class : <p>A ResultExpressionMembership is a FeatureMembership that indicates that the <code>ownedResultExpression</code> provides the result values for the Function or Expression that owns it. The owning Function or Expression must contain a BindingConnector between the <code>result</code> parameter of the <code>ownedResultExpression</code> and the <code>result</code> parameter of the Function or Expression.</p><br>

description: <p>A ResultExpressionMembership is a FeatureMembership that indicates that the <code>ownedResultExpression</code> provides the result values for the Function or Expression that owns it. The owning Function or Expression must contain a BindingConnector between the <code>result</code> parameter of the <code>ownedResultExpression</code> and the <code>result</code> parameter of the Function or Expression.</p><br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:resultExpressionMembershipOwnedResultExpression](https://www.omg.org/spec/KerML/20230201/vocab#resultExpressionMembershipOwnedResultExpression)| [1]| [kerml_vocab:Expression](https://www.omg.org/spec/KerML/20230201/vocab#Expression)| <p>The Expression that provides the result for the owner of the ResultExpressionMembership.</p>| <p>The Expression that provides the result for the owner of the ResultExpressionMembership.</p>|



### Interaction

URI: https://www.omg.org/spec/KerML/20230201/shapes#Interaction

type: Shape

target class: [kerml_vocab:Interaction](https://www.omg.org/spec/KerML/20230201/vocab#Interaction)

definition of vocabulary class : <p>An Interaction is a Behavior that is also an Association, providing a context for multiple objects that have behaviors that impact one another.</p><br>

description: <p>An Interaction is a Behavior that is also an Association, providing a context for multiple objects that have behaviors that impact one another.</p><br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|



### InvocationExpression

URI: https://www.omg.org/spec/KerML/20230201/shapes#InvocationExpression

type: Shape

target class: [kerml_vocab:InvocationExpression](https://www.omg.org/spec/KerML/20230201/vocab#InvocationExpression)

definition of vocabulary class : <p>An InvocationExpression is an Expression each of whose input <code>parameters</code> are bound to the <code>result</code> of an owned <code>argument</code> Expression. Each input <code>parameter</code> may be bound to the <code>result</code> of at most one <code>argument</code>.</p><br><br>TBD<br>not ownedTyping->exists(oclIsKindOf(Behavior)) and<br>not ownedSubsetting.subsettedFeature.type->exists(oclIsKindOf(Behavior)) implies<br>    ownedFeature.selectByKind(BindingConnector)->exists(<br>        relatedFeature->includes(self) and<br>        relatedFeature->includes(result))<br>            

description: <p>An InvocationExpression is an Expression each of whose input <code>parameters</code> are bound to the <code>result</code> of an owned <code>argument</code> Expression. Each input <code>parameter</code> may be bound to the <code>result</code> of at most one <code>argument</code>.</p><br><br>TBD<br>not ownedTyping->exists(oclIsKindOf(Behavior)) and<br>not ownedSubsetting.subsettedFeature.type->exists(oclIsKindOf(Behavior)) implies<br>    ownedFeature.selectByKind(BindingConnector)->exists(<br>        relatedFeature->includes(self) and<br>        relatedFeature->includes(result))<br>            

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:invocationExpressionArgument](https://www.omg.org/spec/KerML/20230201/vocab#invocationExpressionArgument)| [0..*]| [kerml_vocab:Expression](https://www.omg.org/spec/KerML/20230201/vocab#Expression)| <p>The <code>value</code> <code>Expressions</code> of the <code>FeatureValues</code> of the input <code>parameters</code> of the <code>InvocationExpression</code>.| <p>The <code>value</code> <code>Expressions</code> of the <code>FeatureValues</code> of the input <code>parameters</code> of the <code>InvocationExpression</code>.|



### FeatureReferenceExpression

URI: https://www.omg.org/spec/KerML/20230201/shapes#FeatureReferenceExpression

type: Shape

target class: [kerml_vocab:FeatureReferenceExpression](https://www.omg.org/spec/KerML/20230201/vocab#FeatureReferenceExpression)

definition of vocabulary class : <p>A FeatureReferenceExpression is an Expression whose <code>result</code> is bound a <code>referent</code> Feature. The only <code>members</code> allowed for a FeatureReferenceExpression are the <code>referent</code>, the <code>result</code> and the BindingConnector between them.</p>

description: <p>A FeatureReferenceExpression is an Expression whose <code>result</code> is bound a <code>referent</code> Feature. The only <code>members</code> allowed for a FeatureReferenceExpression are the <code>referent</code>, the <code>result</code> and the BindingConnector between them.</p>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:featureReferenceExpressionReferent](https://www.omg.org/spec/KerML/20230201/vocab#featureReferenceExpressionReferent)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature that is referenced by this FeatureReferenceExpression, derived as its first <code>member</code> Feature.</p>| <p>The Feature that is referenced by this FeatureReferenceExpression, derived as its first <code>member</code> Feature.</p>|



### Class

URI: https://www.omg.org/spec/KerML/20230201/shapes#Class

type: Shape

target class: [kerml_vocab:Class](https://www.omg.org/spec/KerML/20230201/vocab#Class)

definition of vocabulary class : <p>A Class is a Classifier of things (in the universe) that can be distinguished without regard to how they are related to other things (via Features). This means multiple things classified by the same Class can be distinguished, even&nbsp;when they are related&nbsp;other things in exactly the same way.</p><br><br>specializesFromLibrary("Occurrences::Occurrence")<br>ownedGeneralization.general-><br>    forAll(not oclIsKindOf(DataType) and <br>           not oclIsKindOf(Association))

description: <p>A Class is a Classifier of things (in the universe) that can be distinguished without regard to how they are related to other things (via Features). This means multiple things classified by the same Class can be distinguished, even&nbsp;when they are related&nbsp;other things in exactly the same way.</p><br><br>specializesFromLibrary("Occurrences::Occurrence")<br>ownedGeneralization.general-><br>    forAll(not oclIsKindOf(DataType) and <br>           not oclIsKindOf(Association))

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|



### OwningMembership

URI: https://www.omg.org/spec/KerML/20230201/shapes#OwningMembership

type: Shape

target class: [kerml_vocab:OwningMembership](https://www.omg.org/spec/KerML/20230201/vocab#OwningMembership)

definition of vocabulary class : <p>An OwningMembership is a Membership that owns its <code>memberElement</code> as a <code>ownedRelatedElement</code>. The <code>ownedMemberElementM</code> becomes an <code>ownedMember</code> of the <code>membershipOwningNamespace</code>.<br>ownedMemberName = ownedMemberElement.name<br>ownedMemberShortName = ownedMemberElement.shortName

description: <p>An OwningMembership is a Membership that owns its <code>memberElement</code> as a <code>ownedRelatedElement</code>. The <code>ownedMemberElementM</code> becomes an <code>ownedMember</code> of the <code>membershipOwningNamespace</code>.<br>ownedMemberName = ownedMemberElement.name<br>ownedMemberShortName = ownedMemberElement.shortName

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:owningMembershipOwnedMemberElementId](https://www.omg.org/spec/KerML/20230201/vocab#owningMembershipOwnedMemberElementId)| [1]| String| <p>The <code>elementId</code> of the <code>ownedMemberElement</code>.</p>| <p>The <code>elementId</code> of the <code>ownedMemberElement</code>.</p>|
| [kerml_vocab:owningMembershipOwnedMemberShortName](https://www.omg.org/spec/KerML/20230201/vocab#owningMembershipOwnedMemberShortName)| [0..1]| String| <p>The <code>shortName</code> of the <code>ownedMemberElement</code>.</p>| <p>The <code>shortName</code> of the <code>ownedMemberElement</code>.</p>|
| [kerml_vocab:owningMembershipOwnedMemberName](https://www.omg.org/spec/KerML/20230201/vocab#owningMembershipOwnedMemberName)| [0..1]| String| <p>The <code>name</code> of the <code>ownedMemberElement</code>.</p><br>| <p>The <code>name</code> of the <code>ownedMemberElement</code>.</p><br>|
| [kerml_vocab:owningMembershipOwnedMemberElement](https://www.omg.org/spec/KerML/20230201/vocab#owningMembershipOwnedMemberElement)| [1]| [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)| <p>The Element that becomes an <code>ownedMember</code> of the <code>membershipOwningNamespace</code> due to this OwningMembership. Derived as the first <code>ownedRelatedElement</code> of the OwningRelationship.</p><br><br>| <p>The Element that becomes an <code>ownedMember</code> of the <code>membershipOwningNamespace</code> due to this OwningMembership. Derived as the first <code>ownedRelatedElement</code> of the OwningRelationship.</p><br><br>|



### Succession

URI: https://www.omg.org/spec/KerML/20230201/shapes#Succession

type: Shape

target class: [kerml_vocab:Succession](https://www.omg.org/spec/KerML/20230201/vocab#Succession)

definition of vocabulary class : <p>A Succession is a binary&nbsp;Connector that requires its <code>relatedFeatures</code> to happen separately in time. A Succession must be typed by the Association <em>HappensBefore</em> from the Kernel Model Library (or a specialization of it).</p><br><br>specializesFromLibrary("Occurences::happensBeforeLinks")

description: <p>A Succession is a binary&nbsp;Connector that requires its <code>relatedFeatures</code> to happen separately in time. A Succession must be typed by the Association <em>HappensBefore</em> from the Kernel Model Library (or a specialization of it).</p><br><br>specializesFromLibrary("Occurences::happensBeforeLinks")

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:successionTransitionStep](https://www.omg.org/spec/KerML/20230201/vocab#successionTransitionStep)| [0..1]| [kerml_vocab:Step](https://www.omg.org/spec/KerML/20230201/vocab#Step)| <p>A Step that is typed by the Behavior <em>TransitionPerformance</em> (from the Model Library) that has this Succession as its <em><code>transitionLink</code></em>.</p><br>| <p>A Step that is typed by the Behavior <em>TransitionPerformance</em> (from the Model Library) that has this Succession as its <em><code>transitionLink</code></em>.</p><br>|
| [kerml_vocab:successionTriggerStep](https://www.omg.org/spec/KerML/20230201/vocab#successionTriggerStep)| [0..*]| [kerml_vocab:Step](https://www.omg.org/spec/KerML/20230201/vocab#Step)| <p>Steps that map incoming events to the timing of occurrences of the <code>transitionStep</code>. The values of <code>triggerStep</code> subset the list of acceptable events to be received by a Behavior or the object that performs it.</p><br>| <p>Steps that map incoming events to the timing of occurrences of the <code>transitionStep</code>. The values of <code>triggerStep</code> subset the list of acceptable events to be received by a Behavior or the object that performs it.</p><br>|
| [kerml_vocab:successionEffectStep](https://www.omg.org/spec/KerML/20230201/vocab#successionEffectStep)| [0..*]| [kerml_vocab:Step](https://www.omg.org/spec/KerML/20230201/vocab#Step)| <p>Steps that represent occurrences that are side effects of the <code>transitionStep</code> occurring.</p><br>| <p>Steps that represent occurrences that are side effects of the <code>transitionStep</code> occurring.</p><br>|
| [kerml_vocab:successionGuardExpression](https://www.omg.org/spec/KerML/20230201/vocab#successionGuardExpression)| [0..*]| [kerml_vocab:Expression](https://www.omg.org/spec/KerML/20230201/vocab#Expression)| <p>Expressions that must evaluate to true before the <code>transitionStep</code> can occur.</p><br>| <p>Expressions that must evaluate to true before the <code>transitionStep</code> can occur.</p><br>|



### Predicate

URI: https://www.omg.org/spec/KerML/20230201/shapes#Predicate

type: Shape

target class: [kerml_vocab:Predicate](https://www.omg.org/spec/KerML/20230201/vocab#Predicate)

definition of vocabulary class : <p>A Predicate is a Function whose <code>result</code> Parameter has type <em>Boolean</em> and multiplicity 1..1.</p><br><br>specializesFromLibrary("Performances::BooleanEvaluation")

description: <p>A Predicate is a Function whose <code>result</code> Parameter has type <em>Boolean</em> and multiplicity 1..1.</p><br><br>specializesFromLibrary("Performances::BooleanEvaluation")

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|



### LiteralRational

URI: https://www.omg.org/spec/KerML/20230201/shapes#LiteralRational

type: Shape

target class: [kerml_vocab:LiteralRational](https://www.omg.org/spec/KerML/20230201/vocab#LiteralRational)

definition of vocabulary class : <p>A LiteralRational is a LiteralExpression that provides a <code><em>Rational</em></code> value as a result. Its <code>result</code> parameter must have the type <code><em>Rational</em></code>.</p><br>

description: <p>A LiteralRational is a LiteralExpression that provides a <code><em>Rational</em></code> value as a result. Its <code>result</code> parameter must have the type <code><em>Rational</em></code>.</p><br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:literalRationalValue](https://www.omg.org/spec/KerML/20230201/vocab#literalRationalValue)| [1]| Float| <p>The value whose rational approximation is the result of evaluating this Expression.</p><br><br><p>The Real value that is the result of evaluating this Expression.</p>| <p>The value whose rational approximation is the result of evaluating this Expression.</p><br><br><p>The Real value that is the result of evaluating this Expression.</p>|



### CollectExpression

URI: https://www.omg.org/spec/KerML/20230201/shapes#CollectExpression

type: Shape

target class: [kerml_vocab:CollectExpression](https://www.omg.org/spec/KerML/20230201/vocab#CollectExpression)

definition of vocabulary class : <p>A CollectExpression is an OperatorExpression whose operator is <code>"collect"</code>, which resolves to the library Function <em><code>ControlFunctions::collect</code></em>.</p>

description: <p>A CollectExpression is an OperatorExpression whose operator is <code>"collect"</code>, which resolves to the library Function <em><code>ControlFunctions::collect</code></em>.</p>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|



### Behavior

URI: https://www.omg.org/spec/KerML/20230201/shapes#Behavior

type: Shape

target class: [kerml_vocab:Behavior](https://www.omg.org/spec/KerML/20230201/vocab#Behavior)

definition of vocabulary class : <p>A Behavior coordinates occurrences of other Behaviors, as well as&nbsp;changes in objects. Behaviors can be decomposed into Steps and be characterized by <code>parameters</code>.</p><br><br>specializesFromLibrary("Performances::Performance")

description: <p>A Behavior coordinates occurrences of other Behaviors, as well as&nbsp;changes in objects. Behaviors can be decomposed into Steps and be characterized by <code>parameters</code>.</p><br><br>specializesFromLibrary("Performances::Performance")

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:behaviorStep](https://www.omg.org/spec/KerML/20230201/vocab#behaviorStep)| [0..*]| [kerml_vocab:Step](https://www.omg.org/spec/KerML/20230201/vocab#Step)| <p>The Steps that make up this Behavior.</p><br>| <p>The Steps that make up this Behavior.</p><br>|
| [kerml_vocab:behaviorParameter](https://www.omg.org/spec/KerML/20230201/vocab#behaviorParameter)| [0..*]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The parameters of this Behavior, which are all its <code>directedFeatures</code>, whose values are passed into and/or out of a performance of the Behavior.</p><br>| <p>The parameters of this Behavior, which are all its <code>directedFeatures</code>, whose values are passed into and/or out of a performance of the Behavior.</p><br>|



### Structure

URI: https://www.omg.org/spec/KerML/20230201/shapes#Structure

type: Shape

target class: [kerml_vocab:Structure](https://www.omg.org/spec/KerML/20230201/vocab#Structure)

definition of vocabulary class : <p>A Structure is a Class of objects in the modeled universe that are primarily structural in nature. While an Object is not itself behavioral, it may be involved in and acted on by Behaviors, and it may be the performer of some of them.</p><br><br>specializesFromLibrary"Objects::Object")

description: <p>A Structure is a Class of objects in the modeled universe that are primarily structural in nature. While an Object is not itself behavioral, it may be involved in and acted on by Behaviors, and it may be the performer of some of them.</p><br><br>specializesFromLibrary"Objects::Object")

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|



### Connector

URI: https://www.omg.org/spec/KerML/20230201/shapes#Connector

type: Shape

target class: [kerml_vocab:Connector](https://www.omg.org/spec/KerML/20230201/vocab#Connector)

definition of vocabulary class : <p>A Connector is a usage of Associations, with links restricted according to instances of the Type in which they are used (domain of the Connector). Associations restrict what kinds of things might be linked. The Connector further restricts these links to between values of two Features on instances of its domain.</p><br><br>relatedFeature = connectorEnd.ownedReferenceSubsetting.subsettedFeature<br>relatedFeature->forAll(f | <br>    if featuringType->isEmpty() then f.isFeaturedWithin(null)<br>    else featuringType->exists(t | f.isFeaturedWithin(t))<br>    endif)<br>sourceFeature = <br>    if relatedFeature->size() = 2 then relatedFeature->at(1) <br>    else null <br>    endif<br>targetFeature =<br>    if sourceFeature = null then relatedFeature<br>    else relatedFeature->excluding(sourceFeature)<br>    endif<br>connectorEnd = feature->select(isEnd)<br>not isAbstract implies relatedFeature->size() >= 2<br>specializesFromLibrary("Links::links")<br>connectorEnd->size() = 2 implies<br>    specializesFromLibrary('Links::binaryLinks')<br>association->exists(oclIsKindOf(AssociationStructure)) implies<br>    specializesFromLibrary("Objects::linkObjects")<br>connectorEnds->size() = 2 and<br>association->exists(oclIsKindOf(AssocationStructure)) implies<br>    specializesFromLibrary("Objects::binaryLinkObjects")<br>connectorEnds->size() > 2 implies<br>    not specializesFromLibrary("Links::BinaryLink")

description: <p>A Connector is a usage of Associations, with links restricted according to instances of the Type in which they are used (domain of the Connector). Associations restrict what kinds of things might be linked. The Connector further restricts these links to between values of two Features on instances of its domain.</p><br><br>relatedFeature = connectorEnd.ownedReferenceSubsetting.subsettedFeature<br>relatedFeature->forAll(f | <br>    if featuringType->isEmpty() then f.isFeaturedWithin(null)<br>    else featuringType->exists(t | f.isFeaturedWithin(t))<br>    endif)<br>sourceFeature = <br>    if relatedFeature->size() = 2 then relatedFeature->at(1) <br>    else null <br>    endif<br>targetFeature =<br>    if sourceFeature = null then relatedFeature<br>    else relatedFeature->excluding(sourceFeature)<br>    endif<br>connectorEnd = feature->select(isEnd)<br>not isAbstract implies relatedFeature->size() >= 2<br>specializesFromLibrary("Links::links")<br>connectorEnd->size() = 2 implies<br>    specializesFromLibrary('Links::binaryLinks')<br>association->exists(oclIsKindOf(AssociationStructure)) implies<br>    specializesFromLibrary("Objects::linkObjects")<br>connectorEnds->size() = 2 and<br>association->exists(oclIsKindOf(AssocationStructure)) implies<br>    specializesFromLibrary("Objects::binaryLinkObjects")<br>connectorEnds->size() > 2 implies<br>    not specializesFromLibrary("Links::BinaryLink")

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:connectorIsDirected](https://www.omg.org/spec/KerML/20230201/vocab#connectorIsDirected)| [1]| Boolean| <p>For a binary Connector, whether or not the Connector should be considered to have a direction from <code>source</code> to <code>target</code>.</p><br>| <p>For a binary Connector, whether or not the Connector should be considered to have a direction from <code>source</code> to <code>target</code>.</p><br>|
| [kerml_vocab:connectorRelatedFeature](https://www.omg.org/spec/KerML/20230201/vocab#connectorRelatedFeature)| [0..*]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Features that are related by this Connector considered as a Relationship and restrict the links it identifies, derived as the referenced Features of the <code>connectorEnds</code> of the Connector.</p><br>| <p>The Features that are related by this Connector considered as a Relationship and restrict the links it identifies, derived as the referenced Features of the <code>connectorEnds</code> of the Connector.</p><br>|
| [kerml_vocab:connectorAssociation](https://www.omg.org/spec/KerML/20230201/vocab#connectorAssociation)| [0..*]| [kerml_vocab:Association](https://www.omg.org/spec/KerML/20230201/vocab#Association)| <p>The Associations that type the Connector.</p><br>| <p>The Associations that type the Connector.</p><br>|
| [kerml_vocab:connectorConnectorEnd](https://www.omg.org/spec/KerML/20230201/vocab#connectorConnectorEnd)| [0..*]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The <code>endFeatures</code> of a Connector, which redefine the <code>endFeatures<code> of the <code>associations</code> of the Connector. The <code>connectorEnds</code> determine via ReferenceSubsetting Relationships which Features are related by the Connector.</p>| <p>The <code>endFeatures</code> of a Connector, which redefine the <code>endFeatures<code> of the <code>associations</code> of the Connector. The <code>connectorEnds</code> determine via ReferenceSubsetting Relationships which Features are related by the Connector.</p>|
| [kerml_vocab:connectorSourceFeature](https://www.omg.org/spec/KerML/20230201/vocab#connectorSourceFeature)| [0..1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The source <code>relatedFeature</code> for this Connector. It is  derived as the first <code>relatedFeature</code>.</p>| <p>The source <code>relatedFeature</code> for this Connector. It is  derived as the first <code>relatedFeature</code>.</p>|
| [kerml_vocab:connectorTargetFeature](https://www.omg.org/spec/KerML/20230201/vocab#connectorTargetFeature)| [0..*]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The target <code>relatedFeatures</code> for this Connector. This includes all the <code>relatedFeatures</code> other than the <code>sourceFeature</code>.</p>| <p>The target <code>relatedFeatures</code> for this Connector. This includes all the <code>relatedFeatures</code> other than the <code>sourceFeature</code>.</p>|



### Type

URI: https://www.omg.org/spec/KerML/20230201/shapes#Type

type: Shape

target class: [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)

definition of vocabulary class : <p>A Type is a Namespace that is the most general kind of Element supporting the semantics of classification. A Type may be a Classifier or a Feature, defining conditions on what is classified by the Type (see also the description of <code>isSufficient</code>).</p><br><br>ownedSpecialization = ownedRelationship->selectByKind(Specialization)-><br>    select(g | g.special = self)<br>    <br>multiplicity = <br>    let ownedMultiplicities: Sequence(Multiplicity) =<br>        ownedMember->selectByKind(Multiplicity) in<br>    if ownedMultiplicities->notEmpty() then <br>        ownedMultiplicities->first()<br>    else <br>        let inheritedMultiplicities: Sequence(Multiplicity) =<br>            ownedSpecialization.general.multiplicity in<br>        if inheritedMultiplicities->notEmpty() then<br>            inheritedMultiplicities->first()<br>        endif<br>    endif<br>ownedFeatureMembership = ownedRelationship->selectByKind(FeatureMembership)<br>let ownedConjugators: Sequence(Conjugator) = <br>    ownedRelationship->selectByKind(Conjugation) in<br>    ownedConjugator = <br>        if ownedConjugators->isEmpty() then null <br>        else ownedConjugators->at(1) endif<br>output =<br>    if isConjugated then <br>        conjugator.originalType.input<br>    else <br>        feature->select(direction = out or direction = inout)<br>    endif<br>input = <br>    if isConjugated then <br>        conjugator.originalType.output<br>    else <br>        feature->select(direction = _'in' or direction = inout)<br>    endif<br>inheritedMembership = inheritedMemberships(Set{})<br>disjointType = disjoiningTypeDisjoining.disjoiningType<br>specializesFromLibrary("Base::Anything")<br>directedFeature = feature->select(direction <> null)<br>feature = featureMembership.ownedMemberFeature<br>featureMembership = ownedMembership->union(<br>    inheritedMembership->selectByKind(FeatureMembership))<br>ownedFeature = ownedFeatureMembership.ownedMemberFeature<br>intersectingType->excludes(self)<br>unioningType->excludes(self)<br>differencingType->excludes(self)<br>differencingType = ownedDifferencing.differencingType<br>unioningType = ownedUnioning.unioningType<br>intersectingType = ownedIntersecting.intersectingType<br>ownedRelationship->selectByKind(Conjugator)->size() <= 1<br>ownedMember->selectByKind(Multiplicity)->size() <= 1<br>endFeature = feature->select(isEnd)<br>not ownedMember->exists(oclIsType(Multiplicity)) implies<br>    ownedSpecialization.general.multiplicity->size() <= 1

description: <p>A Type is a Namespace that is the most general kind of Element supporting the semantics of classification. A Type may be a Classifier or a Feature, defining conditions on what is classified by the Type (see also the description of <code>isSufficient</code>).</p><br><br>ownedSpecialization = ownedRelationship->selectByKind(Specialization)-><br>    select(g | g.special = self)<br>    <br>multiplicity = <br>    let ownedMultiplicities: Sequence(Multiplicity) =<br>        ownedMember->selectByKind(Multiplicity) in<br>    if ownedMultiplicities->notEmpty() then <br>        ownedMultiplicities->first()<br>    else <br>        let inheritedMultiplicities: Sequence(Multiplicity) =<br>            ownedSpecialization.general.multiplicity in<br>        if inheritedMultiplicities->notEmpty() then<br>            inheritedMultiplicities->first()<br>        endif<br>    endif<br>ownedFeatureMembership = ownedRelationship->selectByKind(FeatureMembership)<br>let ownedConjugators: Sequence(Conjugator) = <br>    ownedRelationship->selectByKind(Conjugation) in<br>    ownedConjugator = <br>        if ownedConjugators->isEmpty() then null <br>        else ownedConjugators->at(1) endif<br>output =<br>    if isConjugated then <br>        conjugator.originalType.input<br>    else <br>        feature->select(direction = out or direction = inout)<br>    endif<br>input = <br>    if isConjugated then <br>        conjugator.originalType.output<br>    else <br>        feature->select(direction = _'in' or direction = inout)<br>    endif<br>inheritedMembership = inheritedMemberships(Set{})<br>disjointType = disjoiningTypeDisjoining.disjoiningType<br>specializesFromLibrary("Base::Anything")<br>directedFeature = feature->select(direction <> null)<br>feature = featureMembership.ownedMemberFeature<br>featureMembership = ownedMembership->union(<br>    inheritedMembership->selectByKind(FeatureMembership))<br>ownedFeature = ownedFeatureMembership.ownedMemberFeature<br>intersectingType->excludes(self)<br>unioningType->excludes(self)<br>differencingType->excludes(self)<br>differencingType = ownedDifferencing.differencingType<br>unioningType = ownedUnioning.unioningType<br>intersectingType = ownedIntersecting.intersectingType<br>ownedRelationship->selectByKind(Conjugator)->size() <= 1<br>ownedMember->selectByKind(Multiplicity)->size() <= 1<br>endFeature = feature->select(isEnd)<br>not ownedMember->exists(oclIsType(Multiplicity)) implies<br>    ownedSpecialization.general.multiplicity->size() <= 1

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:typeIsAbstract](https://www.omg.org/spec/KerML/20230201/vocab#typeIsAbstract)| [1]| Boolean| <p>Indicates whether instances of this Type must also be instances of at least one of its specialized Types.</p><br>| <p>Indicates whether instances of this Type must also be instances of at least one of its specialized Types.</p><br>|
| [kerml_vocab:typeIsSufficient](https://www.omg.org/spec/KerML/20230201/vocab#typeIsSufficient)| [1]| Boolean| <p>Whether all things that meet the classification conditions of this Type must be classified by the Type.</p><br><br><p>(A Type&nbsp;gives conditions that must be met by whatever it classifies, but when <code>isSufficient</code> is false, things may meet those conditions but still not be classified by the Type. For example, a Type <code><em>Car</em></code> that is not sufficient could require everything it classifies to have four wheels, but not all four wheeled things would need to be cars. However, if the type <code><em>Car</em></code> were sufficient, it would classify all four-wheeled things.)</p><br>| <p>Whether all things that meet the classification conditions of this Type must be classified by the Type.</p><br><br><p>(A Type&nbsp;gives conditions that must be met by whatever it classifies, but when <code>isSufficient</code> is false, things may meet those conditions but still not be classified by the Type. For example, a Type <code><em>Car</em></code> that is not sufficient could require everything it classifies to have four wheels, but not all four wheeled things would need to be cars. However, if the type <code><em>Car</em></code> were sufficient, it would classify all four-wheeled things.)</p><br>|
| [kerml_vocab:typeIsConjugated](https://www.omg.org/spec/KerML/20230201/vocab#typeIsConjugated)| [1]| Boolean| <p>Indicates whether this Type has an <code>ownedConjugator</code>. (See Conjugation.)</p><br>| <p>Indicates whether this Type has an <code>ownedConjugator</code>. (See Conjugation.)</p><br>|
| [kerml_vocab:typeOwnedSpecialization](https://www.omg.org/spec/KerML/20230201/vocab#typeOwnedSpecialization)| [0..*]| [kerml_vocab:Specialization](https://www.omg.org/spec/KerML/20230201/vocab#Specialization)| <p>The <code>ownedRelationships</code> of this Type that are Specializations, for which the Type is the <code>specific</code> Type.</p><br>| <p>The <code>ownedRelationships</code> of this Type that are Specializations, for which the Type is the <code>specific</code> Type.</p><br>|
| [kerml_vocab:typeOwnedFeatureMembership](https://www.omg.org/spec/KerML/20230201/vocab#typeOwnedFeatureMembership)| [0..*]| [kerml_vocab:FeatureMembership](https://www.omg.org/spec/KerML/20230201/vocab#FeatureMembership)| <p>The <code>ownedMemberships</code> of this Type that are FeatureMemberships, for which the Type is the <code>owningType</code>. Each such FeatureMembership identifies an <code>ownedFeature</code> of the Type.</p><br>| <p>The <code>ownedMemberships</code> of this Type that are FeatureMemberships, for which the Type is the <code>owningType</code>. Each such FeatureMembership identifies an <code>ownedFeature</code> of the Type.</p><br>|
| [kerml_vocab:typeOwnedFeature](https://www.omg.org/spec/KerML/20230201/vocab#typeOwnedFeature)| [0..*]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The <code>ownedMemberFeatures</code> of the <code>ownedFeatureMemberships</code> of this Type.</code><br>| <p>The <code>ownedMemberFeatures</code> of the <code>ownedFeatureMemberships</code> of this Type.</code><br>|
| [kerml_vocab:typeOwnedEndFeature](https://www.omg.org/spec/KerML/20230201/vocab#typeOwnedEndFeature)| [0..*]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>All <code>endFeatures</code> of this Type that are <code>ownedFeatures</code>.</p><br>| <p>All <code>endFeatures</code> of this Type that are <code>ownedFeatures</code>.</p><br>|
| [kerml_vocab:typeFeature](https://www.omg.org/spec/KerML/20230201/vocab#typeFeature)| [0..*]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The <code>ownedMemberFeatures</code> of the <code>featureMemberships</code> of this Type.</p><br>| <p>The <code>ownedMemberFeatures</code> of the <code>featureMemberships</code> of this Type.</p><br>|
| [kerml_vocab:typeInput](https://www.omg.org/spec/KerML/20230201/vocab#typeInput)| [0..*]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>All <code>features</code> related to this Type by FeatureMemberships that have <code>direction</code> <code>in<code> or <code>inout<code>.</p><br>| <p>All <code>features</code> related to this Type by FeatureMemberships that have <code>direction</code> <code>in<code> or <code>inout<code>.</p><br>|
| [kerml_vocab:typeOutput](https://www.omg.org/spec/KerML/20230201/vocab#typeOutput)| [0..*]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>All <code>features</code> related to this Type by FeatureMemberships that have <code>direction</code> <code>out<code> or <code>inout<code>.</p><br>| <p>All <code>features</code> related to this Type by FeatureMemberships that have <code>direction</code> <code>out<code> or <code>inout<code>.</p><br>|
| [kerml_vocab:typeInheritedMembership](https://www.omg.org/spec/KerML/20230201/vocab#typeInheritedMembership)| [0..*]| [kerml_vocab:Membership](https://www.omg.org/spec/KerML/20230201/vocab#Membership)| <p>All Memberships inherited by this Type via Generalization or Conjugation. These are included in the derived union for the <code>memberships</code> of the Type.</p>| <p>All Memberships inherited by this Type via Generalization or Conjugation. These are included in the derived union for the <code>memberships</code> of the Type.</p>|
| [kerml_vocab:typeEndFeature](https://www.omg.org/spec/KerML/20230201/vocab#typeEndFeature)| [0..*]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>All <code>features</code> of this <code>Type</code> with <code>isEnd = true</code>.</p>| <p>All <code>features</code> of this <code>Type</code> with <code>isEnd = true</code>.</p>|
| [kerml_vocab:typeOwnedConjugator](https://www.omg.org/spec/KerML/20230201/vocab#typeOwnedConjugator)| [0..1]| [kerml_vocab:Conjugation](https://www.omg.org/spec/KerML/20230201/vocab#Conjugation)| <p>A Conjugation owned by this Type for which the Type is the <code>originalType</code>.</p><br>| <p>A Conjugation owned by this Type for which the Type is the <code>originalType</code>.</p><br>|
| [kerml_vocab:typeInheritedFeature](https://www.omg.org/spec/KerML/20230201/vocab#typeInheritedFeature)| [0..*]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>All the <code>memberFeatures</code> of the <code>inheritedMemberships</code> of this Type.</p><br>| <p>All the <code>memberFeatures</code> of the <code>inheritedMemberships</code> of this Type.</p><br>|
| [kerml_vocab:typeMultiplicity](https://www.omg.org/spec/KerML/20230201/vocab#typeMultiplicity)| [0..1]| [kerml_vocab:Multiplicity](https://www.omg.org/spec/KerML/20230201/vocab#Multiplicity)| <p>The one <code>member</code> (at most) of this Type that is a Multiplicity, which constrains the cardinality of the Type. A <code>multiplicity</code> can be owned or inherited. If it is owned, the <code>multiplicity</code> must redefine the <code>multiplicity</code> (if it has one) of any <code>general</code> Type of an <code>ownedSpecialization</code> of this Type.</p>| <p>The one <code>member</code> (at most) of this Type that is a Multiplicity, which constrains the cardinality of the Type. A <code>multiplicity</code> can be owned or inherited. If it is owned, the <code>multiplicity</code> must redefine the <code>multiplicity</code> (if it has one) of any <code>general</code> Type of an <code>ownedSpecialization</code> of this Type.</p>|
| [kerml_vocab:typeUnioningType](https://www.omg.org/spec/KerML/20230201/vocab#typeUnioningType)| [0..*]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>The interpretations of a Type with code>unioningTypes</code> are asserted to be the same as those of all the <code>unioningTypes</code> together, which are the Types  derived from the <code>unioningType</code> of the <code>ownedUnionings</code> of this Type.  For example, a Classifier for people might be the union of Classifiers for all the sexes. Similarly, a feature for people's children might be the union of features dividing them in the same ways as people in general.</p>| <p>The interpretations of a Type with code>unioningTypes</code> are asserted to be the same as those of all the <code>unioningTypes</code> together, which are the Types  derived from the <code>unioningType</code> of the <code>ownedUnionings</code> of this Type.  For example, a Classifier for people might be the union of Classifiers for all the sexes. Similarly, a feature for people's children might be the union of features dividing them in the same ways as people in general.</p>|
| [kerml_vocab:typeOwnedIntersecting](https://www.omg.org/spec/KerML/20230201/vocab#typeOwnedIntersecting)| [0..*]| [kerml_vocab:Intersecting](https://www.omg.org/spec/KerML/20230201/vocab#Intersecting)| <p>The <code>ownedRelationships</code> of this Type that are Intersectings, have the Type as their <code>typeIntersected</code>.</p>| <p>The <code>ownedRelationships</code> of this Type that are Intersectings, have the Type as their <code>typeIntersected</code>.</p>|
| [kerml_vocab:typeIntersectingType](https://www.omg.org/spec/KerML/20230201/vocab#typeIntersectingType)| [0..*]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>The interpretations of a Type with code>intersectingTypes</code> are asserted to be those in common among the <code>intersectingTypes</code>, which are the Types derived from the <code>intersectingType</code> of the <code>ownedIntersectings</code> of this Type.  For example, a Classifier might be an intersection of Classifiers for people of a particular sex and of a particular nationality.  Similarly, a feature for people's children of a particular sex might be the intersection of a feature for their children and a Classifier for people of that sex (because the interpretations of the children feature that identify those of that sex are also interpretations of the Classifier for that sex).<p>| <p>The interpretations of a Type with code>intersectingTypes</code> are asserted to be those in common among the <code>intersectingTypes</code>, which are the Types derived from the <code>intersectingType</code> of the <code>ownedIntersectings</code> of this Type.  For example, a Classifier might be an intersection of Classifiers for people of a particular sex and of a particular nationality.  Similarly, a feature for people's children of a particular sex might be the intersection of a feature for their children and a Classifier for people of that sex (because the interpretations of the children feature that identify those of that sex are also interpretations of the Classifier for that sex).<p>|
| [kerml_vocab:typeOwnedUnioning](https://www.omg.org/spec/KerML/20230201/vocab#typeOwnedUnioning)| [0..*]| [kerml_vocab:Unioning](https://www.omg.org/spec/KerML/20230201/vocab#Unioning)| <p>The <code>ownedRelationships</code> of this Type that are Unionings, having the Type as their <code>typeUnioned</code>.</p>| <p>The <code>ownedRelationships</code> of this Type that are Unionings, having the Type as their <code>typeUnioned</code>.</p>|
| [kerml_vocab:typeOwnedDisjoining](https://www.omg.org/spec/KerML/20230201/vocab#typeOwnedDisjoining)| [0..*]| [kerml_vocab:Disjoining](https://www.omg.org/spec/KerML/20230201/vocab#Disjoining)| <p>The <code>ownedRelationships</code> of this Type that are Disjoinings, for which the Type is the <code>typeDisjoined</code> Type.</p>| <p>The <code>ownedRelationships</code> of this Type that are Disjoinings, for which the Type is the <code>typeDisjoined</code> Type.</p>|
| [kerml_vocab:typeFeatureMembership](https://www.omg.org/spec/KerML/20230201/vocab#typeFeatureMembership)| [0..*]| [kerml_vocab:FeatureMembership](https://www.omg.org/spec/KerML/20230201/vocab#FeatureMembership)| <p>The FeatureMemberships for <code>features</code> of this Type, which include all <code>ownedFeatureMemberships</code> and those <code>inheritedMemberships</code> that are FeatureMemberships (but does <em>not</em> include any <code>importedMemberships</code>).</p>| <p>The FeatureMemberships for <code>features</code> of this Type, which include all <code>ownedFeatureMemberships</code> and those <code>inheritedMemberships</code> that are FeatureMemberships (but does <em>not</em> include any <code>importedMemberships</code>).</p>|
| [kerml_vocab:typeDifferencingType](https://www.omg.org/spec/KerML/20230201/vocab#typeDifferencingType)| [0..*]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>The interpretations of a Type with <code>differencingTypes</code> are asserted to be those of the first of those Types, but not including those of the remaining types. For example, a Classifier might be the difference of a Classifier for people and another for people of a particular nationality, leaving people who are not of that nationality. Similarly, a feature of people might be the difference between a feature for their children and a Classifier for people of a particular sex, identifying their children not of that sex (because the interpretations of the children feature that identify those of that sex are also interpretations of the Classifier for that sex).<p>| <p>The interpretations of a Type with <code>differencingTypes</code> are asserted to be those of the first of those Types, but not including those of the remaining types. For example, a Classifier might be the difference of a Classifier for people and another for people of a particular nationality, leaving people who are not of that nationality. Similarly, a feature of people might be the difference between a feature for their children and a Classifier for people of a particular sex, identifying their children not of that sex (because the interpretations of the children feature that identify those of that sex are also interpretations of the Classifier for that sex).<p>|
| [kerml_vocab:typeOwnedDifferencing](https://www.omg.org/spec/KerML/20230201/vocab#typeOwnedDifferencing)| [0..*]| [kerml_vocab:Differencing](https://www.omg.org/spec/KerML/20230201/vocab#Differencing)| <p>The <code>ownedRelationships</code> of this Type that are Differencings, having this Type as their <code>typeDifferenced</code>.</p>| <p>The <code>ownedRelationships</code> of this Type that are Differencings, having this Type as their <code>typeDifferenced</code>.</p>|
| [kerml_vocab:typeDirectedFeature](https://www.omg.org/spec/KerML/20230201/vocab#typeDirectedFeature)| [0..*]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The <code>features</code> of this Type that have a non-null <code>direction</code>.</p>| <p>The <code>features</code> of this Type that have a non-null <code>direction</code>.</p>|



### Association

URI: https://www.omg.org/spec/KerML/20230201/shapes#Association

type: Shape

target class: [kerml_vocab:Association](https://www.omg.org/spec/KerML/20230201/vocab#Association)

definition of vocabulary class : <p>An Association is a Relationship and a Classifier to enable classification of links between things (in the universe). The co-domains (<code>types</code>) of the <code>associationEnd</code> Features are the <code>relatedTypes</code>, as co-domain and participants (linked things) of an Association identify each other.</p><br><br>relatedTypes = associationEnd.type<br>specializesFromLibrary("Links::Link")<br>oclIsKindOf(Structure) = oclIsKindOf(AssociationStructure)<br>ownedEndFeature->size() = 2 implies<br>    specializesFromLibrary("Links::BinaryLink)<br>not isAbstract implies relatedType->size() >= 2<br>associationEnds->size() > 2 implies<br>    not specializesFromLibrary("Links::BinaryLink")

description: <p>An Association is a Relationship and a Classifier to enable classification of links between things (in the universe). The co-domains (<code>types</code>) of the <code>associationEnd</code> Features are the <code>relatedTypes</code>, as co-domain and participants (linked things) of an Association identify each other.</p><br><br>relatedTypes = associationEnd.type<br>specializesFromLibrary("Links::Link")<br>oclIsKindOf(Structure) = oclIsKindOf(AssociationStructure)<br>ownedEndFeature->size() = 2 implies<br>    specializesFromLibrary("Links::BinaryLink)<br>not isAbstract implies relatedType->size() >= 2<br>associationEnds->size() > 2 implies<br>    not specializesFromLibrary("Links::BinaryLink")

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:associationRelatedType](https://www.omg.org/spec/KerML/20230201/vocab#associationRelatedType)| [0..*]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>The <code>types</code> of the <code>associationEnds</code> of the Association, which are the <code>relatedElements</code> of the Association considered as a Relationship.</p><br>| <p>The <code>types</code> of the <code>associationEnds</code> of the Association, which are the <code>relatedElements</code> of the Association considered as a Relationship.</p><br>|
| [kerml_vocab:associationSourceType](https://www.omg.org/spec/KerML/20230201/vocab#associationSourceType)| [0..1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>The source <code>relatedType</code> for this Association. It is the first <code>relatedType</code> of the Association.</p><br>| <p>The source <code>relatedType</code> for this Association. It is the first <code>relatedType</code> of the Association.</p><br>|
| [kerml_vocab:associationTargetType](https://www.omg.org/spec/KerML/20230201/vocab#associationTargetType)| [0..*]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>The target <code>relatedTypes</code> for this Association. This includes all the <code>relatedTypes</code> other than the <code>sourceType</code>.</p> <br>| <p>The target <code>relatedTypes</code> for this Association. This includes all the <code>relatedTypes</code> other than the <code>sourceType</code>.</p> <br>|
| [kerml_vocab:associationAssociationEnd](https://www.omg.org/spec/KerML/20230201/vocab#associationAssociationEnd)| [0..*]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The <code>features</code> of the Association that identify the things that can be related by it. A concrete Association must have at least two <code>associationEnds</code>. When it has exactly two, the Association is called a <em>binary</em> Association.</p> <br><br><p>The ends of the Association determine which elements are eligible to be related by instances of the Association.</p><br>| <p>The <code>features</code> of the Association that identify the things that can be related by it. A concrete Association must have at least two <code>associationEnds</code>. When it has exactly two, the Association is called a <em>binary</em> Association.</p> <br><br><p>The ends of the Association determine which elements are eligible to be related by instances of the Association.</p><br>|



### MultiplicityRange

URI: https://www.omg.org/spec/KerML/20230201/shapes#MultiplicityRange

type: Shape

target class: [kerml_vocab:MultiplicityRange](https://www.omg.org/spec/KerML/20230201/vocab#MultiplicityRange)

definition of vocabulary class : <p>A MultiplicityRange is a Multiplicity whose value is defined to be the (inclusive) range of natural numbers given by the result of a <code>lowerBound</code> Expression and the result of an <code>upperBound</code> Expression. The result of the <code>lowerBound</code> Expression shall be of type <em>Natural</em>, while the result of the <code>upperBound</code> Expression shall be of type <em>UnlimitedNatural</em>. If the result of the <code>upperBound</code> Expression is the unbounded value <code>*</code>, then the specified range includes all natural numbers greater than or equal to the <code>lowerBound</code> value.</p><br><br>bound->forAll(b | b.featuringType = self.featuringType)

description: <p>A MultiplicityRange is a Multiplicity whose value is defined to be the (inclusive) range of natural numbers given by the result of a <code>lowerBound</code> Expression and the result of an <code>upperBound</code> Expression. The result of the <code>lowerBound</code> Expression shall be of type <em>Natural</em>, while the result of the <code>upperBound</code> Expression shall be of type <em>UnlimitedNatural</em>. If the result of the <code>upperBound</code> Expression is the unbounded value <code>*</code>, then the specified range includes all natural numbers greater than or equal to the <code>lowerBound</code> value.</p><br><br>bound->forAll(b | b.featuringType = self.featuringType)

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:multiplicityRangeLowerBound](https://www.omg.org/spec/KerML/20230201/vocab#multiplicityRangeLowerBound)| [0..1]| [kerml_vocab:Expression](https://www.omg.org/spec/KerML/20230201/vocab#Expression)| <p>The Expression whose result provides the lower bound of MultiplicityRange. If no <code>lowerBound</code> Expression is given, then the lower bound shall have the same value as the upper bound, unless the upper bound is unbounded (<code>*</code>), in which case the lower bound shall be 0.</p><br>| <p>The Expression whose result provides the lower bound of MultiplicityRange. If no <code>lowerBound</code> Expression is given, then the lower bound shall have the same value as the upper bound, unless the upper bound is unbounded (<code>*</code>), in which case the lower bound shall be 0.</p><br>|
| [kerml_vocab:multiplicityRangeUpperBound](https://www.omg.org/spec/KerML/20230201/vocab#multiplicityRangeUpperBound)| [1]| [kerml_vocab:Expression](https://www.omg.org/spec/KerML/20230201/vocab#Expression)| The Expression whose result is the upper bound of the MultiplicityRange.| The Expression whose result is the upper bound of the MultiplicityRange.|
| [kerml_vocab:multiplicityRangeBound](https://www.omg.org/spec/KerML/20230201/vocab#multiplicityRangeBound)| [1..*]| [kerml_vocab:Expression](https://www.omg.org/spec/KerML/20230201/vocab#Expression)| <p>The bound Expressions of the MultiplicityRange. These shall be the only <code>ownedMembers</code> of the MultiplicityRange.</p>| <p>The bound Expressions of the MultiplicityRange. These shall be the only <code>ownedMembers</code> of the MultiplicityRange.</p>|



### Multiplicity

URI: https://www.omg.org/spec/KerML/20230201/shapes#Multiplicity

type: Shape

target class: [kerml_vocab:Multiplicity](https://www.omg.org/spec/KerML/20230201/vocab#Multiplicity)

definition of vocabulary class : <p>A Multiplicity is a Feature whose co-domain is a set of natural numbers that includes the number&nbsp;of sequences determined below, based on the kind of&nbsp;typeWithMultiplicity:</p><br><br><ul><br>	<li>Classifiers: minimal sequences (the single length sequences of the Classifier).</li><br>	<li>Features: sequences with the same feature-pair head.&nbsp; In the case of Features with Classifiers as domain and co-domain, these sequences are pairs, with the first element in&nbsp;a single-length sequence of the domain Classifier (head of the pair), and the number of pairs with the same first element being among the Multiplicity co-domain numbers.</li><br></ul><br><br><p>Multiplicity co-domains (in models) can be specified by Expression that might vary in their results. If the <code>typeWithMultiplicity</code> is a Classifier, the domain of the Multiplicity shall be <em>Anything</em>.  If the <code>typeWithMultiplicity</code> is a Feature,  the Multiplicity shall have the same domain as the <code>typeWithMultiplicity</code>.</p><br><br>if typeWithMultiplicity.oclIsKindOf(Feature) then<br>    featuringType = <br>        typeWithMultiplicity.oclAsType(Feature).featuringType<br>else<br>    featuringType = Sequence{resolveGlobal("Base::Anything"))}<br>endif<br>specializesFromLibrary("Base::naturals")<br>owningNamespace.oclIsKindOf(Type) implies<br>    owningNamespace.oclAsType(Type).ownedSpecialization.general.multiplicity-><br>        forAll(m | redefines(m))<br>

description: <p>A Multiplicity is a Feature whose co-domain is a set of natural numbers that includes the number&nbsp;of sequences determined below, based on the kind of&nbsp;typeWithMultiplicity:</p><br><br><ul><br>	<li>Classifiers: minimal sequences (the single length sequences of the Classifier).</li><br>	<li>Features: sequences with the same feature-pair head.&nbsp; In the case of Features with Classifiers as domain and co-domain, these sequences are pairs, with the first element in&nbsp;a single-length sequence of the domain Classifier (head of the pair), and the number of pairs with the same first element being among the Multiplicity co-domain numbers.</li><br></ul><br><br><p>Multiplicity co-domains (in models) can be specified by Expression that might vary in their results. If the <code>typeWithMultiplicity</code> is a Classifier, the domain of the Multiplicity shall be <em>Anything</em>.  If the <code>typeWithMultiplicity</code> is a Feature,  the Multiplicity shall have the same domain as the <code>typeWithMultiplicity</code>.</p><br><br>if typeWithMultiplicity.oclIsKindOf(Feature) then<br>    featuringType = <br>        typeWithMultiplicity.oclAsType(Feature).featuringType<br>else<br>    featuringType = Sequence{resolveGlobal("Base::Anything"))}<br>endif<br>specializesFromLibrary("Base::naturals")<br>owningNamespace.oclIsKindOf(Type) implies<br>    owningNamespace.oclAsType(Type).ownedSpecialization.general.multiplicity-><br>        forAll(m | redefines(m))<br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|



### Expression

URI: https://www.omg.org/spec/KerML/20230201/shapes#Expression

type: Shape

target class: [kerml_vocab:Expression](https://www.omg.org/spec/KerML/20230201/vocab#Expression)

definition of vocabulary class : <p>An Expression is a Step that is typed by a Function. An Expression that also has a Function as its <code>featuringType</code> is a computational step within that Function. An Expression always has a single <code>result</code> parameter, which redefines the <code>result</code> parameter of its defining <code>function</code>. This allows Expressions to be interconnected in tree structures, in which inputs to each Expression in the tree are determined as the results of other Expressions in the tree.</p><br><br>isModelLevelEvaluable = modelLevelEvaluable(Set(Element){})<br>specializesFromLibrary("Performances::evaluations")<br>ownedMembership.selectByKind(ResultExpressionMembership)-><br>    forAll(mem | ownedFeature.selectByKind(BindingConnector)-><br>        exists(binding |<br>            binding.relatedFeature->includes(result) and<br>            binding.relatedFeature->includes(mem.ownedResultExpression.result)))<br>owningMembership <> null and <br>owningMembership.oclIsKindOf(FeatureValue) implies<br>    let featureWithValue : Feature = <br>        owningMembership.oclAsType(FeatureValue).featureWithValue in<br>    featuringType = featureWithValue.featuringType

description: <p>An Expression is a Step that is typed by a Function. An Expression that also has a Function as its <code>featuringType</code> is a computational step within that Function. An Expression always has a single <code>result</code> parameter, which redefines the <code>result</code> parameter of its defining <code>function</code>. This allows Expressions to be interconnected in tree structures, in which inputs to each Expression in the tree are determined as the results of other Expressions in the tree.</p><br><br>isModelLevelEvaluable = modelLevelEvaluable(Set(Element){})<br>specializesFromLibrary("Performances::evaluations")<br>ownedMembership.selectByKind(ResultExpressionMembership)-><br>    forAll(mem | ownedFeature.selectByKind(BindingConnector)-><br>        exists(binding |<br>            binding.relatedFeature->includes(result) and<br>            binding.relatedFeature->includes(mem.ownedResultExpression.result)))<br>owningMembership <> null and <br>owningMembership.oclIsKindOf(FeatureValue) implies<br>    let featureWithValue : Feature = <br>        owningMembership.oclAsType(FeatureValue).featureWithValue in<br>    featuringType = featureWithValue.featuringType

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:expressionIsModelLevelEvaluable](https://www.omg.org/spec/KerML/20230201/vocab#expressionIsModelLevelEvaluable)| [1]| Boolean| <p>Whether this Expression meets the constraints necessary to be evaluated at <em>model level</em>, that is, using metadata within the model.</p>| <p>Whether this Expression meets the constraints necessary to be evaluated at <em>model level</em>, that is, using metadata within the model.</p>|
| [kerml_vocab:expressionFunction](https://www.omg.org/spec/KerML/20230201/vocab#expressionFunction)| [0..1]| [kerml_vocab:Function](https://www.omg.org/spec/KerML/20230201/vocab#Function)| <p>The Function that types this Expression.</p><br><br><p>This is the Function that types the Expression.</p><br>| <p>The Function that types this Expression.</p><br><br><p>This is the Function that types the Expression.</p><br>|
| [kerml_vocab:expressionResult](https://www.omg.org/spec/KerML/20230201/vocab#expressionResult)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p><p>The <code>result</code> parameter of the Expression, derived as the single <code>parameter</code> of the Expression with direction <code>out</code>. The result of an Expression must either be inherited from its <code>function</code> or (directly or indirectly) redefine the <code>result</code> parameter of its <code>function</code>.</p><br>| <p><p>The <code>result</code> parameter of the Expression, derived as the single <code>parameter</code> of the Expression with direction <code>out</code>. The result of an Expression must either be inherited from its <code>function</code> or (directly or indirectly) redefine the <code>result</code> parameter of its <code>function</code>.</p><br>|



### BindingConnector

URI: https://www.omg.org/spec/KerML/20230201/shapes#BindingConnector

type: Shape

target class: [kerml_vocab:BindingConnector](https://www.omg.org/spec/KerML/20230201/vocab#BindingConnector)

definition of vocabulary class : <p>A Binding Connector is a binary Connector that requires its <code>relatedFeatures</code> to identify the same things (have the same values). <br><br><p> A BindingConnector must be directly or indirectly typed by the <em><code>SelfLink</code></em> Association from the <em><code>Links</code</em> library model. Both end multiplicities must be 1..1 when the <code>relatedFeatures</code> have unique values.</p><br><br>specializesFromLibrary("Links::selfLinks")

description: <p>A Binding Connector is a binary Connector that requires its <code>relatedFeatures</code> to identify the same things (have the same values). <br><br><p> A BindingConnector must be directly or indirectly typed by the <em><code>SelfLink</code></em> Association from the <em><code>Links</code</em> library model. Both end multiplicities must be 1..1 when the <code>relatedFeatures</code> have unique values.</p><br><br>specializesFromLibrary("Links::selfLinks")

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|



### Package

URI: https://www.omg.org/spec/KerML/20230201/shapes#Package

type: Shape

target class: [kerml_vocab:Package](https://www.omg.org/spec/KerML/20230201/vocab#Package)

definition of vocabulary class : <p>A Package is a Namespace used to group Elements, without any instance-level semantics. It may have one or more model-level evaluable <code>filterCondition</code> Expressions used to filter its <code>importedMemberships</code>. Any imported <code>member</code> must meet all of the <code>filterConditions</code>.</p>

description: <p>A Package is a Namespace used to group Elements, without any instance-level semantics. It may have one or more model-level evaluable <code>filterCondition</code> Expressions used to filter its <code>importedMemberships</code>. Any imported <code>member</code> must meet all of the <code>filterConditions</code>.</p>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:packageFilterCondition](https://www.omg.org/spec/KerML/20230201/vocab#packageFilterCondition)| [0..*]| [kerml_vocab:Expression](https://www.omg.org/spec/KerML/20230201/vocab#Expression)| <p>The model-level evaluable Boolean Expressions used to filter the <code>members</code> of this Package, derived as those <code>ownedMembers</code> of the Package that are owned via ElementFilterMembership.</p>| <p>The model-level evaluable Boolean Expressions used to filter the <code>members</code> of this Package, derived as those <code>ownedMembers</code> of the Package that are owned via ElementFilterMembership.</p>|



### BooleanExpression

URI: https://www.omg.org/spec/KerML/20230201/shapes#BooleanExpression

type: Shape

target class: [kerml_vocab:BooleanExpression](https://www.omg.org/spec/KerML/20230201/vocab#BooleanExpression)

definition of vocabulary class : <p>A BooleanExpression is a Boolean-valued Expression whose type is a Predicate. It represents a logical condition resulting from the evaluation of the Predicate.</p><br><br><p>A BooleanExpression must subset, directly or indirectly, the Expression <em>booleanEvaluations</em> from the Base model library, which is typed by the base Predicate <em>BooleanEvaluation</em>. As a result, a BooleanExpression must always be typed by BooleanEvaluation or a subclass of BooleanEvaluation.</p><br><br>specializesFromLibrary("Performances::booleanEvaluations")

description: <p>A BooleanExpression is a Boolean-valued Expression whose type is a Predicate. It represents a logical condition resulting from the evaluation of the Predicate.</p><br><br><p>A BooleanExpression must subset, directly or indirectly, the Expression <em>booleanEvaluations</em> from the Base model library, which is typed by the base Predicate <em>BooleanEvaluation</em>. As a result, a BooleanExpression must always be typed by BooleanEvaluation or a subclass of BooleanEvaluation.</p><br><br>specializesFromLibrary("Performances::booleanEvaluations")

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:booleanExpressionPredicate](https://www.omg.org/spec/KerML/20230201/vocab#booleanExpressionPredicate)| [0..1]| [kerml_vocab:Predicate](https://www.omg.org/spec/KerML/20230201/vocab#Predicate)| <p>The Predicate that types the Expression.</p><br><p>The Predicate that types the Expression.</p><br>| <p>The Predicate that types the Expression.</p><br><p>The Predicate that types the Expression.</p><br>|



### LiteralInfinity

URI: https://www.omg.org/spec/KerML/20230201/shapes#LiteralInfinity

type: Shape

target class: [kerml_vocab:LiteralInfinity](https://www.omg.org/spec/KerML/20230201/vocab#LiteralInfinity)

definition of vocabulary class : <p>A LiteralInfinity is a LiteralExpression that provides the positive infinity value (<code>*</code>). It's <code>result</code> must have the type <code><em>Positive</em></code>.</p><br>

description: <p>A LiteralInfinity is a LiteralExpression that provides the positive infinity value (<code>*</code>). It's <code>result</code> must have the type <code><em>Positive</em></code>.</p><br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|



### LiteralExpression

URI: https://www.omg.org/spec/KerML/20230201/shapes#LiteralExpression

type: Shape

target class: [kerml_vocab:LiteralExpression](https://www.omg.org/spec/KerML/20230201/vocab#LiteralExpression)

definition of vocabulary class : <p>A LiteralExpression is an Expression that provides a basic value as a result. It must directly or indirectly specialize the Function <code><em>LiteralEvaluation</em></code> from the <code><em>Base</em></code> model library, which has no parameters other than its result, which is a single <code><em>DataValue</em></code>.</p><br><br>isModelLevelEvaluable = true<br>specializesFromLibrary("Performances::literalEvaluations")

description: <p>A LiteralExpression is an Expression that provides a basic value as a result. It must directly or indirectly specialize the Function <code><em>LiteralEvaluation</em></code> from the <code><em>Base</em></code> model library, which has no parameters other than its result, which is a single <code><em>DataValue</em></code>.</p><br><br>isModelLevelEvaluable = true<br>specializesFromLibrary("Performances::literalEvaluations")

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|



### SelectExpression

URI: https://www.omg.org/spec/KerML/20230201/shapes#SelectExpression

type: Shape

target class: [kerml_vocab:SelectExpression](https://www.omg.org/spec/KerML/20230201/vocab#SelectExpression)

definition of vocabulary class : <p>A SelectExpression is an OperatorExpression whose operator is <code>"select"</code>, which resolves to the library Function <em><code>ControlFunctions::select</code></em>.</p>

description: <p>A SelectExpression is an OperatorExpression whose operator is <code>"select"</code>, which resolves to the library Function <em><code>ControlFunctions::select</code></em>.</p>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|



### LiteralInteger

URI: https://www.omg.org/spec/KerML/20230201/shapes#LiteralInteger

type: Shape

target class: [kerml_vocab:LiteralInteger](https://www.omg.org/spec/KerML/20230201/vocab#LiteralInteger)

definition of vocabulary class : <p>A LiteralInteger is a LiteralExpression that provides an <code><em>Integer</em></code> value as a result. Its <code>result</code> parameter must have the type <code><em>Integer</em></code>.</p><br>

description: <p>A LiteralInteger is a LiteralExpression that provides an <code><em>Integer</em></code> value as a result. Its <code>result</code> parameter must have the type <code><em>Integer</em></code>.</p><br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:literalIntegerValue](https://www.omg.org/spec/KerML/20230201/vocab#literalIntegerValue)| [1]| Integer| <p>The Integer value that is the result of evaluating this Expression.</p><br><p>The Integer value that is the result of evaluating this Expression.</p><br>| <p>The Integer value that is the result of evaluating this Expression.</p><br><p>The Integer value that is the result of evaluating this Expression.</p><br>|



### FeatureMembership

URI: https://www.omg.org/spec/KerML/20230201/shapes#FeatureMembership

type: Shape

target class: [kerml_vocab:FeatureMembership](https://www.omg.org/spec/KerML/20230201/vocab#FeatureMembership)

definition of vocabulary class : <p>FeatureMembership is an OwningMembership for a Feature in a Type that is also a Featuring Relationship between the Feature and the Type, in which the <code>featuringType</code> is the <code>source</code> and the <code>featureOfType</code> is the <code>target</code>. A FeatureMembership is always owned by its <code>owningType</code>, which is the <code>featuringType</code> for the FeatureMembership considered as a Featuring.</p><br>

description: <p>FeatureMembership is an OwningMembership for a Feature in a Type that is also a Featuring Relationship between the Feature and the Type, in which the <code>featuringType</code> is the <code>source</code> and the <code>featureOfType</code> is the <code>target</code>. A FeatureMembership is always owned by its <code>owningType</code>, which is the <code>featuringType</code> for the FeatureMembership considered as a Featuring.</p><br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:featureMembershipOwnedMemberFeature](https://www.omg.org/spec/KerML/20230201/vocab#featureMembershipOwnedMemberFeature)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature that this FeatureMembership relates to its <code>owningType</code>, making it an <code>ownedFeature</code> of the <code>owningType</code>.</p>| <p>The Feature that this FeatureMembership relates to its <code>owningType</code>, making it an <code>ownedFeature</code> of the <code>owningType</code>.</p>|
| [kerml_vocab:featureMembershipOwningType](https://www.omg.org/spec/KerML/20230201/vocab#featureMembershipOwningType)| [1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>The Type that owns this FeatureMembership.</p>| <p>The Type that owns this FeatureMembership.</p>|



### MetadataFeature

URI: https://www.omg.org/spec/KerML/20230201/shapes#MetadataFeature

type: Shape

target class: [kerml_vocab:MetadataFeature](https://www.omg.org/spec/KerML/20230201/vocab#MetadataFeature)

definition of vocabulary class : <p>A MetadataFeature is a Feature that is an AnnotatingElement used to annotate another Element with metadata. It is typed by a Metaclass. All its <code>ownedFeatures</code> must redefine <code>features</code> of its <code>metaclass</code> and any feature bindings must be model-level evaluable.</p><br><br><p>A MetadataFeature must subset, directly or indirectly, the base MetadataFeature <em><code>metadata</code></em> from the Kernel Library.</p><br><br><br>specializesFromLibrary("Metaobjects::metaobjects")<br>isSemantic() implies<br>    let annotatedTypes : Sequence(Type) = <br>        annotatedElement->selectAsKind(Type) in<br>    let baseTypes : Sequence(MetadataFeature) = <br>        evaluateFeature(resolveGlobal(<br>            'Metaobjects::SemanticMetadata::baseType').<br>            oclAsType(Feature))-><br>        selectAsKind(MetadataFeature) in<br>    annotatedTypes->notEmpty() and <br>    baseTypes()->notEmpty() and <br>    baseTypes()->first().isSyntactic() implies<br>        let annotatedType : Type = annotatedTypes->first() in<br>        let baseType : Element = baseTypes->first().syntaxElement() in<br>        if annotatedType.oclIsKindOf(Classifier) and <br>            baseType.oclIsKindOf(Feature) then<br>            baseType.oclAsType(Feature).type-><br>                forAll(t | annotatedType.specializes(t))<br>        else if baseType.oclIsKindOf(Type) then<br>            annotatedType.specializes(baseType.oclAsType(Type))<br>        else<br>            true<br>        endif

description: <p>A MetadataFeature is a Feature that is an AnnotatingElement used to annotate another Element with metadata. It is typed by a Metaclass. All its <code>ownedFeatures</code> must redefine <code>features</code> of its <code>metaclass</code> and any feature bindings must be model-level evaluable.</p><br><br><p>A MetadataFeature must subset, directly or indirectly, the base MetadataFeature <em><code>metadata</code></em> from the Kernel Library.</p><br><br><br>specializesFromLibrary("Metaobjects::metaobjects")<br>isSemantic() implies<br>    let annotatedTypes : Sequence(Type) = <br>        annotatedElement->selectAsKind(Type) in<br>    let baseTypes : Sequence(MetadataFeature) = <br>        evaluateFeature(resolveGlobal(<br>            'Metaobjects::SemanticMetadata::baseType').<br>            oclAsType(Feature))-><br>        selectAsKind(MetadataFeature) in<br>    annotatedTypes->notEmpty() and <br>    baseTypes()->notEmpty() and <br>    baseTypes()->first().isSyntactic() implies<br>        let annotatedType : Type = annotatedTypes->first() in<br>        let baseType : Element = baseTypes->first().syntaxElement() in<br>        if annotatedType.oclIsKindOf(Classifier) and <br>            baseType.oclIsKindOf(Feature) then<br>            baseType.oclAsType(Feature).type-><br>                forAll(t | annotatedType.specializes(t))<br>        else if baseType.oclIsKindOf(Type) then<br>            annotatedType.specializes(baseType.oclAsType(Type))<br>        else<br>            true<br>        endif

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:metadataFeatureMetaclass](https://www.omg.org/spec/KerML/20230201/vocab#metadataFeatureMetaclass)| [0..1]| [kerml_vocab:Metaclass](https://www.omg.org/spec/KerML/20230201/vocab#Metaclass)| <p>The <code>type</code> of this AnnotatingFeature, which must be a DataType.</p>| <p>The <code>type</code> of this AnnotatingFeature, which must be a DataType.</p>|



### Subsetting

URI: https://www.omg.org/spec/KerML/20230201/shapes#Subsetting

type: Shape

target class: [kerml_vocab:Subsetting](https://www.omg.org/spec/KerML/20230201/vocab#Subsetting)

definition of vocabulary class : <p>Subsetting is Generalization in which the <code>specific</code> and <code>general</code> Types that are Features. This means all values of the <code>subsettingFeature</code> (on instances of its domain, i.e., the intersection of its <code>featuringTypes</code>) are values of the <code>subsettedFeature</code> on instances of its domain.&nbsp; To support this,&nbsp;the domain&nbsp;of the <code>subsettingFeature</code> must be the same or specialize (at least indirectly) the&nbsp;domain&nbsp;of the <code>subsettedFeature</code> (via Generalization), and the range (intersection of a Feature&#39;s <code>types</code>) of the <code>subsettingFeature</code> must specialize the range of the <code>subsettedFeature</code>.&nbsp;The <code>subsettedFeature</code> is imported into the <code>owningNamespace</code> of the <code>subsettingFeature</code> (if it is not already in that namespace), requiring the names of the <code>subsettingFeature</code> and <code>subsettedFeature</code> to be different.</p><br>

description: <p>Subsetting is Generalization in which the <code>specific</code> and <code>general</code> Types that are Features. This means all values of the <code>subsettingFeature</code> (on instances of its domain, i.e., the intersection of its <code>featuringTypes</code>) are values of the <code>subsettedFeature</code> on instances of its domain.&nbsp; To support this,&nbsp;the domain&nbsp;of the <code>subsettingFeature</code> must be the same or specialize (at least indirectly) the&nbsp;domain&nbsp;of the <code>subsettedFeature</code> (via Generalization), and the range (intersection of a Feature&#39;s <code>types</code>) of the <code>subsettingFeature</code> must specialize the range of the <code>subsettedFeature</code>.&nbsp;The <code>subsettedFeature</code> is imported into the <code>owningNamespace</code> of the <code>subsettingFeature</code> (if it is not already in that namespace), requiring the names of the <code>subsettingFeature</code> and <code>subsettedFeature</code> to be different.</p><br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:subsettingSubsettedFeature](https://www.omg.org/spec/KerML/20230201/vocab#subsettingSubsettedFeature)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature that is subsetted by the <code>subsettingFeature</code> of this Subsetting.</p><br>| <p>The Feature that is subsetted by the <code>subsettingFeature</code> of this Subsetting.</p><br>|
| [kerml_vocab:subsettingSubsettingFeature](https://www.omg.org/spec/KerML/20230201/vocab#subsettingSubsettingFeature)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature that is a subset of the <code>subsettedFeature</code> of this Subsetting.</p><br>| <p>The Feature that is a subset of the <code>subsettedFeature</code> of this Subsetting.</p><br>|
| [kerml_vocab:subsettingOwningFeature](https://www.omg.org/spec/KerML/20230201/vocab#subsettingOwningFeature)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature that owns this Subsetting relationship, which must also be its <code>subsettingFeature</code>.</p><br>| <p>The Feature that owns this Subsetting relationship, which must also be its <code>subsettingFeature</code>.</p><br>|



### LiteralBoolean

URI: https://www.omg.org/spec/KerML/20230201/shapes#LiteralBoolean

type: Shape

target class: [kerml_vocab:LiteralBoolean](https://www.omg.org/spec/KerML/20230201/vocab#LiteralBoolean)

definition of vocabulary class : <p>LiteralBoolean is a LiteralExpression that provides a <code><em>Boolean</em></code> value as a result. Its <code>result</code> parameter must have type <code><em>Boolean</em></code>.</p><br>

description: <p>LiteralBoolean is a LiteralExpression that provides a <code><em>Boolean</em></code> value as a result. Its <code>result</code> parameter must have type <code><em>Boolean</em></code>.</p><br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:literalBooleanValue](https://www.omg.org/spec/KerML/20230201/vocab#literalBooleanValue)| [1]| Boolean| <p>The Boolean value that is the result of evaluating this Expression.</p><br><p>The Boolean value that is the result of evaluating this Expression.</p><br>| <p>The Boolean value that is the result of evaluating this Expression.</p><br><p>The Boolean value that is the result of evaluating this Expression.</p><br>|



### Relationship

URI: https://www.omg.org/spec/KerML/20230201/shapes#Relationship

type: Shape

target class: [kerml_vocab:Relationship](https://www.omg.org/spec/KerML/20230201/vocab#Relationship)

definition of vocabulary class : <p>A <code>Relationship</code> is an <code>Element</code> that relates other <code>Element<s/code>. Some of its <code>relatedElements</code> may be owned, in which case those <code>ownedRelatedElements</code> will be deleted from a model if their <code>owningRelationship</code> is. A <code>Relationship</code> may also be owned by another <code>Element</code>, in which case the <code>ownedRelatedElements</code> of the <code>Relationship</code> are also considered to be transitively owned by the <code>owningRelatedElement</code> of the Relationship.</p><br><br><p>The <code>relatedElements</code> of a Relationship are divided into <code>source</code> and <code>target</code> <code>Elements</code>. The <code>Relationship</code> is considered to be directed from the <code>source</code> to the <code>target</code> <code>Elements</code>. An undirected <code>Relationship</code> may have either all <code>source</code> or all <code>target</code> <code>Elements</code>.</p><br><br><p>A &quot;relationship <code>Element</code>&quot; in the abstract syntax is generically any <code>Element</code> that is an instance of either <code>Relationship</code> or a direct or indirect specialization of <code>Relationship</code>. Any other kind of <code>Element</code> is a &quot;non-relationship <code>Element</code>&quot;. It is a convention of that non-relationship <code>Elements</code> are <em>only</em> related via reified relationship <code>Elements</code>. Any meta-associations directly between non-relationship <code>Elements</code> must be derived from underlying reified <code>Relationship</code>.</p><br><br>relatedElement = source->union(target)

description: <p>A <code>Relationship</code> is an <code>Element</code> that relates other <code>Element<s/code>. Some of its <code>relatedElements</code> may be owned, in which case those <code>ownedRelatedElements</code> will be deleted from a model if their <code>owningRelationship</code> is. A <code>Relationship</code> may also be owned by another <code>Element</code>, in which case the <code>ownedRelatedElements</code> of the <code>Relationship</code> are also considered to be transitively owned by the <code>owningRelatedElement</code> of the Relationship.</p><br><br><p>The <code>relatedElements</code> of a Relationship are divided into <code>source</code> and <code>target</code> <code>Elements</code>. The <code>Relationship</code> is considered to be directed from the <code>source</code> to the <code>target</code> <code>Elements</code>. An undirected <code>Relationship</code> may have either all <code>source</code> or all <code>target</code> <code>Elements</code>.</p><br><br><p>A &quot;relationship <code>Element</code>&quot; in the abstract syntax is generically any <code>Element</code> that is an instance of either <code>Relationship</code> or a direct or indirect specialization of <code>Relationship</code>. Any other kind of <code>Element</code> is a &quot;non-relationship <code>Element</code>&quot;. It is a convention of that non-relationship <code>Elements</code> are <em>only</em> related via reified relationship <code>Elements</code>. Any meta-associations directly between non-relationship <code>Elements</code> must be derived from underlying reified <code>Relationship</code>.</p><br><br>relatedElement = source->union(target)

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:relationshipIsImplied](https://www.omg.org/spec/KerML/20230201/vocab#relationshipIsImplied)| [1]| Boolean| <p>Whether this Relationship was generated by tooling to meet semantic rules, rather than being directly created by a modeler.</p>| <p>Whether this Relationship was generated by tooling to meet semantic rules, rather than being directly created by a modeler.</p>|
| [kerml_vocab:relationshipOwnedRelatedElement](https://www.omg.org/spec/KerML/20230201/vocab#relationshipOwnedRelatedElement)| [0..*]| [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)| <p>The <tt>relatedElements</tt> of this Relationship that are owned by the Relationship.</p>| <p>The <tt>relatedElements</tt> of this Relationship that are owned by the Relationship.</p>|
| [kerml_vocab:relationshipOwningRelatedElement](https://www.omg.org/spec/KerML/20230201/vocab#relationshipOwningRelatedElement)| [0..1]| [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)| <p>The <tt>relatedElement</tt> of this Relationship that owns the Relationship, if any.</p>| <p>The <tt>relatedElement</tt> of this Relationship that owns the Relationship, if any.</p>|
| [kerml_vocab:relationshipRelatedElement](https://www.omg.org/spec/KerML/20230201/vocab#relationshipRelatedElement)| [0..*]| [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)| <p>The Elements that are related by this Relationship, derived as the union of the <code>source</code> and <code>target</code> Elements of the Relationship.</p>| <p>The Elements that are related by this Relationship, derived as the union of the <code>source</code> and <code>target</code> Elements of the Relationship.</p>|
| [kerml_vocab:relationshipTarget](https://www.omg.org/spec/KerML/20230201/vocab#relationshipTarget)| [0..*]| [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)| <p>The <code>relatedElements</code> to which this Relationship is considered to be directed.</p><br>| <p>The <code>relatedElements</code> to which this Relationship is considered to be directed.</p><br>|
| [kerml_vocab:relationshipSource](https://www.omg.org/spec/KerML/20230201/vocab#relationshipSource)| [0..*]| [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)| <p>The <code>relatedElements</c ode> from which this Relationship is considered to be directed.</p>| <p>The <code>relatedElements</c ode> from which this Relationship is considered to be directed.</p>|



### Membership

URI: https://www.omg.org/spec/KerML/20230201/shapes#Membership

type: Shape

target class: [kerml_vocab:Membership](https://www.omg.org/spec/KerML/20230201/vocab#Membership)

definition of vocabulary class : <p>Membership is a Relationship between a Namespace and an Element that indicates the Element is a <code>member</code> of (i.e., is contained in) the Namespace. Any <code>memberNames</code> specify how the <code>memberElement</code> is identified in the Namespace and the <code>visibility</code> specifies whether or not the <code>memberElement</code> is publicly visible from outside the Namespace.</p><br><br><p>If a Membership is an OwningMembership, then it owns its <code>memberElement</code>, which becomes an <code>ownedMember</code> of the <code>membershipOwningNamespace</code>. Otherwise, the <code>memberNames</code> of a Membership are effectively aliases within the <code>membershipOwningNamespace</code> for an Element with a separate OwningMembership in the same or a different Namespace.<p><br>

description: <p>Membership is a Relationship between a Namespace and an Element that indicates the Element is a <code>member</code> of (i.e., is contained in) the Namespace. Any <code>memberNames</code> specify how the <code>memberElement</code> is identified in the Namespace and the <code>visibility</code> specifies whether or not the <code>memberElement</code> is publicly visible from outside the Namespace.</p><br><br><p>If a Membership is an OwningMembership, then it owns its <code>memberElement</code>, which becomes an <code>ownedMember</code> of the <code>membershipOwningNamespace</code>. Otherwise, the <code>memberNames</code> of a Membership are effectively aliases within the <code>membershipOwningNamespace</code> for an Element with a separate OwningMembership in the same or a different Namespace.<p><br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:membershipMemberElementId](https://www.omg.org/spec/KerML/20230201/vocab#membershipMemberElementId)| [1]| String| <p>The <code>elementId</code> of the <code>memberElement</code>.</p>| <p>The <code>elementId</code> of the <code>memberElement</code>.</p>|
| [kerml_vocab:membershipMemberShortName](https://www.omg.org/spec/KerML/20230201/vocab#membershipMemberShortName)| [0..1]| String| <p>The short name of the <code>memberElement</code> relative to the <code>membershipOwningNamespace</code>.</p>| <p>The short name of the <code>memberElement</code> relative to the <code>membershipOwningNamespace</code>.</p>|
| [kerml_vocab:membershipMemberName](https://www.omg.org/spec/KerML/20230201/vocab#membershipMemberName)| [0..1]| String| <p>The name of the <code>memberElement</code> relative to the <code>membershipOwningNamespace</code>.</p><br>| <p>The name of the <code>memberElement</code> relative to the <code>membershipOwningNamespace</code>.</p><br>|
| [kerml_vocab:membershipVisibility](https://www.omg.org/spec/KerML/20230201/vocab#membershipVisibility)| [1]| String| <p>Whether or not the Membership of the <code>memberElement</code> in the <code>membershipOwningNamespace</code> is publicly visible outside that Namespace.</p><br>| <p>Whether or not the Membership of the <code>memberElement</code> in the <code>membershipOwningNamespace</code> is publicly visible outside that Namespace.</p><br>|
| [kerml_vocab:membershipMembershipOwningNamespace](https://www.omg.org/spec/KerML/20230201/vocab#membershipMembershipOwningNamespace)| [1]| [kerml_vocab:Namespace](https://www.omg.org/spec/KerML/20230201/vocab#Namespace)| <p>The Namespace of which the <code>memberElement</code> becomes a <cpde>member</code> due to this Membership.</p><br>| <p>The Namespace of which the <code>memberElement</code> becomes a <cpde>member</code> due to this Membership.</p><br>|
| [kerml_vocab:membershipMemberElement](https://www.omg.org/spec/KerML/20230201/vocab#membershipMemberElement)| [1]| [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)| <p>The Element that becomes a <code>member</code> of the <code>membershipOwningNamespace</code> due to this Membership.</p><br>| <p>The Element that becomes a <code>member</code> of the <code>membershipOwningNamespace</code> due to this Membership.</p><br>|



### Conjugation

URI: https://www.omg.org/spec/KerML/20230201/shapes#Conjugation

type: Shape

target class: [kerml_vocab:Conjugation](https://www.omg.org/spec/KerML/20230201/vocab#Conjugation)

definition of vocabulary class : <p>Conjugation is a Relationship between two types in which the <code>conjugatedType</code> inherits all the Features of the <code>originalType</code>, but with all <code>input</code> and <code>output</code> Features reversed. That is, any Features with a FeatureMembership with <code>direction</code> <em>in</em> relative to the <code>originalType</code> are considered to have an effective <code>direction</code> of <em>out</em> relative to the <code>conjugatedType</code> and, similarly, Features with <code>direction</code> <em>out</em> in the <code>originalType</code> are considered to have an effective <code>direction</code> of <em>in</em> in the <code>originalType</code>. Features with <code>direction</code> <em>inout</em>, or with no <code>direction</code>, in the <code>originalType</code>, are inherited without change.</p><br><br><p>A Type may participate as a <code>conjugatedType</code> in at most one Conjugation relationship, and such a Type may not also be the <code>specific</code> Type in any Generalization relationship.</p><br>

description: <p>Conjugation is a Relationship between two types in which the <code>conjugatedType</code> inherits all the Features of the <code>originalType</code>, but with all <code>input</code> and <code>output</code> Features reversed. That is, any Features with a FeatureMembership with <code>direction</code> <em>in</em> relative to the <code>originalType</code> are considered to have an effective <code>direction</code> of <em>out</em> relative to the <code>conjugatedType</code> and, similarly, Features with <code>direction</code> <em>out</em> in the <code>originalType</code> are considered to have an effective <code>direction</code> of <em>in</em> in the <code>originalType</code>. Features with <code>direction</code> <em>inout</em>, or with no <code>direction</code>, in the <code>originalType</code>, are inherited without change.</p><br><br><p>A Type may participate as a <code>conjugatedType</code> in at most one Conjugation relationship, and such a Type may not also be the <code>specific</code> Type in any Generalization relationship.</p><br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:conjugationOriginalType](https://www.omg.org/spec/KerML/20230201/vocab#conjugationOriginalType)| [1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>The Type to be conjugated.</P>| <p>The Type to be conjugated.</P>|
| [kerml_vocab:conjugationConjugatedType](https://www.omg.org/spec/KerML/20230201/vocab#conjugationConjugatedType)| [1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>The Type that is the result of applying Conjugation to the <code>originalType</code>.</p>| <p>The Type that is the result of applying Conjugation to the <code>originalType</code>.</p>|
| [kerml_vocab:conjugationOwningType](https://www.omg.org/spec/KerML/20230201/vocab#conjugationOwningType)| [0..1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>The <code>conjugatedType</code> of this Type that is also its <code>owningRelatedElement</code>.</p><br>| <p>The <code>conjugatedType</code> of this Type that is also its <code>owningRelatedElement</code>.</p><br>|



### Documentation

URI: https://www.omg.org/spec/KerML/20230201/shapes#Documentation

type: Shape

target class: [kerml_vocab:Documentation](https://www.omg.org/spec/KerML/20230201/vocab#Documentation)

definition of vocabulary class : <p>Documentation is a Comment that specifically documents a <code>documentedElement</code>, which must be its <code>owner</code>.</p>

description: <p>Documentation is a Comment that specifically documents a <code>documentedElement</code>, which must be its <code>owner</code>.</p>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:documentationDocumentedElement](https://www.omg.org/spec/KerML/20230201/vocab#documentationDocumentedElement)| [1]| [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)| <p>The Element that is documented by this Documentation.</p>| <p>The Element that is documented by this Documentation.</p>|



### Unioning

URI: https://www.omg.org/spec/KerML/20230201/shapes#Unioning

type: Shape

target class: [kerml_vocab:Unioning](https://www.omg.org/spec/KerML/20230201/vocab#Unioning)

definition of vocabulary class : <p>Unioning is a Relationship that makes its <code>unioningType</code> one of the <code>unioningTypes</code> of its <code>typeUnioned</code>.</p>

description: <p>Unioning is a Relationship that makes its <code>unioningType</code> one of the <code>unioningTypes</code> of its <code>typeUnioned</code>.</p>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:unioningUnioningType](https://www.omg.org/spec/KerML/20230201/vocab#unioningUnioningType)| [1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>Type that partly determines interpretations of <code>typeUnioned</code>, as described in <code>Type::unioningType</code>.</p>| <p>Type that partly determines interpretations of <code>typeUnioned</code>, as described in <code>Type::unioningType</code>.</p>|
| [kerml_vocab:unioningTypeUnioned](https://www.omg.org/spec/KerML/20230201/vocab#unioningTypeUnioned)| [1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>Type with interpretations partly determined by <code>unioningType</code>, as described in <code>Type::unioningType</code>.</p>| <p>Type with interpretations partly determined by <code>unioningType</code>, as described in <code>Type::unioningType</code>.</p>|



### EndFeatureMembership

URI: https://www.omg.org/spec/KerML/20230201/shapes#EndFeatureMembership

type: Shape

target class: [kerml_vocab:EndFeatureMembership](https://www.omg.org/spec/KerML/20230201/vocab#EndFeatureMembership)

definition of vocabulary class : <p>EndFeatureMembership is a FeatureMembership that requires its <code>memberFeature</code> be owned and have <code>isEnd = true</code>.</p><br>ownedMemberFeature.isEnd

description: <p>EndFeatureMembership is a FeatureMembership that requires its <code>memberFeature</code> be owned and have <code>isEnd = true</code>.</p><br>ownedMemberFeature.isEnd

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|



### AnnotatingElement

URI: https://www.omg.org/spec/KerML/20230201/shapes#AnnotatingElement

type: Shape

target class: [kerml_vocab:AnnotatingElement](https://www.omg.org/spec/KerML/20230201/vocab#AnnotatingElement)

definition of vocabulary class : <p>An AnnotatingElement is an Element that provides additional description of or metadata on some other Element. An AnnotatingElement is attached to its <code>annotatedElement</code> by an Annotation Relationship.</p><br><br>annotatedElement = <br> if annotation->notEmpty() then annotation.annotatedElement<br> else owningNamespace endif

description: <p>An AnnotatingElement is an Element that provides additional description of or metadata on some other Element. An AnnotatingElement is attached to its <code>annotatedElement</code> by an Annotation Relationship.</p><br><br>annotatedElement = <br> if annotation->notEmpty() then annotation.annotatedElement<br> else owningNamespace endif

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:annotatingElementAnnotation](https://www.omg.org/spec/KerML/20230201/vocab#annotatingElementAnnotation)| [0..*]| [kerml_vocab:Annotation](https://www.omg.org/spec/KerML/20230201/vocab#Annotation)| <p>The Annotations that relate this AnnotatingElement to its <code>annotatedElements</code>.</p>| <p>The Annotations that relate this AnnotatingElement to its <code>annotatedElements</code>.</p>|
| [kerml_vocab:annotatingElementAnnotatedElement](https://www.omg.org/spec/KerML/20230201/vocab#annotatingElementAnnotatedElement)| [1..*]| [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)| <p>The Elements that are annotated by this AnnotatingElement. If <code>annotation</code<> is not empty, this is derived as the <code>annotatedElements</code> of the <code>annotations</code>. If <code>annotation</code>, then it is derived as the <code>owningNamespace</code> of the AnnotatingElement.</p><br>| <p>The Elements that are annotated by this AnnotatingElement. If <code>annotation</code<> is not empty, this is derived as the <code>annotatedElements</code> of the <code>annotations</code>. If <code>annotation</code>, then it is derived as the <code>owningNamespace</code> of the AnnotatingElement.</p><br>|



### TypeFeaturing

URI: https://www.omg.org/spec/KerML/20230201/shapes#TypeFeaturing

type: Shape

target class: [kerml_vocab:TypeFeaturing](https://www.omg.org/spec/KerML/20230201/vocab#TypeFeaturing)

definition of vocabulary class : <p>A TypeFeaturing is a Featuring Relationship in which the <code>featureOfType</code> is the <code>source</code> and the <code>featuringType</code> is the target. A TypeFeaturing may be owned by its <code>featureOfType</code>.</p>

description: <p>A TypeFeaturing is a Featuring Relationship in which the <code>featureOfType</code> is the <code>source</code> and the <code>featuringType</code> is the target. A TypeFeaturing may be owned by its <code>featureOfType</code>.</p>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:typeFeaturingOwningFeatureOfType](https://www.omg.org/spec/KerML/20230201/vocab#typeFeaturingOwningFeatureOfType)| [0..1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature that owns this TypeFeaturing and is also the <code>featureOfType</code>.</p>| <p>The Feature that owns this TypeFeaturing and is also the <code>featureOfType</code>.</p>|
| [kerml_vocab:typeFeaturingFeatureOfType](https://www.omg.org/spec/KerML/20230201/vocab#typeFeaturingFeatureOfType)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature that is featured by the <code>featuringType</code>. It is the <code>source</code> of the Relationship.</p>| <p>The Feature that is featured by the <code>featuringType</code>. It is the <code>source</code> of the Relationship.</p>|
| [kerml_vocab:typeFeaturingFeaturingType](https://www.omg.org/spec/KerML/20230201/vocab#typeFeaturingFeaturingType)| [1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>The Type that features the <code>featureOfType</code>. It is the <code>target</code> of the Relationship.</p>| <p>The Type that features the <code>featureOfType</code>. It is the <code>target</code> of the Relationship.</p>|



### DataType

URI: https://www.omg.org/spec/KerML/20230201/shapes#DataType

type: Shape

target class: [kerml_vocab:DataType](https://www.omg.org/spec/KerML/20230201/vocab#DataType)

definition of vocabulary class : <p>A DataType is a Classifier of things (in the universe) that can only be distinguished by how they are related to other things (via Features). This means multiple things classified by the same DataType</p><br><br><ul><br>	<li>Cannot be distinguished when they are related to other things in exactly the same way, even when they are intended to be about different things.</li><br>	<li>Can be distinguished when they are related to other things in different ways, even when they are intended to be about the same thing.</li><br></ul><br><br>specializesFromLibrary("Base::DataValue")<br>ownedGeneralization.general-><br>    forAll(not oclIsKindOf(Class))

description: <p>A DataType is a Classifier of things (in the universe) that can only be distinguished by how they are related to other things (via Features). This means multiple things classified by the same DataType</p><br><br><ul><br>	<li>Cannot be distinguished when they are related to other things in exactly the same way, even when they are intended to be about different things.</li><br>	<li>Can be distinguished when they are related to other things in different ways, even when they are intended to be about the same thing.</li><br></ul><br><br>specializesFromLibrary("Base::DataValue")<br>ownedGeneralization.general-><br>    forAll(not oclIsKindOf(Class))

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|



### Comment

URI: https://www.omg.org/spec/KerML/20230201/shapes#Comment

type: Shape

target class: [kerml_vocab:Comment](https://www.omg.org/spec/KerML/20230201/vocab#Comment)

definition of vocabulary class : <p>A Comment is an AnnotatingElement whose <code>body</code> in some way describes its <code>annotatedElements</code>.</p><br>

description: <p>A Comment is an AnnotatingElement whose <code>body</code> in some way describes its <code>annotatedElements</code>.</p><br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:commentLocale](https://www.omg.org/spec/KerML/20230201/vocab#commentLocale)| [0..1]| String| <p>Identification of the language of the <code>body</code> text and, optionally, the region and/or encoding. The format shall be a POSIX locale conformant to ISO/IEC 15897, with the format <code>[language[_territory][.codeset][@modifier]]</code>.</p>| <p>Identification of the language of the <code>body</code> text and, optionally, the region and/or encoding. The format shall be a POSIX locale conformant to ISO/IEC 15897, with the format <code>[language[_territory][.codeset][@modifier]]</code>.</p>|
| [kerml_vocab:commentBody](https://www.omg.org/spec/KerML/20230201/vocab#commentBody)| [1]| String| <p>The annotation text for the Comment.</p><br>| <p>The annotation text for the Comment.</p><br>|



### Feature

URI: https://www.omg.org/spec/KerML/20230201/shapes#Feature

type: Shape

target class: [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)

definition of vocabulary class : <p>A Feature is a Type that classifies sequences of multiple things (in the universe). These must concatenate a sequence drawn from the intersection of the Feature&#39;s <code>featuringTypes</code> (<em>domain</em>) with a sequence drawn from the intersection of its <code>types</code> (<em>co-domain</em>), treating (co)domains as sets of sequences. The domain of Features that do not have any <code>featuringTypes</code> is the same as if it were the library Type Anything. A Feature&#39;s <code>types</code> include at least Anything, which can be narrowed to other Classifiers by Redefinition.</p><br><br><p>In the simplest cases, a Feature&#39;s <code>featuringTypes</code> and <code>types</code> are Classifiers, its sequences being pairs (length = 2), with the first element drawn from the Feature&#39;s domain and the second element from its co-domain (the Feature &quot;value&quot;). Examples include cars paired with wheels, people paired with other people, and cars paired with numbers&nbsp;representing the car length.</p><br><br><p>Since Features are Types, their <code>featuringTypes</code> and <code>types</code> can be Features. When both are, Features classify sequences of at least four elements (length &gt; 3), otherwise at least three (length &gt; 2). The <code>featuringTypes</code> of <em>nested</em> Features are Features.</p><br><br><p>The values of a Feature with <code>chainingFeatures</code> are the same as values of the last Feature in the chain, which can be found by starting with values of the first Feature, then from those values to values of the second feature, and so on, to values of the last feature.</p><br><br>ownedRedefinition = ownedSubsetting->selectByKind(Redefinition)<br>ownedTypeFeaturing = ownedRelationship->selectByKind(TypeFeaturing)-><br>    select(tf | tf.featureOfType = self)<br>ownedSubsetting = ownedGeneralization->selectByKind(Subsetting)<br>isComposite = owningFeatureMembership <> null and owningFeatureMembership.isComposite<br>ownedTyping = ownedGeneralization->selectByKind(FeatureTyping)<br>type =<br>    if chainingFeature->notEmpty() then<br>        chainingFeature->last().type<br>    else<br>        ownedTyping.type-><br>            union(ownedSubsetting.subsettedFeature.type)-><br>            asOrderedSet()<br>    endif<br>isEnd = owningFeatureMembership <> null and owningFeatureMembership.oclIsKindOf(EndFeatureMembership)<br>multiplicity <> null implies multiplicity.featuringType = featuringType <br>specializesFromLibrary("Base::things")<br>chainingFeatures->excludes(self)<br>ownedFeatureChaining = ownedRelationship->selectByKind(FeatureChaining)<br>chainingFeature = ownedFeatureChaining.chainingFeature<br>chainingFeatures->size() <> 1<br>inverseFeature = invertingFeatureInverting.featureInverse<br>invertedFeature = invertedFeatureInverting.featureInverted<br>ownedTyping.type->exists(selectByKind(DataType)) implies<br>    specializesFromLibary("Base::dataValues")<br>ownedTyping.type->exists(selectByKind(Class)) implies<br>    specializesFromLibrary("Occurrences::occurrences")<br>isComposite and<br>ownedTyping.type->includes(oclIsKindOf(Class)) and<br>owningType <> null and<br>(owningType.oclIsKindOf(Class) or<br> owningType.oclIsKindOf(Feature) and<br>    owningType.oclAsType(Feature).type-><br>        exists(oclIsKindOf(Class))) implies<br>    specializesFromLibrary("Occurrence::Occurrence::suboccurrences")<br>isComposite and<br>ownedTyping.type->includes(oclIsKindOf(Structure)) and<br>owningType <> null and<br>(owningType.oclIsKindOf(Structure) or<br> owningType.type->includes(oclIsKindOf(Structure))) implies<br>    specializesFromLibrary("Occurrence::Occurrence::suboccurrences")<br>isEnd and owningType <> null and<br>owningType.oclIsKindOf(Association) implies<br>    specializesFromLibrary("Links::Link::participants")<br>isEnd and owningType <> null implies<br>    let i : Integer = <br>        owningType.ownedFeature->select(isEnd) in<br>    owningType.ownedSpecialization.general-><br>        forAll(supertype |<br>            let ownedEndFeatures : Sequence(Feature) = <br>                supertype.ownedFeature->select(isEnd) in<br>            ownedEndFeatures->size() >= i implies<br>                redefines(ownedEndFeatures->at(i))<br>owningType <> null and<br>(owningType.oclIsKindOf(Behavior) or<br> owningType.oclIsKindOf(Step)) implies<br>    let i : Integer = <br>        owningType.ownedFeature->select(direction <> null) in<br>    owningType.ownedSpecialization.general-><br>        forAll(supertype |<br>            let ownedParameters : Sequence(Feature) = <br>                supertype.ownedFeature->select(direction <> null) in<br>            ownedParameters->size() >= i implies<br>                redefines(ownedParameters->at(i))<br>owningType <> null and<br>(owningType.oclIsKindOf(LiteralExpression) or<br> owningType.oclIsKindOf(FeatureReferenceExpression)) implies<br>    if owningType.oclIsKindOf(LiteralString) then<br>        specializesFromLibrary("ScalarValues::String")<br>    else if owningType.oclIsKindOf(LiteralBoolean) then<br>        specializesFromLibrary("ScalarValues::Boolean")<br>    else if owningType.oclIsKindOf(LiteralInteger) then<br>        specializesFromLibrary("ScalarValues::Rational")<br>    else if owningType.oclIsKindOf(LiteralBoolean) then<br>        specializesFromLibrary("ScalarValues::Rational")<br>    else if owningType.oclIsKindOf(LiteralBoolean) then<br>        specializesFromLibrary("ScalarValues::Real")<br>    else specializes(<br>        owningType.oclAsType(FeatureReferenceExpression).referent)<br>    endif endif endif endif endif<br><br>owningType <> null and<br>owningType.oclIsKindOf(ItemFlowEnd) and<br>owningType.ownedFeature->at(1) = self implies<br>    let flowType : Type = owningType.owningType in<br>    flowType <> null implies<br>        let i : Integer = <br>            flowType.ownedFeature.indexOf(owningType) in<br>        (i = 1 implies <br>            redefinesFromLibrary("Transfers::Transfer::source::sourceOutput")) and<br>        (i = 2 implies<br>            redefinesFromLibrary("Transfers::Transfer::source::targetInput"))<br>                 <br>ownedMembership-><br>    selectByKind(FeatureValue)-><br>    forAll(fv | specializes(fv.value.result))<br>owningType <> null and<br>(owningType.oclIsKindOf(Function) and<br>    self = owningType.oclAsType(Function).result or<br> owningType.oclIsKindOf(Expression) and<br>    self = owningType.oclAsType(Expression).result) implies<br>    owningType.ownedSpecialization.general-><br>        select(oclIsKindOf(Function) or oclIsKindOf(Expression))-><br>        forAll(supertype |<br>            redefines(<br>                if superType.oclIsKindOf(Function) then<br>                    superType.oclAsType(Function).result<br>                else<br>                    superType.oclAsType(Expression).result<br>                endif)<br>ownedTyping.type->exists(selectByKind(Structure)) implies<br>    specializesFromLibary("Objects::objects")

description: <p>A Feature is a Type that classifies sequences of multiple things (in the universe). These must concatenate a sequence drawn from the intersection of the Feature&#39;s <code>featuringTypes</code> (<em>domain</em>) with a sequence drawn from the intersection of its <code>types</code> (<em>co-domain</em>), treating (co)domains as sets of sequences. The domain of Features that do not have any <code>featuringTypes</code> is the same as if it were the library Type Anything. A Feature&#39;s <code>types</code> include at least Anything, which can be narrowed to other Classifiers by Redefinition.</p><br><br><p>In the simplest cases, a Feature&#39;s <code>featuringTypes</code> and <code>types</code> are Classifiers, its sequences being pairs (length = 2), with the first element drawn from the Feature&#39;s domain and the second element from its co-domain (the Feature &quot;value&quot;). Examples include cars paired with wheels, people paired with other people, and cars paired with numbers&nbsp;representing the car length.</p><br><br><p>Since Features are Types, their <code>featuringTypes</code> and <code>types</code> can be Features. When both are, Features classify sequences of at least four elements (length &gt; 3), otherwise at least three (length &gt; 2). The <code>featuringTypes</code> of <em>nested</em> Features are Features.</p><br><br><p>The values of a Feature with <code>chainingFeatures</code> are the same as values of the last Feature in the chain, which can be found by starting with values of the first Feature, then from those values to values of the second feature, and so on, to values of the last feature.</p><br><br>ownedRedefinition = ownedSubsetting->selectByKind(Redefinition)<br>ownedTypeFeaturing = ownedRelationship->selectByKind(TypeFeaturing)-><br>    select(tf | tf.featureOfType = self)<br>ownedSubsetting = ownedGeneralization->selectByKind(Subsetting)<br>isComposite = owningFeatureMembership <> null and owningFeatureMembership.isComposite<br>ownedTyping = ownedGeneralization->selectByKind(FeatureTyping)<br>type =<br>    if chainingFeature->notEmpty() then<br>        chainingFeature->last().type<br>    else<br>        ownedTyping.type-><br>            union(ownedSubsetting.subsettedFeature.type)-><br>            asOrderedSet()<br>    endif<br>isEnd = owningFeatureMembership <> null and owningFeatureMembership.oclIsKindOf(EndFeatureMembership)<br>multiplicity <> null implies multiplicity.featuringType = featuringType <br>specializesFromLibrary("Base::things")<br>chainingFeatures->excludes(self)<br>ownedFeatureChaining = ownedRelationship->selectByKind(FeatureChaining)<br>chainingFeature = ownedFeatureChaining.chainingFeature<br>chainingFeatures->size() <> 1<br>inverseFeature = invertingFeatureInverting.featureInverse<br>invertedFeature = invertedFeatureInverting.featureInverted<br>ownedTyping.type->exists(selectByKind(DataType)) implies<br>    specializesFromLibary("Base::dataValues")<br>ownedTyping.type->exists(selectByKind(Class)) implies<br>    specializesFromLibrary("Occurrences::occurrences")<br>isComposite and<br>ownedTyping.type->includes(oclIsKindOf(Class)) and<br>owningType <> null and<br>(owningType.oclIsKindOf(Class) or<br> owningType.oclIsKindOf(Feature) and<br>    owningType.oclAsType(Feature).type-><br>        exists(oclIsKindOf(Class))) implies<br>    specializesFromLibrary("Occurrence::Occurrence::suboccurrences")<br>isComposite and<br>ownedTyping.type->includes(oclIsKindOf(Structure)) and<br>owningType <> null and<br>(owningType.oclIsKindOf(Structure) or<br> owningType.type->includes(oclIsKindOf(Structure))) implies<br>    specializesFromLibrary("Occurrence::Occurrence::suboccurrences")<br>isEnd and owningType <> null and<br>owningType.oclIsKindOf(Association) implies<br>    specializesFromLibrary("Links::Link::participants")<br>isEnd and owningType <> null implies<br>    let i : Integer = <br>        owningType.ownedFeature->select(isEnd) in<br>    owningType.ownedSpecialization.general-><br>        forAll(supertype |<br>            let ownedEndFeatures : Sequence(Feature) = <br>                supertype.ownedFeature->select(isEnd) in<br>            ownedEndFeatures->size() >= i implies<br>                redefines(ownedEndFeatures->at(i))<br>owningType <> null and<br>(owningType.oclIsKindOf(Behavior) or<br> owningType.oclIsKindOf(Step)) implies<br>    let i : Integer = <br>        owningType.ownedFeature->select(direction <> null) in<br>    owningType.ownedSpecialization.general-><br>        forAll(supertype |<br>            let ownedParameters : Sequence(Feature) = <br>                supertype.ownedFeature->select(direction <> null) in<br>            ownedParameters->size() >= i implies<br>                redefines(ownedParameters->at(i))<br>owningType <> null and<br>(owningType.oclIsKindOf(LiteralExpression) or<br> owningType.oclIsKindOf(FeatureReferenceExpression)) implies<br>    if owningType.oclIsKindOf(LiteralString) then<br>        specializesFromLibrary("ScalarValues::String")<br>    else if owningType.oclIsKindOf(LiteralBoolean) then<br>        specializesFromLibrary("ScalarValues::Boolean")<br>    else if owningType.oclIsKindOf(LiteralInteger) then<br>        specializesFromLibrary("ScalarValues::Rational")<br>    else if owningType.oclIsKindOf(LiteralBoolean) then<br>        specializesFromLibrary("ScalarValues::Rational")<br>    else if owningType.oclIsKindOf(LiteralBoolean) then<br>        specializesFromLibrary("ScalarValues::Real")<br>    else specializes(<br>        owningType.oclAsType(FeatureReferenceExpression).referent)<br>    endif endif endif endif endif<br><br>owningType <> null and<br>owningType.oclIsKindOf(ItemFlowEnd) and<br>owningType.ownedFeature->at(1) = self implies<br>    let flowType : Type = owningType.owningType in<br>    flowType <> null implies<br>        let i : Integer = <br>            flowType.ownedFeature.indexOf(owningType) in<br>        (i = 1 implies <br>            redefinesFromLibrary("Transfers::Transfer::source::sourceOutput")) and<br>        (i = 2 implies<br>            redefinesFromLibrary("Transfers::Transfer::source::targetInput"))<br>                 <br>ownedMembership-><br>    selectByKind(FeatureValue)-><br>    forAll(fv | specializes(fv.value.result))<br>owningType <> null and<br>(owningType.oclIsKindOf(Function) and<br>    self = owningType.oclAsType(Function).result or<br> owningType.oclIsKindOf(Expression) and<br>    self = owningType.oclAsType(Expression).result) implies<br>    owningType.ownedSpecialization.general-><br>        select(oclIsKindOf(Function) or oclIsKindOf(Expression))-><br>        forAll(supertype |<br>            redefines(<br>                if superType.oclIsKindOf(Function) then<br>                    superType.oclAsType(Function).result<br>                else<br>                    superType.oclAsType(Expression).result<br>                endif)<br>ownedTyping.type->exists(selectByKind(Structure)) implies<br>    specializesFromLibary("Objects::objects")

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:featureIsUnique](https://www.omg.org/spec/KerML/20230201/vocab#featureIsUnique)| [1]| Boolean| <p>Whether or not values for this Feature must have no duplicates or not.</p><br>| <p>Whether or not values for this Feature must have no duplicates or not.</p><br>|
| [kerml_vocab:featureIsOrdered](https://www.omg.org/spec/KerML/20230201/vocab#featureIsOrdered)| [1]| Boolean| <p>Whether an order exists for the values of this Feature or not.</p>| <p>Whether an order exists for the values of this Feature or not.</p>|
| [kerml_vocab:featureIsComposite](https://www.omg.org/spec/KerML/20230201/vocab#featureIsComposite)| [1]| Boolean| <p>Whether the Feature is a composite <code>feature</code> of its <code>featuringType</code>. If so, the values of the Feature cannot exist after the instance of the <code>featuringType</code> no longer does.</p><br>| <p>Whether the Feature is a composite <code>feature</code> of its <code>featuringType</code>. If so, the values of the Feature cannot exist after the instance of the <code>featuringType</code> no longer does.</p><br>|
| [kerml_vocab:featureIsEnd](https://www.omg.org/spec/KerML/20230201/vocab#featureIsEnd)| [1]| Boolean| <p>Whether or not the this Feature is an end Feature, requiring a different interpretation of the <code>multiplicity</code> of the Feature.</p><br><br><p>An end Feature is always considered to map each domain entity to a single co-domain entity, whether or not a Multiplicity is given for it. If a Multiplicity is given for an end Feature, rather than giving the co-domain cardinality for the Feature as usual, it specifies a cardinality constraint for <em>navigating</em> across the <code>endFeatures</code> of the <code>featuringType</code> of the end Feature. That is, if a Type has <em>n</em> <code>endFeatures</code>, then the Multiplicity of any one of those end Features constrains the cardinality of the set of values of that Feature when the values of the other <em>n-1</em> end Features are held fixed.</p><br>| <p>Whether or not the this Feature is an end Feature, requiring a different interpretation of the <code>multiplicity</code> of the Feature.</p><br><br><p>An end Feature is always considered to map each domain entity to a single co-domain entity, whether or not a Multiplicity is given for it. If a Multiplicity is given for an end Feature, rather than giving the co-domain cardinality for the Feature as usual, it specifies a cardinality constraint for <em>navigating</em> across the <code>endFeatures</code> of the <code>featuringType</code> of the end Feature. That is, if a Type has <em>n</em> <code>endFeatures</code>, then the Multiplicity of any one of those end Features constrains the cardinality of the set of values of that Feature when the values of the other <em>n-1</em> end Features are held fixed.</p><br>|
| [kerml_vocab:featureIsDerived](https://www.omg.org/spec/KerML/20230201/vocab#featureIsDerived)| [1]| Boolean| <p>Whether the values of this Feature&nbsp;can always be computed from the values of other Features.</p><br>| <p>Whether the values of this Feature&nbsp;can always be computed from the values of other Features.</p><br>|
| [kerml_vocab:featureIsReadOnly](https://www.omg.org/spec/KerML/20230201/vocab#featureIsReadOnly)| [1]| Boolean| <p>Whether the values of this Feature can change over the lifetime of an instance of the domain.</p><br>| <p>Whether the values of this Feature can change over the lifetime of an instance of the domain.</p><br>|
| [kerml_vocab:featureIsPortion](https://www.omg.org/spec/KerML/20230201/vocab#featureIsPortion)| [1]| Boolean| <p>Whether the values of this Feature are contained in the space and time of instances of the Feature&#39;s domain.</p><br>| <p>Whether the values of this Feature are contained in the space and time of instances of the Feature&#39;s domain.</p><br>|
| [kerml_vocab:featureDirection](https://www.omg.org/spec/KerML/20230201/vocab#featureDirection)| [0..1]| String| <p>Determines how values of this Feature are determined or used (see FeatureDirectionKind).</p><br>| <p>Determines how values of this Feature are determined or used (see FeatureDirectionKind).</p><br>|
| [kerml_vocab:featureIsNonunique](https://www.omg.org/spec/KerML/20230201/vocab#featureIsNonunique)| [1]| Boolean| n/a| n/a|
| [kerml_vocab:featureOwningType](https://www.omg.org/spec/KerML/20230201/vocab#featureOwningType)| [0..1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>The Type that is the <code>owningType</code> of the <code>owningFeatureMembership</code> of this Type.</p>| <p>The Type that is the <code>owningType</code> of the <code>owningFeatureMembership</code> of this Type.</p>|
| [kerml_vocab:featureType](https://www.omg.org/spec/KerML/20230201/vocab#featureType)| [0..*]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>Types that restrict the values of this Feature, such that the values must be instances of all the types. The types of a Feature are derived from its <code>ownedFeatureTypings</code> and the <code>types</code> of its <code>ownedSubsettings</code>.</p><br>| <p>Types that restrict the values of this Feature, such that the values must be instances of all the types. The types of a Feature are derived from its <code>ownedFeatureTypings</code> and the <code>types</code> of its <code>ownedSubsettings</code>.</p><br>|
| [kerml_vocab:featureOwnedRedefinition](https://www.omg.org/spec/KerML/20230201/vocab#featureOwnedRedefinition)| [0..*]| [kerml_vocab:Redefinition](https://www.omg.org/spec/KerML/20230201/vocab#Redefinition)| <p>The <code>ownedSubsettings</code> of this Feature that are Redefinitions, for which the Feature is the <code>redefiningFeature</code>.</p><br><br>| <p>The <code>ownedSubsettings</code> of this Feature that are Redefinitions, for which the Feature is the <code>redefiningFeature</code>.</p><br><br>|
| [kerml_vocab:featureOwnedSubsetting](https://www.omg.org/spec/KerML/20230201/vocab#featureOwnedSubsetting)| [0..*]| [kerml_vocab:Subsetting](https://www.omg.org/spec/KerML/20230201/vocab#Subsetting)| <p>The <code>ownedGeneralizations</code> of this Feature that are Subsettings, for which the Feature is the <code>subsettingFeature</code>.</p><br>| <p>The <code>ownedGeneralizations</code> of this Feature that are Subsettings, for which the Feature is the <code>subsettingFeature</code>.</p><br>|
| [kerml_vocab:featureEndOwningType](https://www.omg.org/spec/KerML/20230201/vocab#featureEndOwningType)| [0..1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>The Type that is related to this Feature by an EndFeatureMembership in which the Feature is an <code>ownedMemberFeature</code>.</p>| <p>The Type that is related to this Feature by an EndFeatureMembership in which the Feature is an <code>ownedMemberFeature</code>.</p>|
| [kerml_vocab:featureOwnedTyping](https://www.omg.org/spec/KerML/20230201/vocab#featureOwnedTyping)| [0..*]| [kerml_vocab:FeatureTyping](https://www.omg.org/spec/KerML/20230201/vocab#FeatureTyping)| <p>The <code>ownedGeneralizations</code> of this Feature that are FeatureTypings, for which the Feature is the <code>typedFeature</code>.</p>| <p>The <code>ownedGeneralizations</code> of this Feature that are FeatureTypings, for which the Feature is the <code>typedFeature</code>.</p>|
| [kerml_vocab:featureFeaturingType](https://www.omg.org/spec/KerML/20230201/vocab#featureFeaturingType)| [0..*]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>Types that feature this Feature, such that any instance in the domain of the Feature must be classified by all of these Types, including at least all the <code>featuringTypes</code> of its <code>ownedTypeFeaturings</code>.</p>| <p>Types that feature this Feature, such that any instance in the domain of the Feature must be classified by all of these Types, including at least all the <code>featuringTypes</code> of its <code>ownedTypeFeaturings</code>.</p>|
| [kerml_vocab:featureOwnedTypeFeaturing](https://www.omg.org/spec/KerML/20230201/vocab#featureOwnedTypeFeaturing)| [0..*]| [kerml_vocab:TypeFeaturing](https://www.omg.org/spec/KerML/20230201/vocab#TypeFeaturing)| <p>The <code>ownedRelationships</code> of this Feature that are TypeFeaturings, for which the Feature is the <code>featureOfType</code>.</p>| <p>The <code>ownedRelationships</code> of this Feature that are TypeFeaturings, for which the Feature is the <code>featureOfType</code>.</p>|
| [kerml_vocab:featureChainingFeature](https://www.omg.org/spec/KerML/20230201/vocab#featureChainingFeature)| [0..*]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Features that are chained together to determine the values of this Feature, derived from the <code>chainingFeatures</code> of the <code>ownedFeatureChainings</code> of this Feature, in the same order. The values of a Feature with chainingFeatures are the same as values of the last Feature in the chain, which can be found by starting with the values of the first Feature (for each instance of the original Feature's domain), then on each of those to the values of the second Feature in chainingFeatures, and so on, to values of the last Feature. The Features related to a Feature by a FeatureChaining are identified as its chainingFeatures.</p>| <p>The Features that are chained together to determine the values of this Feature, derived from the <code>chainingFeatures</code> of the <code>ownedFeatureChainings</code> of this Feature, in the same order. The values of a Feature with chainingFeatures are the same as values of the last Feature in the chain, which can be found by starting with the values of the first Feature (for each instance of the original Feature's domain), then on each of those to the values of the second Feature in chainingFeatures, and so on, to values of the last Feature. The Features related to a Feature by a FeatureChaining are identified as its chainingFeatures.</p>|
| [kerml_vocab:featureOwnedFeatureInverting](https://www.omg.org/spec/KerML/20230201/vocab#featureOwnedFeatureInverting)| [0..*]| [kerml_vocab:FeatureInverting](https://www.omg.org/spec/KerML/20230201/vocab#FeatureInverting)| <p>The <code>ownedRelationships</code> of this Feature that are FeatureInvertings, for which the Feature is the <code>featureInverted</code>.</p>| <p>The <code>ownedRelationships</code> of this Feature that are FeatureInvertings, for which the Feature is the <code>featureInverted</code>.</p>|
| [kerml_vocab:featureOwnedFeatureChaining](https://www.omg.org/spec/KerML/20230201/vocab#featureOwnedFeatureChaining)| [0..*]| [kerml_vocab:FeatureChaining](https://www.omg.org/spec/KerML/20230201/vocab#FeatureChaining)| <p>The FeatureChainings that are among the <code>ownedRelationships</owned> of this Feature (identify their <code>featureChained</code> also as an <code>owningRelatedElement</code>).</p>| <p>The FeatureChainings that are among the <code>ownedRelationships</owned> of this Feature (identify their <code>featureChained</code> also as an <code>owningRelatedElement</code>).</p>|
| [kerml_vocab:featureOwnedReferenceSubsetting](https://www.omg.org/spec/KerML/20230201/vocab#featureOwnedReferenceSubsetting)| [0..1]| [kerml_vocab:ReferenceSubsetting](https://www.omg.org/spec/KerML/20230201/vocab#ReferenceSubsetting)| <p>The one <code>ownedSubsetting</code> of this Feature, if any, that is a ReferenceSubsetting, for which the Feature is the <code>referencingFeature</code>.</p>| <p>The one <code>ownedSubsetting</code> of this Feature, if any, that is a ReferenceSubsetting, for which the Feature is the <code>referencingFeature</code>.</p>|
| [kerml_vocab:featureOwningFeatureMembership](https://www.omg.org/spec/KerML/20230201/vocab#featureOwningFeatureMembership)| [0..1]| [kerml_vocab:FeatureMembership](https://www.omg.org/spec/KerML/20230201/vocab#FeatureMembership)| <p>The FeatureMembership that owns this Feature as an <code>ownedMemberFeature</code>, determining its <code>owningType</code>.</p>| <p>The FeatureMembership that owns this Feature as an <code>ownedMemberFeature</code>, determining its <code>owningType</code>.</p>|



### Step

URI: https://www.omg.org/spec/KerML/20230201/shapes#Step

type: Shape

target class: [kerml_vocab:Step](https://www.omg.org/spec/KerML/20230201/vocab#Step)

definition of vocabulary class : <p>A Step is a Feature that is typed by one or more Behaviors. Steps may be used by one Behavior to coordinate the performance of other Behaviors, supporting the steady refinement of behavioral descriptions. Steps can be ordered in time and can be connected using ItemFlows to specify things flowing between their parameters.</p><br><br>allSupertypes()->includes(resolveGlobal("Performances::performances"))<br>owningType <> null and<br>    (owningType.oclIsKindOf(Behavior) or<br>     owningType.oclIsKindOf(Step)) implies<br>    specializesFromLibrary('Performances::Performance::enclosedPerformance')<br>owningType <> null and<br>    (owningType.oclIsKindOf(Behavior) or<br>     owningType.oclIsKindOf(Step)) and<br>    self.isComposite implies<br>    specializesFromLibrary('Performances::Performance::subperformance')<br>isComposite and owningType <> null and<br>(owningType.oclIsKindOf(Structure) or<br> owningType.oclIsKindOf(Feature) and<br> owningType.oclAsType(Feature).type-><br>    exists(oclIsKindOf(Structure)) implies<br>    specializesFromLibrary('Objects::Object::ownedPerformance')

description: <p>A Step is a Feature that is typed by one or more Behaviors. Steps may be used by one Behavior to coordinate the performance of other Behaviors, supporting the steady refinement of behavioral descriptions. Steps can be ordered in time and can be connected using ItemFlows to specify things flowing between their parameters.</p><br><br>allSupertypes()->includes(resolveGlobal("Performances::performances"))<br>owningType <> null and<br>    (owningType.oclIsKindOf(Behavior) or<br>     owningType.oclIsKindOf(Step)) implies<br>    specializesFromLibrary('Performances::Performance::enclosedPerformance')<br>owningType <> null and<br>    (owningType.oclIsKindOf(Behavior) or<br>     owningType.oclIsKindOf(Step)) and<br>    self.isComposite implies<br>    specializesFromLibrary('Performances::Performance::subperformance')<br>isComposite and owningType <> null and<br>(owningType.oclIsKindOf(Structure) or<br> owningType.oclIsKindOf(Feature) and<br> owningType.oclAsType(Feature).type-><br>    exists(oclIsKindOf(Structure)) implies<br>    specializesFromLibrary('Objects::Object::ownedPerformance')

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:stepBehavior](https://www.omg.org/spec/KerML/20230201/vocab#stepBehavior)| [0..*]| [kerml_vocab:Behavior](https://www.omg.org/spec/KerML/20230201/vocab#Behavior)| <p>The Behaviors that type this Step.</p><br>| <p>The Behaviors that type this Step.</p><br>|
| [kerml_vocab:stepParameter](https://www.omg.org/spec/KerML/20230201/vocab#stepParameter)| [0..*]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The parameters of this Expression, which are all its <code>directedFeatures</code>, whose values are passed into and/or out of a performance of the Behavior.</p><br>| <p>The parameters of this Expression, which are all its <code>directedFeatures</code>, whose values are passed into and/or out of a performance of the Behavior.</p><br>|



### Namespace

URI: https://www.omg.org/spec/KerML/20230201/shapes#Namespace

type: Shape

target class: [kerml_vocab:Namespace](https://www.omg.org/spec/KerML/20230201/vocab#Namespace)

definition of vocabulary class : <p>A <code>Namespace</code> is an <code>Element</code> that contains other <code>Element</code>, known as its <code>members</code>, via <code>Membership</code> <code>Relationships</code> with those <code>Elements</code>. The <code>members</code> of a <code>Namespace</code> may be owned by the <code>Namespace</code>, aliased in the <code>Namespace</code>, or imported into the <code>Namespace</code> via <code>Import</code> <code>Relationships</code> with other <code>Namespace</code>.</p><br><br><p>A <code>Namespace</code> can provide names for its <code>members</code> via the <code>memberNames</code> and <code>memberShortNames</code> specified by the <code>Memberships</code> in the <code>Namespace</code>. If a <code>Membership</code> specifies a <code>memberName</code> and/or <code>memberShortName</code>, then that those are names of the corresponding <code>memberElement</code> relative to the <code>Namespace</code>. For an <code>OwningMembership</code>, the <code>owningMemberName</code> and <code>owningMemberShortName</code> are given by the <code>Element</code> <code>name</code> and <code>shortName</code>. Note that the same <code>Element</code> may be the <code>memberElement</code> of multiple <code>Memberships</code> in a <code>Namespace</code> (though it may be owned at most once), each of which may define a separate alias for the <code>Element</code> relative to the <code>Namespace</code>.</p><br><br>membership->forAll(m1 | <br>    membership->forAll(m2 | <br>        m1 <> m2 implies m1.isDistinguishableFrom(m2)))<br>member = membership.memberElement<br>ownedMember = ownedMembership->selectByKind(OwningMembership).ownedMemberElement<br>importedMembership = importedMemberships(Set{})<br>ownedImport = ownedRelationship->selectByKind(Import)<br>ownedMembership = ownedRelationship->selectByKind(Membership)

description: <p>A <code>Namespace</code> is an <code>Element</code> that contains other <code>Element</code>, known as its <code>members</code>, via <code>Membership</code> <code>Relationships</code> with those <code>Elements</code>. The <code>members</code> of a <code>Namespace</code> may be owned by the <code>Namespace</code>, aliased in the <code>Namespace</code>, or imported into the <code>Namespace</code> via <code>Import</code> <code>Relationships</code> with other <code>Namespace</code>.</p><br><br><p>A <code>Namespace</code> can provide names for its <code>members</code> via the <code>memberNames</code> and <code>memberShortNames</code> specified by the <code>Memberships</code> in the <code>Namespace</code>. If a <code>Membership</code> specifies a <code>memberName</code> and/or <code>memberShortName</code>, then that those are names of the corresponding <code>memberElement</code> relative to the <code>Namespace</code>. For an <code>OwningMembership</code>, the <code>owningMemberName</code> and <code>owningMemberShortName</code> are given by the <code>Element</code> <code>name</code> and <code>shortName</code>. Note that the same <code>Element</code> may be the <code>memberElement</code> of multiple <code>Memberships</code> in a <code>Namespace</code> (though it may be owned at most once), each of which may define a separate alias for the <code>Element</code> relative to the <code>Namespace</code>.</p><br><br>membership->forAll(m1 | <br>    membership->forAll(m2 | <br>        m1 <> m2 implies m1.isDistinguishableFrom(m2)))<br>member = membership.memberElement<br>ownedMember = ownedMembership->selectByKind(OwningMembership).ownedMemberElement<br>importedMembership = importedMemberships(Set{})<br>ownedImport = ownedRelationship->selectByKind(Import)<br>ownedMembership = ownedRelationship->selectByKind(Membership)

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:namespaceMembership](https://www.omg.org/spec/KerML/20230201/vocab#namespaceMembership)| [0..*]| [kerml_vocab:Membership](https://www.omg.org/spec/KerML/20230201/vocab#Membership)| <p>All Memberships in this Namespace, including (at least) the union of <code>ownedMemberships</code> and <code>importedMemberships</code>.</p><br>| <p>All Memberships in this Namespace, including (at least) the union of <code>ownedMemberships</code> and <code>importedMemberships</code>.</p><br>|
| [kerml_vocab:namespaceOwnedImport](https://www.omg.org/spec/KerML/20230201/vocab#namespaceOwnedImport)| [0..*]| [kerml_vocab:Import](https://www.omg.org/spec/KerML/20230201/vocab#Import)| <p>The <code>ownedRelationships</code> of this Namespace that are Imports, for which the Namespace is the <code>importOwningNamespace</code>.</p><br>| <p>The <code>ownedRelationships</code> of this Namespace that are Imports, for which the Namespace is the <code>importOwningNamespace</code>.</p><br>|
| [kerml_vocab:namespaceMember](https://www.omg.org/spec/KerML/20230201/vocab#namespaceMember)| [0..*]| [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)| <p>The set of all member Elements of this Namespace, derived as the <code>memberElements</code> of all <code>memberships</code> of the Namespace.</p><br>| <p>The set of all member Elements of this Namespace, derived as the <code>memberElements</code> of all <code>memberships</code> of the Namespace.</p><br>|
| [kerml_vocab:namespaceOwnedMember](https://www.omg.org/spec/KerML/20230201/vocab#namespaceOwnedMember)| [0..*]| [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)| <p>The owned <code>members</code> of this Namespace, derived as the <cpde>ownedMemberElements</code> of the <code>ownedMemberships</code> of the Namespace.</p><br>| <p>The owned <code>members</code> of this Namespace, derived as the <cpde>ownedMemberElements</code> of the <code>ownedMemberships</code> of the Namespace.</p><br>|
| [kerml_vocab:namespaceImportedMembership](https://www.omg.org/spec/KerML/20230201/vocab#namespaceImportedMembership)| [0..*]| [kerml_vocab:Membership](https://www.omg.org/spec/KerML/20230201/vocab#Membership)| <p>The Memberships in this Namespace that result from Import Relationships between the Namespace and other Namespaces.</p><br>| <p>The Memberships in this Namespace that result from Import Relationships between the Namespace and other Namespaces.</p><br>|
| [kerml_vocab:namespaceOwnedMembership](https://www.omg.org/spec/KerML/20230201/vocab#namespaceOwnedMembership)| [0..*]| [kerml_vocab:Membership](https://www.omg.org/spec/KerML/20230201/vocab#Membership)| <p>The <code>ownedRelationships</code> of this Namespace that are Memberships, for which the Namespace is the <code>membershipOwningNamespace</code>.</p><br>| <p>The <code>ownedRelationships</code> of this Namespace that are Memberships, for which the Namespace is the <code>membershipOwningNamespace</code>.</p><br>|



### Disjoining

URI: https://www.omg.org/spec/KerML/20230201/shapes#Disjoining

type: Shape

target class: [kerml_vocab:Disjoining](https://www.omg.org/spec/KerML/20230201/vocab#Disjoining)

definition of vocabulary class : <p>A Disjoining is a Relationship between Types asserted to have interpretations that are not shared (disjoint) between them, identified as <code>typeDisjoined</code> and <code>disjoiningType</code>. For example, a Classifier for mammals is disjoint from a Classifier for minerals, and a Feature for people&#39;s parents is disjoint from a Feature for their children. </code></p><br>

description: <p>A Disjoining is a Relationship between Types asserted to have interpretations that are not shared (disjoint) between them, identified as <code>typeDisjoined</code> and <code>disjoiningType</code>. For example, a Classifier for mammals is disjoint from a Classifier for minerals, and a Feature for people&#39;s parents is disjoint from a Feature for their children. </code></p><br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:disjoiningTypeDisjoined](https://www.omg.org/spec/KerML/20230201/vocab#disjoiningTypeDisjoined)| [1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>Type asserted to be disjoint with the <code>disjoiningType</code>.<p>| <p>Type asserted to be disjoint with the <code>disjoiningType</code>.<p>|
| [kerml_vocab:disjoiningDisjoiningType](https://www.omg.org/spec/KerML/20230201/vocab#disjoiningDisjoiningType)| [1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>Type asserted to be disjoint with the <code>typeDisjoined</code>.<p>| <p>Type asserted to be disjoint with the <code>typeDisjoined</code>.<p>|
| [kerml_vocab:disjoiningOwningType](https://www.omg.org/spec/KerML/20230201/vocab#disjoiningOwningType)| [0..1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>A <code>typeDisjoined</code> that is also an <code>owningRelatedElement</code>.</p>| <p>A <code>typeDisjoined</code> that is also an <code>owningRelatedElement</code>.</p>|



### TextualRepresentation

URI: https://www.omg.org/spec/KerML/20230201/shapes#TextualRepresentation

type: Shape

target class: [kerml_vocab:TextualRepresentation](https://www.omg.org/spec/KerML/20230201/vocab#TextualRepresentation)

definition of vocabulary class : <p>A TextualRepresentation is an AnnotatingElement whose <code>body</code> represents the <code>representedElement</code> in a given <code>language</code>. The <code>representedElement</code> must be the <code>owner</code> of the TextualRepresentation. The named <code>language</code> can be a natural language, in which case the <code>body</code> is an informal representation, or an artifical language, in which case the <code>body</code> is expected to be a formal, machine-parsable representation.</p><br><br><p>If the named <code>language</code> of a TextualRepresentation is machine-parsable, then the <code>body</code> text should be legal input text as defined for that <code>language</code>. The interpretation of the named language string shall be case insensitive. The following <code>language</code> names are defined to correspond to the given standard languages:</p><br><br><table border="1" cellpadding="1" cellspacing="1" width="498"><br>	<thead><br>	</thead><br>	<tbody><br>		<tr><br>			<td style="text-align: center; width: 154px;"><code>kerml</code></td><br>			<td style="width: 332px;">Kernel Modeling Language</td><br>		</tr><br>		<tr><br>			<td style="text-align: center; width: 154px;"><code>ocl</code></td><br>			<td style="width: 332px;">Object Constraint Language</td><br>		</tr><br>		<tr><br>			<td style="text-align: center; width: 154px;"><code>alf</code></td><br>			<td style="width: 332px;">Action Language for fUML</td><br>		</tr><br>	</tbody><br></table><br><br><p>Other specifications may define specific <code>language</code> strings, other than those shown in&nbsp;<mms-view-link mms-doc-id="_19_0_4_12e503d9_1655498859928_646482_53332" mms-element-id="MMS_1656305537944_6a3ca48e-424a-4a4d-8ce2-56df128ebabe" mms-pe-id="_hidden_MMS_1656305558930_8d3925ff-003f-4024-a594-14317550f480_pei">[cf:Standard Language Names.vlink]</mms-view-link>, to be used to indicate the use of languages from those specifications in KerML TextualRepresentations.</p><br><br><p>If the <code>language</code> of a TextualRepresentation is &quot;<code>kerml</code>&quot;, then the <code>body</code> text shall be a legal representation of the <code>representedElement</code> in the KerML textual concrete syntax. A conforming tool can use such a TextualRepresentation Annotation to record the original KerML concrete syntax text from which an Element was parsed. In this case, it is a tool responsibility to ensure that the <code>body</code> of the TextualRepresentation remains correct (or the Annotation is removed) if the annotated Element changes other than by re-parsing the <code>body</code> text.</p><br><br><p>An Element with a TextualRepresentation in a language other than KerML is essentially a semantically &quot;opaque&quot; Element specified in the other language. However, a conforming KerML tool may interpret such an element consistently with the specification of the named language.</p><br>

description: <p>A TextualRepresentation is an AnnotatingElement whose <code>body</code> represents the <code>representedElement</code> in a given <code>language</code>. The <code>representedElement</code> must be the <code>owner</code> of the TextualRepresentation. The named <code>language</code> can be a natural language, in which case the <code>body</code> is an informal representation, or an artifical language, in which case the <code>body</code> is expected to be a formal, machine-parsable representation.</p><br><br><p>If the named <code>language</code> of a TextualRepresentation is machine-parsable, then the <code>body</code> text should be legal input text as defined for that <code>language</code>. The interpretation of the named language string shall be case insensitive. The following <code>language</code> names are defined to correspond to the given standard languages:</p><br><br><table border="1" cellpadding="1" cellspacing="1" width="498"><br>	<thead><br>	</thead><br>	<tbody><br>		<tr><br>			<td style="text-align: center; width: 154px;"><code>kerml</code></td><br>			<td style="width: 332px;">Kernel Modeling Language</td><br>		</tr><br>		<tr><br>			<td style="text-align: center; width: 154px;"><code>ocl</code></td><br>			<td style="width: 332px;">Object Constraint Language</td><br>		</tr><br>		<tr><br>			<td style="text-align: center; width: 154px;"><code>alf</code></td><br>			<td style="width: 332px;">Action Language for fUML</td><br>		</tr><br>	</tbody><br></table><br><br><p>Other specifications may define specific <code>language</code> strings, other than those shown in&nbsp;<mms-view-link mms-doc-id="_19_0_4_12e503d9_1655498859928_646482_53332" mms-element-id="MMS_1656305537944_6a3ca48e-424a-4a4d-8ce2-56df128ebabe" mms-pe-id="_hidden_MMS_1656305558930_8d3925ff-003f-4024-a594-14317550f480_pei">[cf:Standard Language Names.vlink]</mms-view-link>, to be used to indicate the use of languages from those specifications in KerML TextualRepresentations.</p><br><br><p>If the <code>language</code> of a TextualRepresentation is &quot;<code>kerml</code>&quot;, then the <code>body</code> text shall be a legal representation of the <code>representedElement</code> in the KerML textual concrete syntax. A conforming tool can use such a TextualRepresentation Annotation to record the original KerML concrete syntax text from which an Element was parsed. In this case, it is a tool responsibility to ensure that the <code>body</code> of the TextualRepresentation remains correct (or the Annotation is removed) if the annotated Element changes other than by re-parsing the <code>body</code> text.</p><br><br><p>An Element with a TextualRepresentation in a language other than KerML is essentially a semantically &quot;opaque&quot; Element specified in the other language. However, a conforming KerML tool may interpret such an element consistently with the specification of the named language.</p><br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:textualRepresentationLanguage](https://www.omg.org/spec/KerML/20230201/vocab#textualRepresentationLanguage)| [1]| String| <p>The natural or artifical language in which the <code>body</code> text is written.</p><br>| <p>The natural or artifical language in which the <code>body</code> text is written.</p><br>|
| [kerml_vocab:textualRepresentationBody](https://www.omg.org/spec/KerML/20230201/vocab#textualRepresentationBody)| [1]| String| <p>The textual representation of the <code>representedElement</code> in the given <code>language</code>.</p><br>| <p>The textual representation of the <code>representedElement</code> in the given <code>language</code>.</p><br>|
| [kerml_vocab:textualRepresentationRepresentedElement](https://www.omg.org/spec/KerML/20230201/vocab#textualRepresentationRepresentedElement)| [1]| [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)| <p>The Element that is represented by this TextualRepresentation.</p>| <p>The Element that is represented by this TextualRepresentation.</p>|



### ReferenceSubsetting

URI: https://www.omg.org/spec/KerML/20230201/shapes#ReferenceSubsetting

type: Shape

target class: [kerml_vocab:ReferenceSubsetting](https://www.omg.org/spec/KerML/20230201/vocab#ReferenceSubsetting)

definition of vocabulary class : <p>ReferenceSubsetting is a kind of Subsetting in which the <code>referencedFeature</code> is syntactically distinguished from other Features subsetted by the <code>referencingFeature</code>. ReferenceSubsetting has the same semantics as Subsetting, but the <code>referenceFeature</code> may have a special purpose relative to the <code>referencingFeature</code>. For instance, ReferenceSubsetting is used to identify the <code>relatedFeatures</code> of a Connector.</p><br><br><p>ReferenceSubsetting is always an <code>ownedRelationship</code> of its <code>referencingFeature</code>. A Feature can have at most one <code>ownedReferenceSubsetting</code>.<p><br>

description: <p>ReferenceSubsetting is a kind of Subsetting in which the <code>referencedFeature</code> is syntactically distinguished from other Features subsetted by the <code>referencingFeature</code>. ReferenceSubsetting has the same semantics as Subsetting, but the <code>referenceFeature</code> may have a special purpose relative to the <code>referencingFeature</code>. For instance, ReferenceSubsetting is used to identify the <code>relatedFeatures</code> of a Connector.</p><br><br><p>ReferenceSubsetting is always an <code>ownedRelationship</code> of its <code>referencingFeature</code>. A Feature can have at most one <code>ownedReferenceSubsetting</code>.<p><br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:referenceSubsettingReferencedFeature](https://www.omg.org/spec/KerML/20230201/vocab#referenceSubsettingReferencedFeature)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature that is referenced by the <code>referencingFeature</code> of this ReferenceSubsetting.</p>| <p>The Feature that is referenced by the <code>referencingFeature</code> of this ReferenceSubsetting.</p>|
| [kerml_vocab:referenceSubsettingReferencingFeature](https://www.omg.org/spec/KerML/20230201/vocab#referenceSubsettingReferencingFeature)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature that owns this ReferenceSubsetting relationship, which is also its <code>subsettingFeature</code>.</p>| <p>The Feature that owns this ReferenceSubsetting relationship, which is also its <code>subsettingFeature</code>.</p>|



### AssociationStructure

URI: https://www.omg.org/spec/KerML/20230201/shapes#AssociationStructure

type: Shape

target class: [kerml_vocab:AssociationStructure](https://www.omg.org/spec/KerML/20230201/vocab#AssociationStructure)

definition of vocabulary class : specializesFromLibrary("Objects::ObjectLink")<br>endFeature->size() = 2 implies<br>    specializesFromLibrary("Objects::BinaryLinkObject")

description: specializesFromLibrary("Objects::ObjectLink")<br>endFeature->size() = 2 implies<br>    specializesFromLibrary("Objects::BinaryLinkObject")

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|



### Dependency

URI: https://www.omg.org/spec/KerML/20230201/shapes#Dependency

type: Shape

target class: [kerml_vocab:Dependency](https://www.omg.org/spec/KerML/20230201/vocab#Dependency)

definition of vocabulary class : <p>A <code>Dependency</code> is a <code>Relationship</code> that indicates that one or more <code>client</code> <code>Elements</code> require one more <code>supplier</code> <code>Elements</code> for their complete specification. In general, this means that a change to one of the <code>supplier</code> <code>Elements</code> may necessitate a change to, or re-specification of, the <code>client</code> <code>Elements</code>.</p><br><br><p>Note that a <code>Dependency</code> is entirely a model-level <code>Relationship</code>, without instance-level semantics.</p>

description: <p>A <code>Dependency</code> is a <code>Relationship</code> that indicates that one or more <code>client</code> <code>Elements</code> require one more <code>supplier</code> <code>Elements</code> for their complete specification. In general, this means that a change to one of the <code>supplier</code> <code>Elements</code> may necessitate a change to, or re-specification of, the <code>client</code> <code>Elements</code>.</p><br><br><p>Note that a <code>Dependency</code> is entirely a model-level <code>Relationship</code>, without instance-level semantics.</p>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:dependencyClient](https://www.omg.org/spec/KerML/20230201/vocab#dependencyClient)| [1..*]| [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)| <p>The <code>Element</code> or <code>Elements</code> dependent on the <code>supplier</code> <code>Elements</code>.</p>| <p>The <code>Element</code> or <code>Elements</code> dependent on the <code>supplier</code> <code>Elements</code>.</p>|
| [kerml_vocab:dependencySupplier](https://www.omg.org/spec/KerML/20230201/vocab#dependencySupplier)| [1..*]| [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)| <p>The <code>Element</code> or <code>Elements</code> on which the <code>client</code> <code>Elements</code> depend in some respect.</p>| <p>The <code>Element</code> or <code>Elements</code> on which the <code>client</code> <code>Elements</code> depend in some respect.</p>|



### Classifier

URI: https://www.omg.org/spec/KerML/20230201/shapes#Classifier

type: Shape

target class: [kerml_vocab:Classifier](https://www.omg.org/spec/KerML/20230201/vocab#Classifier)

definition of vocabulary class : <p>A Classifier is a Type for model elements that classify:</p><br><br><ul><br>	<li>Things&nbsp;(in the universe) regardless of how Features relate them.&nbsp; These are&nbsp;sequences of exactly one&nbsp;thing (sequence of length 1).</li><br>	<li>How the above&nbsp;things are related by Features. These are sequences of multiple things (length &gt; 1).</li><br></ul><br><br><p>Classifiers that classify relationships (sequence length &gt; 1) must also classify the things at the end of those&nbsp;sequences (sequence length =1).&nbsp; Because of this, Classifiers specializing Features cannot classify anything (any sequences).</p><br><br>ownedSubclassification = <br>    ownedSpecialization->selectByKind(Superclassification)<br>multiplicity <> null implies multiplicity.featuringType->isEmpty()

description: <p>A Classifier is a Type for model elements that classify:</p><br><br><ul><br>	<li>Things&nbsp;(in the universe) regardless of how Features relate them.&nbsp; These are&nbsp;sequences of exactly one&nbsp;thing (sequence of length 1).</li><br>	<li>How the above&nbsp;things are related by Features. These are sequences of multiple things (length &gt; 1).</li><br></ul><br><br><p>Classifiers that classify relationships (sequence length &gt; 1) must also classify the things at the end of those&nbsp;sequences (sequence length =1).&nbsp; Because of this, Classifiers specializing Features cannot classify anything (any sequences).</p><br><br>ownedSubclassification = <br>    ownedSpecialization->selectByKind(Superclassification)<br>multiplicity <> null implies multiplicity.featuringType->isEmpty()

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:classifierOwnedSubclassification](https://www.omg.org/spec/KerML/20230201/vocab#classifierOwnedSubclassification)| [0..*]| [kerml_vocab:Subclassification](https://www.omg.org/spec/KerML/20230201/vocab#Subclassification)| <p>The <code>ownedSpecializations</code> of this Classifier that are Subclassifications, for which this Classifier is the <code>subclassifier</code>.</p><br>| <p>The <code>ownedSpecializations</code> of this Classifier that are Subclassifications, for which this Classifier is the <code>subclassifier</code>.</p><br>|



### MembershipImport

URI: https://www.omg.org/spec/KerML/20230201/shapes#MembershipImport

type: Shape

target class: [kerml_vocab:MembershipImport](https://www.omg.org/spec/KerML/20230201/vocab#MembershipImport)

definition of vocabulary class : <p>A MembershipImport is an Import that imports its <code>importedMembership</code> into the <code>importOwningNamespace</code>. If <code>isRecursive = true</code> and the <code>memberElement</code> of the <code>importedMembership</code> is a Namespace, then the equivalent of a recursive NamespaceImport is also performed on that Namespace.</p><br>importedElement = importedMembership.memberElement

description: <p>A MembershipImport is an Import that imports its <code>importedMembership</code> into the <code>importOwningNamespace</code>. If <code>isRecursive = true</code> and the <code>memberElement</code> of the <code>importedMembership</code> is a Namespace, then the equivalent of a recursive NamespaceImport is also performed on that Namespace.</p><br>importedElement = importedMembership.memberElement

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:membershipImportImportedMembership](https://www.omg.org/spec/KerML/20230201/vocab#membershipImportImportedMembership)| [1]| [kerml_vocab:Membership](https://www.omg.org/spec/KerML/20230201/vocab#Membership)| <p>The Membership to be imported.</p>| <p>The Membership to be imported.</p>|



### FeatureChaining

URI: https://www.omg.org/spec/KerML/20230201/shapes#FeatureChaining

type: Shape

target class: [kerml_vocab:FeatureChaining](https://www.omg.org/spec/KerML/20230201/vocab#FeatureChaining)

definition of vocabulary class : <p>FeatureChaining is a Relationship that makes its target Feature one of the <code>chainingFeatures</code> of its owning Feature.</p>

description: <p>FeatureChaining is a Relationship that makes its target Feature one of the <code>chainingFeatures</code> of its owning Feature.</p>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:featureChainingChainingFeature](https://www.omg.org/spec/KerML/20230201/vocab#featureChainingChainingFeature)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature whose values partly determine values of <code>featureChained</code>, as described in <code>Feature::chainingFeature</code>.</p>| <p>The Feature whose values partly determine values of <code>featureChained</code>, as described in <code>Feature::chainingFeature</code>.</p>|
| [kerml_vocab:featureChainingFeatureChained](https://www.omg.org/spec/KerML/20230201/vocab#featureChainingFeatureChained)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature whose values are partly determined by values of the <code>chainingFeature</code>, as described in <code>Feature::chainingFeature</code>.</p>| <p>The Feature whose values are partly determined by values of the <code>chainingFeature</code>, as described in <code>Feature::chainingFeature</code>.</p>|



### Import

URI: https://www.omg.org/spec/KerML/20230201/shapes#Import

type: Shape

target class: [kerml_vocab:Import](https://www.omg.org/spec/KerML/20230201/vocab#Import)

definition of vocabulary class : <p>An Import is an Relationship between its <code>importOwningNamespace</code> and either a Membership (for a MembershipImport) or another Namespace (for a NamespaceImport), which determines a set of Memberships that become <code>importedMemberships</code> of the <code>importOwningNamespace</code>. If <code>isImportAll = false</code> (the default), then only public Memberships are considered &quot;visible&quot;. If <code>isImportAll = true</code>, then all Memberships are considered &quot;visible&quot;, regardless of their declared <code>visibility</code>. If <code>isRecursive = true</code>, then visible Memberships are also recursively imported from owned sub-Namespaces.</p><br><br>

description: <p>An Import is an Relationship between its <code>importOwningNamespace</code> and either a Membership (for a MembershipImport) or another Namespace (for a NamespaceImport), which determines a set of Memberships that become <code>importedMemberships</code> of the <code>importOwningNamespace</code>. If <code>isImportAll = false</code> (the default), then only public Memberships are considered &quot;visible&quot;. If <code>isImportAll = true</code>, then all Memberships are considered &quot;visible&quot;, regardless of their declared <code>visibility</code>. If <code>isRecursive = true</code>, then visible Memberships are also recursively imported from owned sub-Namespaces.</p><br><br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:importVisibility](https://www.omg.org/spec/KerML/20230201/vocab#importVisibility)| [1]| String| <p>The visibility level of the imported <code>members</code> from this Import relative to the <code>importOwningNamespace</code>.</p><br>| <p>The visibility level of the imported <code>members</code> from this Import relative to the <code>importOwningNamespace</code>.</p><br>|
| [kerml_vocab:importIsRecursive](https://www.omg.org/spec/KerML/20230201/vocab#importIsRecursive)| [1]| Boolean| <p>Whether to recursively import Memberships from visible, owned sub-Namespaces.</p>| <p>Whether to recursively import Memberships from visible, owned sub-Namespaces.</p>|
| [kerml_vocab:importIsImportAll](https://www.omg.org/spec/KerML/20230201/vocab#importIsImportAll)| [1]| Boolean| <p>Whether to import memberships without regard to declared visibility.</p><br>| <p>Whether to import memberships without regard to declared visibility.</p><br>|
| [kerml_vocab:importImportedElement](https://www.omg.org/spec/KerML/20230201/vocab#importImportedElement)| [1]| [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)| <p>The effectively imported Element for this Import. For a MembershipImport, this is the <code>memberElement</code> of the <code>importedMembership</code>. For a NamespaceImport, it is the <code>importedNamespace</code>.</p>| <p>The effectively imported Element for this Import. For a MembershipImport, this is the <code>memberElement</code> of the <code>importedMembership</code>. For a NamespaceImport, it is the <code>importedNamespace</code>.</p>|
| [kerml_vocab:importImportOwningNamespace](https://www.omg.org/spec/KerML/20230201/vocab#importImportOwningNamespace)| [1]| [kerml_vocab:Namespace](https://www.omg.org/spec/KerML/20230201/vocab#Namespace)| <p>The Namespace into which Memberships are imported by this Import, which must be the <code>owningRelatedElement</code> of the Import.</p> <br>| <p>The Namespace into which Memberships are imported by this Import, which must be the <code>owningRelatedElement</code> of the Import.</p> <br>|



### ItemFeature

URI: https://www.omg.org/spec/KerML/20230201/shapes#ItemFeature

type: Shape

target class: [kerml_vocab:ItemFeature](https://www.omg.org/spec/KerML/20230201/vocab#ItemFeature)

definition of vocabulary class : <p>An ItemFeature is the <code>ownedFeature</code> of an ItemFlow that identifies the things carried by the kinds of transfers that are instances of the ItemFlow. It must redefine <code><em>Transfer::item</em></code>.</p><br>ownedRedefinition.redefinedFeature-><br>    redefinesFromLibrary("Transfers::Transfer::item")

description: <p>An ItemFeature is the <code>ownedFeature</code> of an ItemFlow that identifies the things carried by the kinds of transfers that are instances of the ItemFlow. It must redefine <code><em>Transfer::item</em></code>.</p><br>ownedRedefinition.redefinedFeature-><br>    redefinesFromLibrary("Transfers::Transfer::item")

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|



### Featuring

URI: https://www.omg.org/spec/KerML/20230201/shapes#Featuring

type: Shape

target class: [kerml_vocab:Featuring](https://www.omg.org/spec/KerML/20230201/vocab#Featuring)

definition of vocabulary class : <p>Featuring is a Relationship between a Type and a Feature that is featured by that Type. Every instance in the domain of the <code>feature</code> must be classified by the <code>type</code>. This means that sequences that are classified by the <code>feature</code> must have a prefix subsequence that is classified by the <code>type</code>.</p><br><br><p>Featuring is abstract and does not commit to which of <code>feature</code> or <code>type</code> are the source or target. This commitment is made in the subclasses of Featuring, TypeFeaturing and FeatureMembership, which are directed differently.</p>

description: <p>Featuring is a Relationship between a Type and a Feature that is featured by that Type. Every instance in the domain of the <code>feature</code> must be classified by the <code>type</code>. This means that sequences that are classified by the <code>feature</code> must have a prefix subsequence that is classified by the <code>type</code>.</p><br><br><p>Featuring is abstract and does not commit to which of <code>feature</code> or <code>type</code> are the source or target. This commitment is made in the subclasses of Featuring, TypeFeaturing and FeatureMembership, which are directed differently.</p>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:featuringType](https://www.omg.org/spec/KerML/20230201/vocab#featuringType)| [1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>The Type that features the <code>featureOfType</code>.</p>| <p>The Type that features the <code>featureOfType</code>.</p>|
| [kerml_vocab:featuringFeature](https://www.omg.org/spec/KerML/20230201/vocab#featuringFeature)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature that is featured by the <code>featuringType</code>.</p>| <p>The Feature that is featured by the <code>featuringType</code>.</p>|



### Subclassification

URI: https://www.omg.org/spec/KerML/20230201/shapes#Subclassification

type: Shape

target class: [kerml_vocab:Subclassification](https://www.omg.org/spec/KerML/20230201/vocab#Subclassification)

definition of vocabulary class : <p>Subclassification is Specialization in which both the <code>specific</code> and <code>general</code> Types are Classifiers. This means all instances of the specific Classifier are also instances of the general Classifier.</p><br>

description: <p>Subclassification is Specialization in which both the <code>specific</code> and <code>general</code> Types are Classifiers. This means all instances of the specific Classifier are also instances of the general Classifier.</p><br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:subclassificationSuperclassifier](https://www.omg.org/spec/KerML/20230201/vocab#subclassificationSuperclassifier)| [1]| [kerml_vocab:Classifier](https://www.omg.org/spec/KerML/20230201/vocab#Classifier)| <p>The more general Classifier in this Subclassification.</p>| <p>The more general Classifier in this Subclassification.</p>|
| [kerml_vocab:subclassificationOwningClassifier](https://www.omg.org/spec/KerML/20230201/vocab#subclassificationOwningClassifier)| [0..1]| [kerml_vocab:Classifier](https://www.omg.org/spec/KerML/20230201/vocab#Classifier)| <p>The Classfier that owns this Subclassification relationship, which must also be its <code>subclassifier</code>.</p>| <p>The Classfier that owns this Subclassification relationship, which must also be its <code>subclassifier</code>.</p>|
| [kerml_vocab:subclassificationSubclassifier](https://www.omg.org/spec/KerML/20230201/vocab#subclassificationSubclassifier)| [1]| [kerml_vocab:Classifier](https://www.omg.org/spec/KerML/20230201/vocab#Classifier)| <p>The more specific Classifier in this Subclassification.</p>| <p>The more specific Classifier in this Subclassification.</p>|



### ParameterMembership

URI: https://www.omg.org/spec/KerML/20230201/shapes#ParameterMembership

type: Shape

target class: [kerml_vocab:ParameterMembership](https://www.omg.org/spec/KerML/20230201/vocab#ParameterMembership)

definition of vocabulary class : <p>A ParameterMembership is a FeatureMembership that identifies its <code>memberFeature</code> as a parameter, which is always owned, and must have a <code>direction</code>. A ParameterMembership must be owned by a Behavior or a Step.</p>

description: <p>A ParameterMembership is a FeatureMembership that identifies its <code>memberFeature</code> as a parameter, which is always owned, and must have a <code>direction</code>. A ParameterMembership must be owned by a Behavior or a Step.</p>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:parameterMembershipOwnedMemberParameter](https://www.omg.org/spec/KerML/20230201/vocab#parameterMembershipOwnedMemberParameter)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature that is identified as a parameter by this ParameterMembership, which is always owned by the ParameterMembership.</p><br>| <p>The Feature that is identified as a parameter by this ParameterMembership, which is always owned by the ParameterMembership.</p><br>|



### FeatureChainExpression

URI: https://www.omg.org/spec/KerML/20230201/shapes#FeatureChainExpression

type: Shape

target class: [kerml_vocab:FeatureChainExpression](https://www.omg.org/spec/KerML/20230201/vocab#FeatureChainExpression)

definition of vocabulary class : <p>A FeatureChainExpression is an OperatorExpression whose operator is <code>"."</code>, which resolves to the library Function <em><code>ControlFunctions::'.'</code></em>. It evaluates to the result of chaining the <code>result</code> Feature of its single <code>argument</code> Expression with its <code>targetFeature</code>.</p><br><br><p>The first two <code>members</code> of a FeatureChainExpression must be its single <code>argument</code> Expression and its <code>targetFeature</code>. Its only other <code>members</code> shall be those necessary to complete it as an InvocationExpression.</p>

description: <p>A FeatureChainExpression is an OperatorExpression whose operator is <code>"."</code>, which resolves to the library Function <em><code>ControlFunctions::'.'</code></em>. It evaluates to the result of chaining the <code>result</code> Feature of its single <code>argument</code> Expression with its <code>targetFeature</code>.</p><br><br><p>The first two <code>members</code> of a FeatureChainExpression must be its single <code>argument</code> Expression and its <code>targetFeature</code>. Its only other <code>members</code> shall be those necessary to complete it as an InvocationExpression.</p>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:featureChainExpressionTargetFeature](https://www.omg.org/spec/KerML/20230201/vocab#featureChainExpressionTargetFeature)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature that is accessed by this FeatureChainExpression, derived as its second <code>member</code> Feature (the first being its one <code>argument</code> Expression). This Feature must redefine the <em><code>target</code> Feature of the Function <em><code>ControlFunctions::'.'</code></em>.</p>| <p>The Feature that is accessed by this FeatureChainExpression, derived as its second <code>member</code> Feature (the first being its one <code>argument</code> Expression). This Feature must redefine the <em><code>target</code> Feature of the Function <em><code>ControlFunctions::'.'</code></em>.</p>|



### NamespaceImport

URI: https://www.omg.org/spec/KerML/20230201/shapes#NamespaceImport

type: Shape

target class: [kerml_vocab:NamespaceImport](https://www.omg.org/spec/KerML/20230201/vocab#NamespaceImport)

definition of vocabulary class : <p>A NamespaceImport is an Import that imports Memberships from its <code>importedNamespace</code> into the <code>importOwningNamespace</code>. If <code> isRecursive = false</code>, then only the visible Memberships of the <code>importOwningNamespace</code> are imported. If <code> isRecursive = true</code>, then, in addition, Memberships are recursively imported from any <code>ownedMembers</code> of the <code>importedNamespace</code> that are Namespaces.</p><br>importedElement = importedNamespace

description: <p>A NamespaceImport is an Import that imports Memberships from its <code>importedNamespace</code> into the <code>importOwningNamespace</code>. If <code> isRecursive = false</code>, then only the visible Memberships of the <code>importOwningNamespace</code> are imported. If <code> isRecursive = true</code>, then, in addition, Memberships are recursively imported from any <code>ownedMembers</code> of the <code>importedNamespace</code> that are Namespaces.</p><br>importedElement = importedNamespace

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:namespaceImportImportedNamespace](https://www.omg.org/spec/KerML/20230201/vocab#namespaceImportImportedNamespace)| [1]| [kerml_vocab:Namespace](https://www.omg.org/spec/KerML/20230201/vocab#Namespace)| <p>The Namespace whose visible Memberships are imported by this NamespaceImport.</p><br>| <p>The Namespace whose visible Memberships are imported by this NamespaceImport.</p><br>|



### ElementFilterMembership

URI: https://www.omg.org/spec/KerML/20230201/shapes#ElementFilterMembership

type: Shape

target class: [kerml_vocab:ElementFilterMembership](https://www.omg.org/spec/KerML/20230201/vocab#ElementFilterMembership)

definition of vocabulary class : <p>ElementFilterMembership is a Mambership between a Namespace and a model-level evaluable Boolean Expression, asserting that imported <code>members</code> of the Namespace should be filtered using the <code>condition</code> Expression. A general Namespace does not define any specific filtering behavior, but such behavior may be defined for various specialized kinds of Namespaces.</p><br>condition.isModelLevelEvaluable

description: <p>ElementFilterMembership is a Mambership between a Namespace and a model-level evaluable Boolean Expression, asserting that imported <code>members</code> of the Namespace should be filtered using the <code>condition</code> Expression. A general Namespace does not define any specific filtering behavior, but such behavior may be defined for various specialized kinds of Namespaces.</p><br>condition.isModelLevelEvaluable

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:elementFilterMembershipCondition](https://www.omg.org/spec/KerML/20230201/vocab#elementFilterMembershipCondition)| [1]| [kerml_vocab:Expression](https://www.omg.org/spec/KerML/20230201/vocab#Expression)| <p>The model-level evaluable Boolean Expression used to filter the <code>members</code> of the <code>membershipOwningNamespace</code> of this ElementFilterMembership.</p>| <p>The model-level evaluable Boolean Expression used to filter the <code>members</code> of the <code>membershipOwningNamespace</code> of this ElementFilterMembership.</p>|



### Specialization

URI: https://www.omg.org/spec/KerML/20230201/shapes#Specialization

type: Shape

target class: [kerml_vocab:Specialization](https://www.omg.org/spec/KerML/20230201/vocab#Specialization)

definition of vocabulary class : <p>Specialization is a Relationship between two Types that requires all instances of the <code>specific</code> type to also be instances of the <code>general</code> Type (i.e., the set of instances of the <code>specific</code> Type is a <em>subset</em> of those of the <code>general</code> Type, which might be the same set).</p><br><br>not specific.isConjugated

description: <p>Specialization is a Relationship between two Types that requires all instances of the <code>specific</code> type to also be instances of the <code>general</code> Type (i.e., the set of instances of the <code>specific</code> Type is a <em>subset</em> of those of the <code>general</code> Type, which might be the same set).</p><br><br>not specific.isConjugated

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:specializationGeneral](https://www.omg.org/spec/KerML/20230201/vocab#specializationGeneral)| [1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>A Type with a superset of all instances of the <code>specific</code> Type, which might be the same set.</p><br>| <p>A Type with a superset of all instances of the <code>specific</code> Type, which might be the same set.</p><br>|
| [kerml_vocab:specializationSpecific](https://www.omg.org/spec/KerML/20230201/vocab#specializationSpecific)| [1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>A Type with a subset of all instances of the <code>general</code> Type, which might be the same set.</p><br>| <p>A Type with a subset of all instances of the <code>general</code> Type, which might be the same set.</p><br>|
| [kerml_vocab:specializationOwningType](https://www.omg.org/spec/KerML/20230201/vocab#specializationOwningType)| [0..1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>The Type that is the <code>specific</code> Type of this Specialization and owns it as its <code>owningRelatedElement</code>.</p>| <p>The Type that is the <code>specific</code> Type of this Specialization and owns it as its <code>owningRelatedElement</code>.</p>|



### FeatureTyping

URI: https://www.omg.org/spec/KerML/20230201/shapes#FeatureTyping

type: Shape

target class: [kerml_vocab:FeatureTyping](https://www.omg.org/spec/KerML/20230201/vocab#FeatureTyping)

definition of vocabulary class : <p>FeatureTyping is Specialization in which the <code>specific</code> Type is a Feature. This means the set of instances of the (specific) <code>typedFeature</code> is a subset of the set of instances of the (general) <code>type</code>. In the simplest case, the <code>type</code> is a Classifier, whereupon the <code>typedFeature</code> subset has instances interpreted as sequences ending in things (in the modeled universe) that are instances of the Classifier.</p><br>

description: <p>FeatureTyping is Specialization in which the <code>specific</code> Type is a Feature. This means the set of instances of the (specific) <code>typedFeature</code> is a subset of the set of instances of the (general) <code>type</code>. In the simplest case, the <code>type</code> is a Classifier, whereupon the <code>typedFeature</code> subset has instances interpreted as sequences ending in things (in the modeled universe) that are instances of the Classifier.</p><br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:featureTypingTypedFeature](https://www.omg.org/spec/KerML/20230201/vocab#featureTypingTypedFeature)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature that has its Type determined by this FeatureTyping.</p>| <p>The Feature that has its Type determined by this FeatureTyping.</p>|
| [kerml_vocab:featureTypingType](https://www.omg.org/spec/KerML/20230201/vocab#featureTypingType)| [1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>The Type that is being applied by this FeatureTyping.</p><br>| <p>The Type that is being applied by this FeatureTyping.</p><br>|
| [kerml_vocab:featureTypingOwningFeature](https://www.omg.org/spec/KerML/20230201/vocab#featureTypingOwningFeature)| [0..1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature that owns this FeatureTyping (which must also be the <code>typedFeature</code>).</p>| <p>The Feature that owns this FeatureTyping (which must also be the <code>typedFeature</code>).</p>|



### NullExpression

URI: https://www.omg.org/spec/KerML/20230201/shapes#NullExpression

type: Shape

target class: [kerml_vocab:NullExpression](https://www.omg.org/spec/KerML/20230201/vocab#NullExpression)

definition of vocabulary class : <p>A NullExpression is an Expression that results in a null value. It must be typed by a <code><em>NullEvaluation</em></code> that results in an empty value.</p><br><br>specializesFromLibrary("Performances::nullEvaluations")

description: <p>A NullExpression is an Expression that results in a null value. It must be typed by a <code><em>NullEvaluation</em></code> that results in an empty value.</p><br><br>specializesFromLibrary("Performances::nullEvaluations")

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|



### Annotation

URI: https://www.omg.org/spec/KerML/20230201/shapes#Annotation

type: Shape

target class: [kerml_vocab:Annotation](https://www.omg.org/spec/KerML/20230201/vocab#Annotation)

definition of vocabulary class : <p>An Annotation is a Relationship between an AnnotatingElement and the Element that is annotated by that AnnotatingElement.</p><br>

description: <p>An Annotation is a Relationship between an AnnotatingElement and the Element that is annotated by that AnnotatingElement.</p><br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:annotationAnnotatingElement](https://www.omg.org/spec/KerML/20230201/vocab#annotationAnnotatingElement)| [1]| [kerml_vocab:AnnotatingElement](https://www.omg.org/spec/KerML/20230201/vocab#AnnotatingElement)| <p>The AnnotatingElement that annotates the <code>annotatedElement</code> of this Annotation.</p><br>| <p>The AnnotatingElement that annotates the <code>annotatedElement</code> of this Annotation.</p><br>|
| [kerml_vocab:annotationOwningAnnotatedElement](https://www.omg.org/spec/KerML/20230201/vocab#annotationOwningAnnotatedElement)| [0..1]| [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)| <p>The <code>annotatedElement</code> of this Annotation, when it is also its <code>owningRelatedElement</code>.| <p>The <code>annotatedElement</code> of this Annotation, when it is also its <code>owningRelatedElement</code>.|
| [kerml_vocab:annotationAnnotatedElement](https://www.omg.org/spec/KerML/20230201/vocab#annotationAnnotatedElement)| [1]| [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)| <p>The Element that is annotated by the <code>annotatingElement</code> of this Annotation.</p>| <p>The Element that is annotated by the <code>annotatingElement</code> of this Annotation.</p>|



### Element

URI: https://www.omg.org/spec/KerML/20230201/shapes#Element

type: Shape

target class: [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)

definition of vocabulary class : <p>An <code>Element</code> is a constituent of a model that is uniquely identified relative to all other <code>Elements</code>. It can have <code>Relationships</code> with other <code>Elements</code>. Some of these <code>Relationships</code> might imply ownership of other <code>Elements</code>, which means that if an <code>Element</code> is deleted from a model, then so are all the <code>Elements</code> that it owns.</p><br><br>ownedElement = ownedRelationship.ownedRelatedElement<br>owner = owningRelationship.owningRelatedElement<br>qualifiedName =<br>    if owningNamespace = null then null<br>    else if owningNamespace.owner = null then escapedName()<br>    else if owningNamespace.qualifiedName = null then null<br>    else owningNamespace.qualifiedName + '::' + escapedName()<br>    endif endif endif<br>documentation = ownedElement->selectByKind(Documentation)<br>ownedAnnotation = ownedRelationship->selectByKind(Annotation)-><br>    select(a | a.annotatedElement = self)<br>name = effectiveName()<br>ownedRelationship->exists(isImplied) implies isImpliedIncluded<br>isLibraryElement = libraryNamespace() <>null<br><br>shortName = effectiveShortName()

description: <p>An <code>Element</code> is a constituent of a model that is uniquely identified relative to all other <code>Elements</code>. It can have <code>Relationships</code> with other <code>Elements</code>. Some of these <code>Relationships</code> might imply ownership of other <code>Elements</code>, which means that if an <code>Element</code> is deleted from a model, then so are all the <code>Elements</code> that it owns.</p><br><br>ownedElement = ownedRelationship.ownedRelatedElement<br>owner = owningRelationship.owningRelatedElement<br>qualifiedName =<br>    if owningNamespace = null then null<br>    else if owningNamespace.owner = null then escapedName()<br>    else if owningNamespace.qualifiedName = null then null<br>    else owningNamespace.qualifiedName + '::' + escapedName()<br>    endif endif endif<br>documentation = ownedElement->selectByKind(Documentation)<br>ownedAnnotation = ownedRelationship->selectByKind(Annotation)-><br>    select(a | a.annotatedElement = self)<br>name = effectiveName()<br>ownedRelationship->exists(isImplied) implies isImpliedIncluded<br>isLibraryElement = libraryNamespace() <>null<br><br>shortName = effectiveShortName()

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [dcterms:identifier](http://purl.org/dc/terms/identifier)| [1]| String| n/a| <p>The globally unique identifier for this Element. This is intended to be set by tooling, and it must not change during the lifetime of the Element.</p>|
| [kerml_vocab:elementAliasIds](https://www.omg.org/spec/KerML/20230201/vocab#elementAliasIds)| [0..*]| String| <p>Various alternative identifiers for this Element. Generally, these will be set by tools.</p>| <p>Various alternative identifiers for this Element. Generally, these will be set by tools.</p>|
| [kerml_vocab:elementDeclaredShortName](https://www.omg.org/spec/KerML/20230201/vocab#elementDeclaredShortName)| [0..1]| String| <p>An optional alternative name for the <code>Element</code> that is intended to be shorter or in some way more succinct than its primary <code>name</code>. It may act as a modeler-specified identifier for the <code>Element</code>, though it is then the responsibility of the modeler to maintain the uniqueness of this identifier within a model or relative to some other context.</p> <br>| <p>An optional alternative name for the <code>Element</code> that is intended to be shorter or in some way more succinct than its primary <code>name</code>. It may act as a modeler-specified identifier for the <code>Element</code>, though it is then the responsibility of the modeler to maintain the uniqueness of this identifier within a model or relative to some other context.</p> <br>|
| [kerml_vocab:elementDeclaredName](https://www.omg.org/spec/KerML/20230201/vocab#elementDeclaredName)| [0..1]| String| <p>The declared name of this <code>Element</code>.</p><br>| <p>The declared name of this <code>Element</code>.</p><br>|
| [kerml_vocab:elementShortName](https://www.omg.org/spec/KerML/20230201/vocab#elementShortName)| [0..1]| String| <p>The short name to be used for this <code>Element</code> during name resolution within its <code>owningNamespace</code>. This is derived using the <code>effectiveShortName()</code> operation. By default, it is the same as the <code>declaredShortName</code>, but this is overridden for certain kinds of <code>Elements</code> to compute a <code>shortName</code> even when the <code>declaredName</code> is null.</p>| <p>The short name to be used for this <code>Element</code> during name resolution within its <code>owningNamespace</code>. This is derived using the <code>effectiveShortName()</code> operation. By default, it is the same as the <code>declaredShortName</code>, but this is overridden for certain kinds of <code>Elements</code> to compute a <code>shortName</code> even when the <code>declaredName</code> is null.</p>|
| [dcterms:title](http://purl.org/dc/terms/title)| [0..1]| String| n/a| <p>The name to be used for this <code>Element</code> during name resolution within its <code>owningNamespace</code>. This is derived using the <code>effectiveName()</code> operation. By default, it is the same as the <code>declaredName</code>, but this is overridden for certain kinds of <code>Elements</code> to compute a <code>name</code> even when the <code>declaredName</code> is null.</p>|
| [kerml_vocab:elementQualifiedName](https://www.omg.org/spec/KerML/20230201/vocab#elementQualifiedName)| [0..1]| String| <p>The full ownership-qualified name of this <code>Element</code>, represented in a form that is valid according to the KerML textual concrete syntax for qualified names (including use of unrestricted name notation and escaped characters, as necessary). The <code>qualifiedName</code> is null if this <code>Element</code> has no <code>owningNamespace</code> or if there is not a complete ownership chain of named <code>Namespaces</code> from a root <code>Namespace</code> to this <code>Element</code>.</p>| <p>The full ownership-qualified name of this <code>Element</code>, represented in a form that is valid according to the KerML textual concrete syntax for qualified names (including use of unrestricted name notation and escaped characters, as necessary). The <code>qualifiedName</code> is null if this <code>Element</code> has no <code>owningNamespace</code> or if there is not a complete ownership chain of named <code>Namespaces</code> from a root <code>Namespace</code> to this <code>Element</code>.</p>|
| [kerml_vocab:elementIsImpliedIncluded](https://www.omg.org/spec/KerML/20230201/vocab#elementIsImpliedIncluded)| [1]| Boolean| <p>Whether all necessary implied Relationships have been included in the <code>ownedRelationships</code> of this Element. This property may be true, even if there are not actually any <code>ownedRelationships</code> with <code>isImplied = true</code>, meaning that no such Relationships are actually implied for this Element. However, if it is false, then <code>ownedRelationships</code> may <em>not</em> contain any implied Relationships. That is, either <em>all</em> required implied Relationships must be included, or none of them.</p>| <p>Whether all necessary implied Relationships have been included in the <code>ownedRelationships</code> of this Element. This property may be true, even if there are not actually any <code>ownedRelationships</code> with <code>isImplied = true</code>, meaning that no such Relationships are actually implied for this Element. However, if it is false, then <code>ownedRelationships</code> may <em>not</em> contain any implied Relationships. That is, either <em>all</em> required implied Relationships must be included, or none of them.</p>|
| [kerml_vocab:elementIsLibraryElement](https://www.omg.org/spec/KerML/20230201/vocab#elementIsLibraryElement)| [1]| Boolean| <p>Whether this Element is contained in the ownership tree of a library model.</p>| <p>Whether this Element is contained in the ownership tree of a library model.</p>|
| [kerml_vocab:elementOwningMembership](https://www.omg.org/spec/KerML/20230201/vocab#elementOwningMembership)| [0..1]| [kerml_vocab:OwningMembership](https://www.omg.org/spec/KerML/20230201/vocab#OwningMembership)| <p>The <code>owningRelationship</code> of this Element, if that Relationship is a Membership.</p><br>| <p>The <code>owningRelationship</code> of this Element, if that Relationship is a Membership.</p><br>|
| [kerml_vocab:elementOwningNamespace](https://www.omg.org/spec/KerML/20230201/vocab#elementOwningNamespace)| [0..1]| [kerml_vocab:Namespace](https://www.omg.org/spec/KerML/20230201/vocab#Namespace)| <p>The Namespace that owns this Element, derived as the <code>membershipOwningNamespace</code> of the <code>owningMembership</code> of this Element, if any.</p><br>| <p>The Namespace that owns this Element, derived as the <code>membershipOwningNamespace</code> of the <code>owningMembership</code> of this Element, if any.</p><br>|
| [kerml_vocab:elementOwningRelationship](https://www.omg.org/spec/KerML/20230201/vocab#elementOwningRelationship)| [0..1]| [kerml_vocab:Relationship](https://www.omg.org/spec/KerML/20230201/vocab#Relationship)| <p>The Relationship for which this Element is an <tt>ownedRelatedElement</tt>, if any.</p><br>| <p>The Relationship for which this Element is an <tt>ownedRelatedElement</tt>, if any.</p><br>|
| [kerml_vocab:elementOwnedRelationship](https://www.omg.org/spec/KerML/20230201/vocab#elementOwnedRelationship)| [0..*]| [kerml_vocab:Relationship](https://www.omg.org/spec/KerML/20230201/vocab#Relationship)| <p>The Relationships for which this Element is the <tt>owningRelatedElement</tt>.</p>| <p>The Relationships for which this Element is the <tt>owningRelatedElement</tt>.</p>|
| [kerml_vocab:elementOwner](https://www.omg.org/spec/KerML/20230201/vocab#elementOwner)| [0..1]| [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)| <p>The owner of this Element, derived as the <code>owningRelatedElement</code> of the <code>owningRelationship</code> of this Element, if any.</p>| <p>The owner of this Element, derived as the <code>owningRelatedElement</code> of the <code>owningRelationship</code> of this Element, if any.</p>|
| [kerml_vocab:elementOwnedElement](https://www.omg.org/spec/KerML/20230201/vocab#elementOwnedElement)| [0..*]| [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)| <p>The Elements owned by this Element, derived as the <tt>ownedRelatedElements</tt> of the <tt>ownedRelationships</tt> of this Element.</p><br>| <p>The Elements owned by this Element, derived as the <tt>ownedRelatedElements</tt> of the <tt>ownedRelationships</tt> of this Element.</p><br>|
| [kerml_vocab:elementDocumentation](https://www.omg.org/spec/KerML/20230201/vocab#elementDocumentation)| [0..*]| [kerml_vocab:Documentation](https://www.omg.org/spec/KerML/20230201/vocab#Documentation)| <p>The Documentation owned by this Element.</p>| <p>The Documentation owned by this Element.</p>|
| [kerml_vocab:elementOwnedAnnotation](https://www.omg.org/spec/KerML/20230201/vocab#elementOwnedAnnotation)| [0..*]| [kerml_vocab:Annotation](https://www.omg.org/spec/KerML/20230201/vocab#Annotation)| <p>The <code>ownedRelationships</code> of this Element that are Annotations, for which this Element is the <code>annotatedElement</code>.</code>| <p>The <code>ownedRelationships</code> of this Element that are Annotations, for which this Element is the <code>annotatedElement</code>.</code>|
| [kerml_vocab:elementTextualRepresentation](https://www.omg.org/spec/KerML/20230201/vocab#elementTextualRepresentation)| [0..*]| [kerml_vocab:TextualRepresentation](https://www.omg.org/spec/KerML/20230201/vocab#TextualRepresentation)| <p>The <code>textualRepresentations</code> that annotate this Element.</p>| <p>The <code>textualRepresentations</code> that annotate this Element.</p>|



### Intersecting

URI: https://www.omg.org/spec/KerML/20230201/shapes#Intersecting

type: Shape

target class: [kerml_vocab:Intersecting](https://www.omg.org/spec/KerML/20230201/vocab#Intersecting)

definition of vocabulary class : <p>Intersecting is a Relationship that makes its <code>intersectingType</code> one of the <code>intersectingTypes</code> of its <code>typeIntersected</code>.</p>

description: <p>Intersecting is a Relationship that makes its <code>intersectingType</code> one of the <code>intersectingTypes</code> of its <code>typeIntersected</code>.</p>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:intersectingIntersectingType](https://www.omg.org/spec/KerML/20230201/vocab#intersectingIntersectingType)| [1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>Type that partly determines interpretations of <code>typeIntersected</code>, as described in <code>Type::intersectingType</code>.</p>| <p>Type that partly determines interpretations of <code>typeIntersected</code>, as described in <code>Type::intersectingType</code>.</p>|
| [kerml_vocab:intersectingTypeIntersected](https://www.omg.org/spec/KerML/20230201/vocab#intersectingTypeIntersected)| [1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>Type with interpretations partly determined by <code>intersectingType</code>, as described in <code>Type::intersectingType</code>.</p>| <p>Type with interpretations partly determined by <code>intersectingType</code>, as described in <code>Type::intersectingType</code>.</p>|



### Differencing

URI: https://www.omg.org/spec/KerML/20230201/shapes#Differencing

type: Shape

target class: [kerml_vocab:Differencing](https://www.omg.org/spec/KerML/20230201/vocab#Differencing)

definition of vocabulary class : <p>Differencing is a Relationship that makes its <code>differencingType</code> one of the <code>differencingTypes</code> of its <code>typeDifferenced</code>.</p>

description: <p>Differencing is a Relationship that makes its <code>differencingType</code> one of the <code>differencingTypes</code> of its <code>typeDifferenced</code>.</p>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:differencingDifferencingType](https://www.omg.org/spec/KerML/20230201/vocab#differencingDifferencingType)| [1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>Type that partly determines interpretations of <code>typeDifferenced</code>, as described in <code>Type::differencingType</code>.</p>| <p>Type that partly determines interpretations of <code>typeDifferenced</code>, as described in <code>Type::differencingType</code>.</p>|
| [kerml_vocab:differencingTypeDifferenced](https://www.omg.org/spec/KerML/20230201/vocab#differencingTypeDifferenced)| [1]| [kerml_vocab:Type](https://www.omg.org/spec/KerML/20230201/vocab#Type)| <p>Type with interpretations partly determined by <code>differencingType</code>, as described in <code>Type::differencingType</code>.</p>| <p>Type with interpretations partly determined by <code>differencingType</code>, as described in <code>Type::differencingType</code>.</p>|



### ItemFlow

URI: https://www.omg.org/spec/KerML/20230201/shapes#ItemFlow

type: Shape

target class: [kerml_vocab:ItemFlow](https://www.omg.org/spec/KerML/20230201/vocab#ItemFlow)

definition of vocabulary class : <p>An ItemFlow is a Step that represents the transfer of objects or values from one Feature to another. ItemFlows can take non-zero time to complete.</p><br><br><p>An ItemFlow must be typed by the Interaction <em><code>Transfer</code></em> from the Kernel Semantic Library, or a specialization of it.</p><br><br>if itemFlowEnds->isEmpty() then<br>    specializesFromLibrary("Transfers::transfers")<br>else<br>    specializesFromLibrary("Transfers::flowTransfers")<br>endif

description: <p>An ItemFlow is a Step that represents the transfer of objects or values from one Feature to another. ItemFlows can take non-zero time to complete.</p><br><br><p>An ItemFlow must be typed by the Interaction <em><code>Transfer</code></em> from the Kernel Semantic Library, or a specialization of it.</p><br><br>if itemFlowEnds->isEmpty() then<br>    specializesFromLibrary("Transfers::transfers")<br>else<br>    specializesFromLibrary("Transfers::flowTransfers")<br>endif

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:itemFlowItemType](https://www.omg.org/spec/KerML/20230201/vocab#itemFlowItemType)| [0..*]| [kerml_vocab:Classifier](https://www.omg.org/spec/KerML/20230201/vocab#Classifier)| <p>The type of  items transferred, derived as the <code>type</code> of the <code>itemFeature</code> of the ItemFlow.</p><br><br>| <p>The type of  items transferred, derived as the <code>type</code> of the <code>itemFeature</code> of the ItemFlow.</p><br><br>|
| [kerml_vocab:itemFlowTargetInputFeature](https://www.omg.org/spec/KerML/20230201/vocab#itemFlowTargetInputFeature)| [0..1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature that receives the items carried by the ItemFlow. It must be an owned <code>output</code> of the target participant of the ItemFlow.</p>| <p>The Feature that receives the items carried by the ItemFlow. It must be an owned <code>output</code> of the target participant of the ItemFlow.</p>|
| [kerml_vocab:itemFlowSourceOutputFeature](https://www.omg.org/spec/KerML/20230201/vocab#itemFlowSourceOutputFeature)| [0..1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature that provides the items carried by the ItemFlow. It must be an owned <code>output</code> of the <code>source</code> of the ItemFlow.</p><br>| <p>The Feature that provides the items carried by the ItemFlow. It must be an owned <code>output</code> of the <code>source</code> of the ItemFlow.</p><br>|
| [kerml_vocab:itemFlowItemFlowEnd](https://www.omg.org/spec/KerML/20230201/vocab#itemFlowItemFlowEnd)| [0..*]| [kerml_vocab:ItemFlowEnd](https://www.omg.org/spec/KerML/20230201/vocab#ItemFlowEnd)| <p>The <code>connectorEnds</code> of this ItemFlow that are ItemFlowEnds.</p><br>| <p>The <code>connectorEnds</code> of this ItemFlow that are ItemFlowEnds.</p><br>|
| [kerml_vocab:itemFlowItemFeature](https://www.omg.org/spec/KerML/20230201/vocab#itemFlowItemFeature)| [0..1]| [kerml_vocab:ItemFeature](https://www.omg.org/spec/KerML/20230201/vocab#ItemFeature)| <p>The Feature of the ItemFlow that is an ItemFeature.</p><br>| <p>The Feature of the ItemFlow that is an ItemFeature.</p><br>|
| [kerml_vocab:itemFlowInteraction](https://www.omg.org/spec/KerML/20230201/vocab#itemFlowInteraction)| [0..*]| [kerml_vocab:Interaction](https://www.omg.org/spec/KerML/20230201/vocab#Interaction)| <p>The Interactions that type this ItemFlow. Interactions are both Associations and Behaviors, which can type Connectors and Steps, respectively.</p>| <p>The Interactions that type this ItemFlow. Interactions are both Associations and Behaviors, which can type Connectors and Steps, respectively.</p>|



### LibraryPackage

URI: https://www.omg.org/spec/KerML/20230201/shapes#LibraryPackage

type: Shape

target class: [kerml_vocab:LibraryPackage](https://www.omg.org/spec/KerML/20230201/vocab#LibraryPackage)

definition of vocabulary class : <p>A LibraryPackage is a Package that is the container for a model library. A LibraryPackage is itself a library Element as are all Elements that are directly or indirectly contained in it.</p>

description: <p>A LibraryPackage is a Package that is the container for a model library. A LibraryPackage is itself a library Element as are all Elements that are directly or indirectly contained in it.</p>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:libraryPackageIsStandard](https://www.omg.org/spec/KerML/20230201/vocab#libraryPackageIsStandard)| [1]| Boolean| <p>Whether this LibraryPackage contains a standard library model. This should only be set to true for LibraryPackage in the standard Kernel Libraries or in normative model libraries for a language built on KerML.</p>| <p>Whether this LibraryPackage contains a standard library model. This should only be set to true for LibraryPackage in the standard Kernel Libraries or in normative model libraries for a language built on KerML.</p>|



### Redefinition

URI: https://www.omg.org/spec/KerML/20230201/shapes#Redefinition

type: Shape

target class: [kerml_vocab:Redefinition](https://www.omg.org/spec/KerML/20230201/vocab#Redefinition)

definition of vocabulary class : <p>Redefinition specializes&nbsp;Subsetting to require&nbsp;the <code>redefinedFeature</code> and the&nbsp;<code>redefiningFeature</code> to have the same values (on each instance of the domain of the <code>redefiningFeature</code>). This means any restrictions on the <code>redefiningFeature</code>, such as <code>type</code> or <code>multiplicity</code>, also apply to the <code>redefinedFeature</code> (on each instance of the <code>owningType</code> of the redefining Feature), and vice versa. The <code>redefinedFeature</code> might have&nbsp;values for instances of the <code>owningType</code> of the <code>redefiningFeature</code>, but only as instances of the <code>owningType</code> of the <code>redefinedFeature</code> that happen to also be instances of the <code>owningType</code> of the <code>redefiningFeature</code>. This is supported by the constraints inherited from&nbsp;Subsetting on the domains of the <code>redefiningFeature</code> and <code>redefinedFeature</code>. However, these constraints are narrowed for Redefinition to require the <code>owningTypes</code> of the <code>redefiningFeature</code> and <code>redefinedFeature</code> to be different and the <code>redefinedFeature</code> to&nbsp;not be imported into the <code>owningNamespace</code> of the <code>redefiningFeature</code>.&nbsp;This&nbsp;enables&nbsp;the <code>redefiningFeature</code> to have the same name as the <code>redefinedFeature</code> if desired.</p><br>

description: <p>Redefinition specializes&nbsp;Subsetting to require&nbsp;the <code>redefinedFeature</code> and the&nbsp;<code>redefiningFeature</code> to have the same values (on each instance of the domain of the <code>redefiningFeature</code>). This means any restrictions on the <code>redefiningFeature</code>, such as <code>type</code> or <code>multiplicity</code>, also apply to the <code>redefinedFeature</code> (on each instance of the <code>owningType</code> of the redefining Feature), and vice versa. The <code>redefinedFeature</code> might have&nbsp;values for instances of the <code>owningType</code> of the <code>redefiningFeature</code>, but only as instances of the <code>owningType</code> of the <code>redefinedFeature</code> that happen to also be instances of the <code>owningType</code> of the <code>redefiningFeature</code>. This is supported by the constraints inherited from&nbsp;Subsetting on the domains of the <code>redefiningFeature</code> and <code>redefinedFeature</code>. However, these constraints are narrowed for Redefinition to require the <code>owningTypes</code> of the <code>redefiningFeature</code> and <code>redefinedFeature</code> to be different and the <code>redefinedFeature</code> to&nbsp;not be imported into the <code>owningNamespace</code> of the <code>redefiningFeature</code>.&nbsp;This&nbsp;enables&nbsp;the <code>redefiningFeature</code> to have the same name as the <code>redefinedFeature</code> if desired.</p><br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:redefinitionRedefiningFeature](https://www.omg.org/spec/KerML/20230201/vocab#redefinitionRedefiningFeature)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature that is redefining the <code>redefinedFeature</code> of this Redefinition.</p><br>| <p>The Feature that is redefining the <code>redefinedFeature</code> of this Redefinition.</p><br>|
| [kerml_vocab:redefinitionRedefinedFeature](https://www.omg.org/spec/KerML/20230201/vocab#redefinitionRedefinedFeature)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature that is redefined by the <code>redefiningFeature</code> of this Redefinition.</p><br>| <p>The Feature that is redefined by the <code>redefiningFeature</code> of this Redefinition.</p><br>|



### SuccessionItemFlow

URI: https://www.omg.org/spec/KerML/20230201/shapes#SuccessionItemFlow

type: Shape

target class: [kerml_vocab:SuccessionItemFlow](https://www.omg.org/spec/KerML/20230201/vocab#SuccessionItemFlow)

definition of vocabulary class : <p>A SuccessionItemFlow is an ItemFlow that also provides temporal ordering. It classifies <em>Transfers</em> that cannot start until the source <em>Occurrence</em> has completed and that must complete before the target <em>Occurrence</em> can start.</p><br><br><p>A SuccessionItemFlow must be typed by the Interaction <em>TransferBefore</em> from the Kernel Library, or a specialization of it.</p><br><br>specializesFromLibrary("Transfers::flowTransfersBefore")

description: <p>A SuccessionItemFlow is an ItemFlow that also provides temporal ordering. It classifies <em>Transfers</em> that cannot start until the source <em>Occurrence</em> has completed and that must complete before the target <em>Occurrence</em> can start.</p><br><br><p>A SuccessionItemFlow must be typed by the Interaction <em>TransferBefore</em> from the Kernel Library, or a specialization of it.</p><br><br>specializesFromLibrary("Transfers::flowTransfersBefore")

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|



### MetadataAccessExpression

URI: https://www.omg.org/spec/KerML/20230201/shapes#MetadataAccessExpression

type: Shape

target class: [kerml_vocab:MetadataAccessExpression](https://www.omg.org/spec/KerML/20230201/vocab#MetadataAccessExpression)

definition of vocabulary class : <p>A MetadataAccessExpression is an Expression whose <code>result</code> is a sequence of instances of Metaclasses representing all the MetadataFeature annotations of the <code>referencedElement</code>. In addition, the sequence includes an instance of the reflective Metaclass corresponding to the MOF class of the <code>referencedElement</code>, with values for all the abstract syntax properties of the Element.</p><br>specializesFromLibrary("Performances::metadataAccessEvaluations")

description: <p>A MetadataAccessExpression is an Expression whose <code>result</code> is a sequence of instances of Metaclasses representing all the MetadataFeature annotations of the <code>referencedElement</code>. In addition, the sequence includes an instance of the reflective Metaclass corresponding to the MOF class of the <code>referencedElement</code>, with values for all the abstract syntax properties of the Element.</p><br>specializesFromLibrary("Performances::metadataAccessEvaluations")

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:metadataAccessExpressionReferencedElement](https://www.omg.org/spec/KerML/20230201/vocab#metadataAccessExpressionReferencedElement)| [1]| [kerml_vocab:Element](https://www.omg.org/spec/KerML/20230201/vocab#Element)| <p> The Element whose metadata is being accessed.</p>| <p> The Element whose metadata is being accessed.</p>|



### Invariant

URI: https://www.omg.org/spec/KerML/20230201/shapes#Invariant

type: Shape

target class: [kerml_vocab:Invariant](https://www.omg.org/spec/KerML/20230201/vocab#Invariant)

definition of vocabulary class : <p>An Invariant is a BooleanExpression that is asserted to have a specific Boolean result value. If <code>isNegated = false</code>, then the Invariant must subset, directly or indirectly, the BooleanExpression <em>trueEvaluations</em> from the Kernel library, meaning that the result is asserted to be true. If <code>isNegated = true</code>, then the Invariant must subset, directly or indirectly, the BooleanExpression <em>falseEvaluations</em> from the Kernel library, meaning that the result is asserted to be false.</p><br><br>if isNegated then<br>    specializesFromLibrary("Performances::falseEvaluations")<br>else<br>    specializesFromLibrary("Performances::trueEvaluations")<br>endif

description: <p>An Invariant is a BooleanExpression that is asserted to have a specific Boolean result value. If <code>isNegated = false</code>, then the Invariant must subset, directly or indirectly, the BooleanExpression <em>trueEvaluations</em> from the Kernel library, meaning that the result is asserted to be true. If <code>isNegated = true</code>, then the Invariant must subset, directly or indirectly, the BooleanExpression <em>falseEvaluations</em> from the Kernel library, meaning that the result is asserted to be false.</p><br><br>if isNegated then<br>    specializesFromLibrary("Performances::falseEvaluations")<br>else<br>    specializesFromLibrary("Performances::trueEvaluations")<br>endif

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:invariantIsNegated](https://www.omg.org/spec/KerML/20230201/vocab#invariantIsNegated)| [1]| Boolean| <p>Whether this Invariant is asserted to be false rather than true.</p>| <p>Whether this Invariant is asserted to be false rather than true.</p>|



### FeatureInverting

URI: https://www.omg.org/spec/KerML/20230201/shapes#FeatureInverting

type: Shape

target class: [kerml_vocab:FeatureInverting](https://www.omg.org/spec/KerML/20230201/vocab#FeatureInverting)

definition of vocabulary class : <p>A FeatureInverting is a Relationship between Features asserting that their interpretations (sequences) are the reverse of each other, identified as <code>featureInverted</code> and <code>invertingFeature</code>. For example, a Feature identifying each person's parents is the inverse of a Feature identifying each person's children.  A person identified as a parent of another will identify that other as one of their children.</p>

description: <p>A FeatureInverting is a Relationship between Features asserting that their interpretations (sequences) are the reverse of each other, identified as <code>featureInverted</code> and <code>invertingFeature</code>. For example, a Feature identifying each person's parents is the inverse of a Feature identifying each person's children.  A person identified as a parent of another will identify that other as one of their children.</p>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:featureInvertingFeatureInverted](https://www.omg.org/spec/KerML/20230201/vocab#featureInvertingFeatureInverted)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>Feature that is an the inverse of <code>invertingFeature</code>.</p>| <p>Feature that is an the inverse of <code>invertingFeature</code>.</p>|
| [kerml_vocab:featureInvertingInvertingFeature](https://www.omg.org/spec/KerML/20230201/vocab#featureInvertingInvertingFeature)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>Feature that is an inverse of <code>invertedFeature</code>.</p>| <p>Feature that is an inverse of <code>invertedFeature</code>.</p>|
| [kerml_vocab:featureInvertingOwningFeature](https://www.omg.org/spec/KerML/20230201/vocab#featureInvertingOwningFeature)| [0..1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>A <code>featureInverted</code> that is also an <code>owningRelatedElement<code>.</p>| <p>A <code>featureInverted</code> that is also an <code>owningRelatedElement<code>.</p>|



### Function

URI: https://www.omg.org/spec/KerML/20230201/shapes#Function

type: Shape

target class: [kerml_vocab:Function](https://www.omg.org/spec/KerML/20230201/vocab#Function)

definition of vocabulary class : <p>A Function is a Behavior that has a single <code>out</code> <code>parameter</code> that is identified as its <code>result</code>. Any other <code>parameters</code> of a Function than the <code>result</code> must have direction <code>in</code>. A Function represents the performance of a calculation that produces the values of its <code>result</code> parameter. This calculation may be decomposed into Expressions that are <code>steps</code> of the Function.</p><br><br>specializesFromLibrary("Performances::Evaluation")<br>ownedMembership.selectByKind(ResultExpressionMembership)-><br>    forAll(mem | ownedFeature.selectByKind(BindingConnector)-><br>        exists(binding |<br>            binding.relatedFeature->includes(result) and<br>            binding.relatedFeature->includes(mem.ownedResultExpression.result)))

description: <p>A Function is a Behavior that has a single <code>out</code> <code>parameter</code> that is identified as its <code>result</code>. Any other <code>parameters</code> of a Function than the <code>result</code> must have direction <code>in</code>. A Function represents the performance of a calculation that produces the values of its <code>result</code> parameter. This calculation may be decomposed into Expressions that are <code>steps</code> of the Function.</p><br><br>specializesFromLibrary("Performances::Evaluation")<br>ownedMembership.selectByKind(ResultExpressionMembership)-><br>    forAll(mem | ownedFeature.selectByKind(BindingConnector)-><br>        exists(binding |<br>            binding.relatedFeature->includes(result) and<br>            binding.relatedFeature->includes(mem.ownedResultExpression.result)))

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:functionIsModelLevelEvaluable](https://www.omg.org/spec/KerML/20230201/vocab#functionIsModelLevelEvaluable)| [1]| Boolean| <p>Whether this Function can be used as the <code>function</code> of a model-level evaluable InvocationExpression.</p>| <p>Whether this Function can be used as the <code>function</code> of a model-level evaluable InvocationExpression.</p>|
| [kerml_vocab:functionExpression](https://www.omg.org/spec/KerML/20230201/vocab#functionExpression)| [0..*]| [kerml_vocab:Expression](https://www.omg.org/spec/KerML/20230201/vocab#Expression)| <p>The Expressions that are steps in the calculation of the <code>result</code> of this Function.</p><br><br><p>The set of expressions that represent computational steps or parts of a system of equations within the Function.</p><br>| <p>The Expressions that are steps in the calculation of the <code>result</code> of this Function.</p><br><br><p>The set of expressions that represent computational steps or parts of a system of equations within the Function.</p><br>|
| [kerml_vocab:functionResult](https://www.omg.org/spec/KerML/20230201/vocab#functionResult)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The <code>result</code> parameter of the Function, derived as the single <code>parameter</code> of the Function with direction <code>out</code>.</p><br><br><p>The object or value that is the result of evaluating the Function.</p>| <p>The <code>result</code> parameter of the Function, derived as the single <code>parameter</code> of the Function with direction <code>out</code>.</p><br><br><p>The object or value that is the result of evaluating the Function.</p>|



### ReturnParameterMembership

URI: https://www.omg.org/spec/KerML/20230201/shapes#ReturnParameterMembership

type: Shape

target class: [kerml_vocab:ReturnParameterMembership](https://www.omg.org/spec/KerML/20230201/vocab#ReturnParameterMembership)

definition of vocabulary class : <p>A ReturnParameterMembership is a ParameterMembership that indicates that the <code>memberParameter</code> is the <code>result</code> parameter of a Function or Expression. The <code>direction</code> of the <code>memberParameter</code> must be <code>out</code>.</p>

description: <p>A ReturnParameterMembership is a ParameterMembership that indicates that the <code>memberParameter</code> is the <code>result</code> parameter of a Function or Expression. The <code>direction</code> of the <code>memberParameter</code> must be <code>out</code>.</p>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|



### ItemFlowEnd

URI: https://www.omg.org/spec/KerML/20230201/shapes#ItemFlowEnd

type: Shape

target class: [kerml_vocab:ItemFlowEnd](https://www.omg.org/spec/KerML/20230201/vocab#ItemFlowEnd)

definition of vocabulary class : <p>An ItemFlowEnd is a Feature that is one of the <code>endFeatures</code> giving the <code><em>source</em></code> or <code><em>target</em></code> of an ItemFlow. For ItemFlows typed by FlowTransfer or its specializations, ItemFlowEnds must have exactly one <code>ownedFeature</code>, which redefines <code><em>Transfer::source::sourceOutput</em></code> or <code><em>Transfer::target::targetInput</em></code> and redefines the corresponding feature of the <code>relatedElement</code> for its end.</p>

description: <p>An ItemFlowEnd is a Feature that is one of the <code>endFeatures</code> giving the <code><em>source</em></code> or <code><em>target</em></code> of an ItemFlow. For ItemFlows typed by FlowTransfer or its specializations, ItemFlowEnds must have exactly one <code>ownedFeature</code>, which redefines <code><em>Transfer::source::sourceOutput</em></code> or <code><em>Transfer::target::targetInput</em></code> and redefines the corresponding feature of the <code>relatedElement</code> for its end.</p>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|



### OperatorExpression

URI: https://www.omg.org/spec/KerML/20230201/shapes#OperatorExpression

type: Shape

target class: [kerml_vocab:OperatorExpression](https://www.omg.org/spec/KerML/20230201/vocab#OperatorExpression)

definition of vocabulary class : <p>An OperatorExpression is an InvocationExpression whose <code>function</code> is determined by resolving its <code>operator</code> in the context of one of the standard Function packages from the Kernel Model Library.</p><br>let libFunctions : Sequence(Element) = <br>    Sequence{"BaseFunctions", "DataFunctions", "ControlFunctions"}-><br>    collect(ns | resolveGlobal(ns + "::'" + operator + "'")) in<br>libFunctions->includes(function)<br>    <br>

description: <p>An OperatorExpression is an InvocationExpression whose <code>function</code> is determined by resolving its <code>operator</code> in the context of one of the standard Function packages from the Kernel Model Library.</p><br>let libFunctions : Sequence(Element) = <br>    Sequence{"BaseFunctions", "DataFunctions", "ControlFunctions"}-><br>    collect(ns | resolveGlobal(ns + "::'" + operator + "'")) in<br>libFunctions->includes(function)<br>    <br>

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:operatorExpressionOperator](https://www.omg.org/spec/KerML/20230201/vocab#operatorExpressionOperator)| [1]| String| <p>An operator symbol that names a corresponding Function from one of the standard Function packages from the Kernel Model Library .</p>| <p>An operator symbol that names a corresponding Function from one of the standard Function packages from the Kernel Model Library .</p>|
| [kerml_vocab:operatorExpressionOperand](https://www.omg.org/spec/KerML/20230201/vocab#operatorExpressionOperand)| [0..*]| [kerml_vocab:Expression](https://www.omg.org/spec/KerML/20230201/vocab#Expression)| n/a| n/a|



### FeatureValue

URI: https://www.omg.org/spec/KerML/20230201/shapes#FeatureValue

type: Shape

target class: [kerml_vocab:FeatureValue](https://www.omg.org/spec/KerML/20230201/vocab#FeatureValue)

definition of vocabulary class : <p>A FeatureValue is a Membership that identifies a particular member Expression that provides the value of the Feature that owns the FeatureValue. The value is specified as either a bound value or an initial value, and as either a concrete or default value. A Feature can have at most one FeatureValue.</p><br><br><p>The result of the <code>value</code> expression is bound to the <code>featureWithValue</code> using a BindingConnector. If <code>isInitial = false</code>, then the <code>featuringType</code> of the BindingConnector is the same as the <code>featuringType</code> of the <code>featureWithValue</code>. If <code>isInitial = true</code>, then the <code>featuringType</code> of the BindingConnector is restricted to its <code>startShot</code>.<br><br><p>If <code>isDefault = false</code>, then the above semantics of the FeatureValue are realized for the given <code>featureWithValue</code>. Otherwise, the semantics are realized for any individual of the <code>featuringType</code> of the <code>featureWithValue</code>, unless another value is explicitly given for the <code>featureWithValue</code> for that individual.</p><br><br>not isDefault implies<br>    featureWithValue.ownedMember-><br>        selectByKind(BindingConnector)->exists(b |<br>            b.relatedFeature->includes(featureWithValue) and<br>            b.relatedFeature->includes(value.result) and<br>            if not isInitial then <br>                b.featuringType = featureWithValue.featuringType<br>            else <br>                b.featuringType->exists(t |<br>                    t.oclIsKindOf(Feature) and<br>                    t.oclAsType(Feature).chainingFeature =<br>                        Sequence{<br>                            resolveGlobal("Base::things::that"),<br>                            resolveGlobal("Occurrences::Occurrence::startShot")<br>                        }<br>                )<br>            endif)

description: <p>A FeatureValue is a Membership that identifies a particular member Expression that provides the value of the Feature that owns the FeatureValue. The value is specified as either a bound value or an initial value, and as either a concrete or default value. A Feature can have at most one FeatureValue.</p><br><br><p>The result of the <code>value</code> expression is bound to the <code>featureWithValue</code> using a BindingConnector. If <code>isInitial = false</code>, then the <code>featuringType</code> of the BindingConnector is the same as the <code>featuringType</code> of the <code>featureWithValue</code>. If <code>isInitial = true</code>, then the <code>featuringType</code> of the BindingConnector is restricted to its <code>startShot</code>.<br><br><p>If <code>isDefault = false</code>, then the above semantics of the FeatureValue are realized for the given <code>featureWithValue</code>. Otherwise, the semantics are realized for any individual of the <code>featuringType</code> of the <code>featureWithValue</code>, unless another value is explicitly given for the <code>featureWithValue</code> for that individual.</p><br><br>not isDefault implies<br>    featureWithValue.ownedMember-><br>        selectByKind(BindingConnector)->exists(b |<br>            b.relatedFeature->includes(featureWithValue) and<br>            b.relatedFeature->includes(value.result) and<br>            if not isInitial then <br>                b.featuringType = featureWithValue.featuringType<br>            else <br>                b.featuringType->exists(t |<br>                    t.oclIsKindOf(Feature) and<br>                    t.oclAsType(Feature).chainingFeature =<br>                        Sequence{<br>                            resolveGlobal("Base::things::that"),<br>                            resolveGlobal("Occurrences::Occurrence::startShot")<br>                        }<br>                )<br>            endif)

| Prefixed Name | Cardinality | Value-type | Definition of Vocabulary Property | Definition |
|:-------|:--------|:---------|:-----------|:-----------|
| [kerml_vocab:featureValueIsInitial](https://www.omg.org/spec/KerML/20230201/vocab#featureValueIsInitial)| [1]| Boolean| <p>Whether this FeatureValue specifies a bound value or an initial value for the <code>featureWithValue</code>.</p>| <p>Whether this FeatureValue specifies a bound value or an initial value for the <code>featureWithValue</code>.</p>|
| [kerml_vocab:featureValueIsDefault](https://www.omg.org/spec/KerML/20230201/vocab#featureValueIsDefault)| [1]| Boolean| <p>Whether this FeatureValue is a concrete specification of the bound of initial value of the <code>featureWithValue</code>, or just a default value that may be overridden.</p>| <p>Whether this FeatureValue is a concrete specification of the bound of initial value of the <code>featureWithValue</code>, or just a default value that may be overridden.</p>|
| [kerml_vocab:featureValueFeatureWithValue](https://www.omg.org/spec/KerML/20230201/vocab#featureValueFeatureWithValue)| [1]| [kerml_vocab:Feature](https://www.omg.org/spec/KerML/20230201/vocab#Feature)| <p>The Feature to be provided a value.</p><br><br><p>The Feature to be provided a value.</p>| <p>The Feature to be provided a value.</p><br><br><p>The Feature to be provided a value.</p>|
| [kerml_vocab:featureValueValue](https://www.omg.org/spec/KerML/20230201/vocab#featureValueValue)| [1]| [kerml_vocab:Expression](https://www.omg.org/spec/KerML/20230201/vocab#Expression)| <p>The Expression that provides the value of the <code>featureWithValue</code> as its <code>result</code>.</p><br><br><p>The Expression that provides the value as a result.</p>| <p>The Expression that provides the value of the <code>featureWithValue</code> as its <code>result</code>.</p><br><br><p>The Expression that provides the value as a result.</p>|




